/*
 *-----------------------------------------------------------------
 *
 * Name:	nfx-target.h
 *
 * RCS:  $Id: nfx-target.h,v 1.53 2002/11/23 19:07:33 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	Target dependant definitions
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/7/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _NFX_TARGET_H
#define _NFX_TARGET_H

#define _SB1250_PASS1_WORKAROUNDS_

#if defined(EVAL_BOARD) || defined(AGILE_HARDWARE)

#define STKSIZE		0x3000

#endif

#ifdef LINUX_TEST

#define LINUX_POLL_NONBLOCKING_FD	/* */

#endif

#define USE_TEMP_EXT_MAC_ADDR_SCHEME		/* get mac addr from ip addr */

#define USE_NEW_BACKPLANE		/* use bp_init() */

#ifndef PROM
#define EXCEPTIONS_IN_KSEG0
/*#define TIMER_TIC_INT*/
#endif
#define USE_WATCHDOG

#if defined(FCNIM) || defined(FCNIM_TM)
#define FC_USE_NEW_MEM_MAP		/* for supporting > 256 MB */
#endif

/*------------------------------------------------------------------*
 *
 *  Global definitions
 *
 *------------------------------------------------------------------*/

/*#define EEE_ATTR*/

#define FIX_HDR_STUFF
#define NO_GMC_APP_NO_TX

#define FIX_SSC_MSG

#define NFX_SOCKET_BACKPLANE	0

#define USE_DP_PROXY

#define MALLOC_ALIGNED_SIZE		32

/* for new SBM code */
#define SBM_REV2
#define SBM_REV_2

/*
 * RAL - there is no GMC, so remove the emulator function from the system.
 *      This should remove the SBM <-> GMC queues and related polling functions.
 */
#define SBM_REMOVE_GMC

/*
 * For calculating/storing/validating user data COD CRC in SAC, turn this on
 */
/* #define USE_SAC_CHECKSUM */

/*------------------------------------------------------------------*/
/*------------------------------------------------------------------*/

/*------------------------------------------------------------------*
 *  Target specific definitions - NFP
 *------------------------------------------------------------------*/
#ifdef NFX_MOD_NFP

#define NFX_MOD_NUM_CPUS	NFX_NFP_NUM_CPUS

#ifdef MALLOC_ALIGNED_SIZE
#undef MALLOC_ALIGNED_SIZE
#define MALLOC_ALIGNED_SIZE		64 /* for the sibyte mac */
#endif

#if defined(LARGE_MEMORY) && defined(NFP_FP)
/* define USE_THREAD_STACKS for debug, it provides TLB
 * protection for stack overflow
 */
#define USE_THREAD_STACKS
/* define USE_BSS_THREAD_STACKS for better performance */
//#define USE_BSS_THREAD_STACKS
#endif

#ifdef NFX_SMP
#define TIMER_USE_SB1250_TIMER
#endif

#endif	/* NFX_NFP */

/*------------------------------------------------------------------*
 *  Target specific definitions - FCNIM
 *------------------------------------------------------------------*/
#ifdef NFX_MOD_FCNIM

#define NFX_MOD_NUM_CPUS	NFX_FCNIM_NUM_CPUS

#define FLOATINGPT
#define NEWFP

#endif	/* NFX_FCNIM */

/*------------------------------------------------------------------*
 *  Target specific definitions - SSC
 *------------------------------------------------------------------*/
#ifdef NFX_MOD_SSC

#define NFX_MOD_NUM_CPUS	NFX_SSC_NUM_CPUS

#define FLOATINGPT
#define NEWFP

#endif	/* NFX_SSC */

/*------------------------------------------------------------------*
 *  Target specific definitions - LINUX TEST
 *------------------------------------------------------------------*/
#ifdef NFX_MOD_LINUX_TEST

#define NFX_MOD_NUM_CPUS	NFX_LINUX_NUM_CPUS

#endif	/* LINUX_TEST */

/*------------------------------------------------------------------*
 *  Target specific definitions - PROM_R7000 or PROM_R9000
 *------------------------------------------------------------------*/
#if defined(PROM_R7000) || defined(PROM_R9000)


#define NFX_MOD_NUM_CPUS	1

#define USE_DECOMPRESS
#undef USE_NSDB

#define PMON
#define IN_PMON
#define TLBREGISTERS
#ifndef PROM_R9000
#define PROM_DEBUG
#endif
#define FLOATINGPT
#define NEWFP
#undef USE_DIAG_LED

#ifdef PROM_R9000
#define FEATURE_AUTOLOAD_RUNTIME
#endif
#endif	/* PROM_R7000 */

/*------------------------------------------------------------------*
 *  Target specific definitions - PROM_SIBYTE_BC
 *------------------------------------------------------------------*/
#ifdef PROM_SIBYTE_BC
#define PROM_SIBYTE
#define FEATURE_AUTOLOAD_RUNTIME
#endif

/*------------------------------------------------------------------*
 *  Target specific definitions - PROM_SIBYTE
 *------------------------------------------------------------------*/
#ifdef PROM_SIBYTE

/* #define SB1250_SIMULATOR */

#define NFX_MOD_NUM_CPUS	1

#define USE_DECOMPRESS
#undef USE_NSDB

#define PMON
#define IN_PMON
#define TLBREGISTERS
#define PROM_DEBUG
#define FLOATINGPT
#define NEWFP

#endif	/* PROM_SIBYTE */

/*------------------------------------------------------------------*
 *  Target specific definitions - PROM_SSC_MGMT
 *------------------------------------------------------------------*/
#ifdef PROM_SSC_MGMT

#define NFX_MOD_NUM_CPUS	1

#define PMON
#define IN_PMON
#define TLBREGISTERS
#define PROM_DEBUG

#undef USE_NSDB

#endif	/* PROM_SSC_MGMT */

/*------------------------------------------------------------------*
 *  Target specific definitions - DIAG_R7000
 *------------------------------------------------------------------*/
#ifdef DIAG_R7000
#define PROM_R7000

#define NFX_MOD_NUM_CPUS	1

#define USE_DECOMPRESS

#define PMON
#define IN_PMON
#define TLBREGISTERS
#define PROM_DEBUG
#define FLOATINGPT
#define NEWFP
#define REF_FREQ		100
#undef USE_DIAG_LED

#define FEATURE_DIAG_PROM 	1	
#endif

/*------------------------------------------------------------------*
 *  Target specific definitions - DIAG_SIBYTE
 *------------------------------------------------------------------*/
#ifdef DIAG_SIBYTE
#define PROM_SIBYTE

#define NFX_MOD_NUM_CPUS	1

#define USE_DECOMPRESS

#define PMON
#define IN_PMON
#define TLBREGISTERS
#define PROM_DEBUG
#define FLOATINGPT
#define NEWFP

/* Control Flag for bmc12500 diag loopback packets */
#define FEATURE_DIAG_PROM 	1	

#endif
#endif	/* _NFX_TARGET_H */

