/*
 *-----------------------------------------------------------------
 *
 * Name:        r9k-regs.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description: Internal OCD registers definition file for RM9000 
 *              from PMC.
 *
 * Created by:  Shaun Hui
 *
 * Date Created: 06/23/04
 *
 *-----------------------------------------------------------------
 */
                                                                                
#define R9K_OCDINFO		0x0000
#define R9K_XCAUFL		0x0010
#define R9K_XCAUFA0		0x0014
#define R9K_XCAUFA1		0x0018
#define R9K_XCPUEBLFL	0x0020
#define R9K_XCPUEBLFA0	0x0024
#define R9K_XCPUEBLFA1	0x0028
#define R9K_LBK0_HI		0x0038

#define R9K_XCPUEBLFA0_CSEWEN	(1 << 11)	/* CPU-SDRAM Wr Err ena */
#define R9K_XCPUEBLFA0_CAREN	(1 << 10)	/* CPU-Any Rd Err ena */

/*
 * extended cause SDRAM ECC Status/Control Register
 */
#define R9K_XECC		0x0060
#define R9K_XECC_MECC	(1 << 3)	/* Multi-bit ECC Error */
#define R9K_XECC_SECC	(1 << 2)	/* Single-bit ECC Error */

#define R9K_XCPUWAEAL	0x0070
#define R9K_XCPUWAEAH	0x0074
#define R9K_UPENR		0x00F0
#define R9K_CPURSLMT	0x00F8
#define R9K_SMCTRL		0x00FC

#define R9K_LKB0		0x0100
#define R9K_LKM0		0x0104
#define R9K_LKB1		0x0108
#define R9K_LKM1		0x010C
#define R9K_LKB2		0x0110
#define R9K_LKM2		0x0114
#define R9K_LKB3		0x0118
#define R9K_LKM3		0x011C
#define R9K_LKB4		0x0120
#define R9K_LKM4		0x0124
#define R9K_LKB5		0x0128
#define R9K_LKM5		0x012C
#define R9K_LKB6		0x0130
#define R9K_LKM6		0x0134
#define R9K_LKB7		0x0138
#define R9K_LKM7		0x013C
#define R9K_LKB8		0x0140
#define R9K_LKM8		0x0144
#define R9K_LKB9		0x0148
#define R9K_LKM9		0x014C
#define R9K_LKB10		0x0150
#define R9K_LKM10		0x0154
#define R9K_LKB11		0x0158
#define R9K_LKM11		0x015C
#define R9K_LKB12		0x0160
#define R9K_LKM12		0x0164
#define R9K_LKB13		0x0168
#define R9K_LKM13		0x016C

#define R9K_LKM1_4_SIZE_16M		(0x00fff << 8)	/* LKM 1-4 size mask 16M */
#define R9K_LKM1_4_SIZE_32M		(0x01fff << 8)	/* LKM 1-4 size mask 32M */
#define R9K_LKM1_4_SIZE_64M		(0x03fff << 8)	/* LKM 1-4 size mask 64M */
#define R9K_LKM1_4_SIZE_128M	(0x07fff << 8)	/* LKM 1-4 size mask 128M */
#define R9K_LKM1_4_SIZE_256M	(0x0ffff << 8)	/* LKM 1-4 size mask 256M */
#define R9K_LKM1_4_SIZE_512M	(0x1ffff << 8)	/* LKM 1-4 size mask 512M */
#define R9K_LKM1_4_SIZE_1G		(0x3ffff << 8)	/* LKM 1-4 size mask 1G */

#define R9K_LKM_SIZE_4K		(0x000000 << 8)	/* LKM size mask  4K */
#define R9K_LKM_SIZE_8K		(0x000001 << 8)	/* LKM size mask  8K */
#define R9K_LKM_SIZE_16K	(0x000003 << 8)	/* LKM size mask  16K */
#define R9K_LKM_SIZE_32K	(0x000007 << 8)	/* LKM size mask  32K */
#define R9K_LKM_SIZE_64K	(0x00000F << 8)	/* LKM size mask  64K */
#define R9K_LKM_SIZE_128K	(0x00001F << 8)	/* LKM size mask 128K */
#define R9K_LKM_SIZE_256K	(0x00003F << 8)	/* LKM size mask 256K */
#define R9K_LKM_SIZE_512K	(0x00007F << 8)	/* LKM size mask 512K */
#define R9K_LKM_SIZE_1M		(0x0000FF << 8)	/* LKM size mask   1M */
#define R9K_LKM_SIZE_2M		(0x0001FF << 8)	/* LKM size mask   2M */
#define R9K_LKM_SIZE_4M		(0x0003FF << 8)	/* LKM size mask   4M */
#define R9K_LKM_SIZE_8M		(0x0007FF << 8)	/* LKM size mask   8M */
#define R9K_LKM_SIZE_16M	(0x000FFF << 8)	/* LKM size mask  16M */
#define R9K_LKM_SIZE_32M	(0x001FFF << 8)	/* LKM size mask  32M */
#define R9K_LKM_SIZE_64M	(0x003FFF << 8)	/* LKM size mask  64M */
#define R9K_LKM_SIZE_128M	(0x007FFF << 8)	/* LKM size mask 128M */
#define R9K_LKM_SIZE_256M	(0x00FFFF << 8)	/* LKM size mask 128M */
#define R9K_LKM_SIZE_512M	(0x01FFFF << 8)	/* LKM size mask 512M */
#define R9K_LKM_SIZE_1G		(0x03FFFF << 8)	/* LKM size mask 1G */
#define R9K_LKM_SIZE_2G		(0x07FFFF << 8)	/* LKM size mask 2G */
#define R9K_LKM_SIZE_4G		(0x0FFFFF << 8)	/* LKM size mask 4G */
#define R9K_LKM_SIZE_8G		(0x1FFFFF << 8)	/* LKM size mask 8G */
#define R9K_LKM_SIZE_16G	(0x3FFFFF << 8)	/* LKM size mask 16G */
#define R9K_LKM_SIZE_32G	(0x7FFFFF << 8)	/* LKM size mask 32G */


#define R9K_LKB_ENABLE 			(1 << 0)		/* Region enable */

#define R9K_LDP0		0x0200
#define R9K_LDP1		0x0210
#define R9K_LDP2		0x0220
#define R9K_LDP3		0x0230

#define R9K_SDCFG		0x0300
#define R9K_SDMW		0x0304
#define R9K_SDWEAL		0x0310
#define R9K_SDWEAH		0x0314
#define R9K_SDEAL		0x0320
#define R9K_SDEAH		0x0324
#define R9K_SDM0		0x0340
#define R9K_SDT0		0x0344
#define R9K_SDM1		0x0350
#define R9K_SDT1		0x0354
#define R9K_SDM2		0x0360
#define R9K_SDT2		0x0364
#define R9K_SDM3		0x0370
#define R9K_SDT3		0x0374
#define R9K_SDECBIA		0x0378
#define R9K_SDECBID		0x037C

/*------------------------------------
 * Bit definitions for SDCFG Registers
 *------------------------------------
 */
#define R9K_SDC_CLKDSC_CL1_WEAK		(0 << 0)	/* ClkDSC, Class 1 weak */
#define R9K_SDC_CLKDSC_CL1_STRONG	(1 << 0)	/* ClkDSC, Class 1 strong */
#define R9K_SDC_CLKDSC_CL2_WEAK		(2 << 0)	/* ClkDSC, Class 2 weak */
#define R9K_SDC_CLKDSC_CL2_STRONG	(3 << 0)	/* ClkDSC, Class 2 strong */
#define R9K_SDC_CLKSRC_SLOW			(0 << 2)	/* Clk Slew Rate Control */
#define R9K_SDC_CLKSRC_FAST			(1 << 2)	/* Clk Slew Rate Control */
#define R9K_SDC_DATADSC_CL1_WEAK	(0 << 3)	/* DataDSC, Class 1 weak */
#define R9K_SDC_DATADSC_CL1_STRONG	(1 << 3)	/* DataDSC, Class 1 strong */
#define R9K_SDC_DATADSC_CL2_WEAK	(2 << 3)	/* DataDSC, Class 2 weak */
#define R9K_SDC_DATADSC_CL2_STRONG	(3 << 3)	/* DataDSC, Class 2 strong */
#define R9K_SDC_DATASRC_SLOW		(0 << 5)	/* Data Slew Rate Control */
#define R9K_SDC_DATASRC_FAST		(1 << 5)	/* Data Slew Rate Control */
#define R9K_SDC_CHKDSC_CL1_WEAK		(0 << 6)	/* ChkDSC, Class 1 weak */
#define R9K_SDC_CHKDSC_CL1_STRONG	(1 << 6)	/* ChkDSC, Class 1 strong */
#define R9K_SDC_CHKDSC_CL2_WEAK		(2 << 6)	/* ChkDSC, Class 2 weak */
#define R9K_SDC_CHKDSC_CL2_STRONG	(3 << 6)	/* ChkDSC, Class 2 strong */
#define R9K_SDC_CHKSRC_SLOW			(0 << 8)	/* Chk Slew Rate Control */
#define R9K_SDC_CHKSRC_FAST			(1 << 8)	/* Chk Slew Rate Control */
#define R9K_SDC_CMDDSC_CL1_WEAK		(0 << 9)	/* CmdDSC, Class 1 weak */
#define R9K_SDC_CMDDSC_CL1_STRONG	(1 << 9)	/* CmdDSC, Class 1 strong */
#define R9K_SDC_CMDDSC_CL2_WEAK		(2 << 9)	/* CmdDSC, Class 2 weak */
#define R9K_SDC_CMDDSC_CL2_STRONG	(3 << 9)	/* CmdDSC, Class 2 strong */
#define R9K_SDC_CMDSRC_SLOW			(0 << 11)	/* Cmd Slew Rate Control */
#define R9K_SDC_CMDSRC_FAST			(1 << 11)	/* Cmd Slew Rate Control */
#define R9K_SDC_ADD_EXTRA_DELAY		(1 << 13)	/* Add extra delay */
#define R9K_SDC_ECC_ENABLE			(0 << 16)	/* ECC mode enabled */
#define R9K_SDC_ECC_DISABLE			(3 << 16)	/* ECC mode disabled */
#define R9K_SDC_PWR_DOWN_DIS		(0 << 20)	/* power down mode disabled */
#define R9K_SDC_PWR_DOWN_ENA		(1 << 20)	/* power down mode enabled */

/*------------------------------------
 * SDRAM Mode Register Write Bits.
 *------------------------------------
 */
#define R9K_SDMW_EXT_RANK_0		(0 << 0)	/* external rank 0 */
#define R9K_SDMW_EXT_RANK_1		(1 << 0)	/* external rank 1 */
#define R9K_SDMW_EXT_RANK_2		(2 << 0)	/* external rank 2 */
#define R9K_SDMW_EXT_RANK_3		(3 << 0)	/* external rank 3 */
#define R9K_SDMW_DLL_ENABLE		(0 << 4)	/* DLL enable */
#define R9K_SDMW_DLL_DISABLE	(1 << 4)	/* DLL disable */
#define R9K_SDMW_DS_NORMAL		(0 << 5)	/* Drive strength normal */
#define R9K_SDMW_DS_REDUCED		(1 << 5)	/* Drive strength reduced */
#define R9K_SDMW_QFC_DISABLE	(0 << 6)	/* QFC disable */
#define R9K_SDMW_QFC_ENABLE		(1 << 6)	/* QFC enable */

/*------------------------------------
 * Bit definitions for SDMx Registers 
 *------------------------------------
 */
#define R9K_SDM_RANK_ENA		(1 << 0)	/* Rank enable */
#define R9K_SDM_ECC_CHK_ENA		(1 << 1)	/* ECC checking enable */
#define R9K_SDM_UNREG_DIMM		(0 << 2)	/* unregistered dimm type */
#define R9K_SDM_REG_DIMM		(1 << 2)	/* registered dimm type */
#define R9K_SDM_DENSITY_64M		(0 << 4)	/* Mem. density  64 M */
#define R9K_SDM_DENSITY_128M	(1 << 4)	/* Mem. density 128 M */
#define R9K_SDM_DENSITY_256M	(2 << 4)	/* Mem. density 256 M */
#define R9K_SDM_DENSITY_512M	(3 << 4)	/* Mem. density 512 M */
#define R9K_SDM_DENSITY_1G  	(4 << 4)	/* Mem. density   1 G */
#define R9K_SDM_WIDTH_8_BITS 	(0 << 8)	/* Mem. width  8 bits */
#define R9K_SDM_WIDTH_16_BITS 	(1 << 8)	/* Mem. width 16 bits */
#define R9K_SDM_WIDTH_32_BITS 	(2 << 8)	/* Mem. width 32 bits */
#define R9K_SDM_TYPE_SDRAM 		(0 << 13)	/* Mem. type SDRAM */

/*------------------------------------
 * Bit definitions for SDTx Registers 
 *------------------------------------
 */
#define R9K_SDT_TCAC_2		(0 << 0)	/* CAS Latency, 2 cycles */
#define R9K_SDT_TCAC_2_5	(1 << 0)	/* CAS Latency, 2.5 cycles */
#define R9K_SDT_TCAC_3  	(2 << 0)	/* CAS Latency, 3 cycles */
#define R9K_SDT_TCAC_4  	(3 << 0)	/* CAS Latency, 4 cycles */
#define R9K_SDT_TRCD_2		(0 << 7)	/* RAS to CAS delay, 2 cycles */
#define R9K_SDT_TRCD_3		(1 << 7)	/* RAS to CAS delay, 3 cycles */
#define R9K_SDT_TRCD_4		(2 << 7)	/* RAS to CAS delay, 4 cycles */
#define R9K_SDT_TRP_2		(0 << 10)	/* Precharge delay, 2 cycles */
#define R9K_SDT_TRP_3		(1 << 10)	/* Precharge delay, 3 cycles */
#define R9K_SDT_TRP_4		(2 << 10)	/* Precharge delay, 4 cycles */
#define R9K_SDT_TRC_7		(7 << 12)	/* Refresh Recovery , 7 cycles */
#define R9K_SDT_TRC_8		(8 << 12)	/* Refresh Recovery , 8 cycles */
#define R9K_SDT_TRC_9		(9 << 12)	/* Refresh Recovery , 9 cycles */
#define R9K_SDT_TRC_10		(10 << 12)	/* Refresh Recovery , 10 cycles */
#define R9K_SDT_TRC_11		(11 << 12)	/* Refresh Recovery , 11 cycles */
#define R9K_SDT_TRC_12		(12 << 12)	/* Refresh Recovery , 12 cycles */
#define R9K_SDT_TRC_13		(13 << 12)	/* Refresh Recovery , 13 cycles */
#define R9K_SDT_TRC_14		(14 << 12)	/* Refresh Recovery , 14 cycles */
#define R9K_SDT_TRC_15		(15 << 12)	/* Refresh Recovery , 15 cycles */
#define R9K_SDT_TREF_47		(47 << 16)	/* Refresh Interval , 47 cycles */
#define R9K_SDT_WTR_1  		(0 << 25)	/* Write to read min time, 1 cycle */
#define R9K_SDT_WTR_2  		(1 << 25)	/* Write to read min time, 2 cycle */

#define R9K_SDT_TRFC_10		(10 << 26)	/* Auto-refresh, 10 cycles */


#define R9K_SDT_TRC_SHIFT	12


#define R9K_HTDVID		0x0600
#define R9K_HTSC		0x0604
#define R9K_HTCCR		0x0608
#define R9K_HTBHL		0x060C
#define R9K_HTBAR0		0x0610
#define R9K_HTBAR1		0x0614
#define R9K_HTBAR2		0x0618
#define R9K_HTBAR3		0x061C
#define R9K_HTBAR4		0x0620
#define R9K_HTBAR5		0x0624
#define R9K_HTCBCPT		0x0628
#define R9K_HTSDVID		0x062C
#define R9K_HTXRA		0x0630
#define R9K_HTCAP1		0x0634
#define R9K_HTIL		0x063C
#define R9K_HTLCC		0x0640
#define R9K_HTLINK		0x0644
#define R9K_HTFQREV		0x0648
#define R9K_HTOPT		0x064C
#define R9K_HTERCTL		0x0668
#define R9K_HTRXDB 		0x066C
#define R9K_HTIMPED		0x0670
#define R9K_HTSWIMP		0x0674
#define R9K_HTCALCMP		0x0678
#define R9K_HTBAA30		0x0680
#define R9K_HTBAA54		0x0684
#define R9K_HTMASK0		0x0688
#define R9K_HTMASK1		0x068C
#define R9K_HTMASK2		0x0690
#define R9K_HTMASK3		0x0694
#define R9K_HTMASK4		0x0698
#define R9K_HTMASK5		0x069C
#define R9K_HTIFCTL		0x06A0
#define R9K_HTPLL		0x06A4
#define R9K_HTSRI		0x06B0
#define R9K_HTRXNUM		0x06B4
#define R9K_HTTXNUM		0x06B8
#define R9K_HTTXCNT		0x06C8
#define R9K_HTERROR		0x06D8
#define R9K_HTRCRCE		0x06DC
#define R9K_HTEOI		0x06E0
#define R9K_HTRCRCR		0x06F0
#define R9K_HTRCFGA		0x06F8
#define R9K_HTRCFGD		0x06FC

#define R9K_DMCHC		0x0808

#define R9K_INTMSG		0x0A00
#define R9K_RSTSTATUS		0x0A20
#define R9K_RSTSET		0x0A24
#define R9K_RSTCLEAR		0x0A28
#define R9K_INTPIN0		0x0A40
#define R9K_INTPIN1		0x0A44
#define R9K_INTPIN2		0x0A48
#define R9K_INTPIN3		0x0A4C
#define R9K_INTPIN4		0x0A50
#define R9K_INTPIN5		0x0A54
#define R9K_INTPIN6		0x0A58
#define R9K_INTPIN7		0x0A5C
#define R9K_SEM			0x0A60
#define R9K_SEMSET		0x0A64
#define R9K_SEMCLR		0x0A68
#define R9K_TKT			0x0A70
#define R9K_TKTINC		0x0A74
#define R9K_NMICONFIG		0x0AC0


#define R9K_DMP0		0x1810
#define R9K_DMP1		0x1814
#define R9K_DMP2		0x2810
#define R9K_DMP3		0x2814
#define R9K_DMBC0		0x1820
#define R9K_DMSAL0		0x1828
#define R9K_DMSAH0		0x182C
#define R9K_DMDAL0		0x1830
#define R9K_DMDAH0		0x1834
#define R9K_DMNXL0		0x1838
#define R9K_DMNXH0		0x183C
#define R9K_DMBC1		0x1840
#define R9K_DMSAL1		0x1848
#define R9K_DMSAH1		0x184C
#define R9K_DMDAL1		0x1850
#define R9K_DMDAH1		0x1854
#define R9K_DMNXL1		0x1858
#define R9K_DMNXH1		0x185C

#define R9K_DMBC2		0x2820
#define R9K_DMSAL2		0x2828
#define R9K_DMSAH2		0x282C
#define R9K_DMDAL2		0x2830
#define R9K_DMDAH2		0x2834
#define R9K_DMNXL2		0x2838
#define R9K_DMNXH2		0x283C

#define R9K_DMBC3		0x2840
#define R9K_DMSAL3		0x2848
#define R9K_DMSAH3		0x284C
#define R9K_DMDAL3		0x2850
#define R9K_DMDAH3		0x2854
#define R9K_DMNXL3		0x2858
#define R9K_DMNXH3		0x285C

#define R9K_INTP0PRI		0x1A80
#define R9K_INTP0STATUS0	0x1B00
#define R9K_INTP0MASK0		0x1B04
#define R9K_INTP0SET0		0x1B08
#define R9K_INTP0CLEAR0		0x1B0C
#define R9K_INTP0STATUS1	0x1B10
#define R9K_INTP0MASK1		0x1B14
#define R9K_INTP0SET1		0x1B18
#define R9K_INTP0CLEAR1		0x1B1C
#define R9K_INTP0STATUS2	0x1B20
#define R9K_INTP0MASK2		0x1B24
#define R9K_INTP0SET2		0x1B28
#define R9K_INTP0CLEAR2		0x1B2C
#define R9K_INTP0STATUS3	0x1B30
#define R9K_INTP0MASK3		0x1B34
#define R9K_INTP0SET3		0x1B38
#define R9K_INTP0CLEAR3		0x1B3C
#define R9K_INTP0STATUS4	0x1B40
#define R9K_INTP0MASK4		0x1B44
#define R9K_INTP0SET4		0x1B48
#define R9K_INTP0CLEAR4		0x1B4C
#define R9K_INTP0STATUS5	0x1B50
#define R9K_INTP0MASK5		0x1B54
#define R9K_INTP0SET5		0x1B58
#define R9K_INTP0CLEAR5		0x1B5C
#define R9K_INTP0STATUS6	0x1B60
#define R9K_INTP0MASK6		0x1B64
#define R9K_INTP0SET6		0x1B68
#define R9K_INTP0CLEAR6		0x1B6C
#define R9K_INTP0STATUS7	0x1B70
#define R9K_INTP0MASK7		0x1B74
#define R9K_INTP0SET7		0x1B78
#define R9K_INTP0CLEAR7		0x1B7C

#define R9K_INTP1PRI		0x2A80
#define R9K_INTP1STATUS0	0x2B00
#define R9K_INTP1MASK0		0x2B04
#define R9K_INTP1SET0		0x2B08
#define R9K_INTP1CLEAR0		0x2B0C
#define R9K_INTP1STATUS1	0x2B90
#define R9K_INTP1MASK1		0x2B94
#define R9K_INTP1SET1		0x2B98
#define R9K_INTP1CLEAR1		0x2B9C
#define R9K_INTP1STATUS2	0x2BA0
#define R9K_INTP1MASK2		0x2BA4
#define R9K_INTP1SET2		0x2BA8
#define R9K_INTP1CLEAR2		0x2BAC
#define R9K_INTP1STATUS3	0x2BB0
#define R9K_INTP1MASK3		0x2BB4
#define R9K_INTP1SET3		0x2BB8
#define R9K_INTP1CLEAR3		0x2BBC
#define R9K_INTP1STATUS4	0x2BC0
#define R9K_INTP1MASK4		0x2BC4
#define R9K_INTP1SET4		0x2BC8
#define R9K_INTP1CLEAR4		0x2BCC
#define R9K_INTP1STATUS5	0x2BD0
#define R9K_INTP1MASK5		0x2BD4
#define R9K_INTP1SET5		0x2BD8
#define R9K_INTP1CLEAR5		0x2BDC
#define R9K_INTP1STATUS6	0x2BE0
#define R9K_INTP1MASK6		0x2BE4
#define R9K_INTP1SET6		0x2BE8
#define R9K_INTP1CLEAR6		0x2BEC
#define R9K_INTP1STATUS7	0x2BF0
#define R9K_INTP1MASK7		0x2BF4
#define R9K_INTP1SET7		0x2BF8
#define R9K_INTP1CLEAR7		0x2BFC







