#
#-----------------------------------------------------------------
#
# Name:	Makefile.fp
#
# RCS:  $Id: Makefile.fp,v 1.70 2002/12/07 02:23:02 laurentb Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:	Linux Test build makefile
#
# Created by:	Rick Lund
#
# Date Created:	4/13/01
#
#-----------------------------------------------------------------
#

PROG	= fp

TOOL_DIRS = sm-appids   \

FAST_MODULES =		\

COMMON_MODULES	=	\
					sm-scsiio		\
					sm-eee			\
					sm-malloc-slab	\
					sm-queue		\
					sm-timer		\
					sm-esm			\
					sm-thread		\
					sm-hash			\
					sm-libc			\
					sm-chassis		\
					sm-ui			\
					sm-test			\
					sm-serio		\
					sm-pci			\
					sm-sbm-rev2		\
					sm-cod			\
					sm-linux-shmem	\
					sm-linux-socket	\
					sm-spinlock		\
					sm-sdm-agent	\
                    sm-fs           \
                    sm-nvram        \
					sm-rtc			\
					sm-evm-srvr		\
                    sm-debug        \
                    sm-elog			\
                    sm-prof         \
                    sm-file         \
                    sm-seep		    \
					sm-dp-proxy		\
                    sm-ndmp		    \
					sm-backplane	\
					sm-rcon			\
					sm-hw			\
					sm-lsi8104		\
					sm-am-agent		\
					sm-fssf			\
					sm-sys-dvt		\
					sm-event		\
					sm-gcov			\
					sm-scsit-fp		\
					sm-stats		\
					sm-sb1250-prof	\
                    sm-vsvr         \


ifneq (${HOST_PLATFORM}, LINUX_TEST)
	MODULES = sm-start ${COMMON_MODULES} sm-sb1250 sm-bmc12500-eth sm-cache sm-prom-upgrade sm-except sm-jmptbl sm-coredump
else
	MODULES = ${COMMON_MODULES}
endif

MODULE_OBJS = $(foreach OBJ, ${MODULES}, ${OBJECTS_DIR}/${OBJ}.o)
FAST_MODULE_OBJS = $(foreach OBJ, ${FAST_MODULES}, ${OBJECTS_DIR}/${OBJ}-fast.o)

EXPORT_ONLY =		sm-appids		\
					sm-scsi			\
					sm-sdm			\
					sm-anpssc		\
					sm-pkt			\
					sm-tpl			\
					sm-datamover	\
					sm-opt    	    \
					sm-gt64240-mii	\
					sm-evm			\
					ssc-prom-upgrade	\
					sm-cifs			\


LINK_SCRIPT = fp.ld.cmd

#-----------------------------------------------------------------
#
# targets
#
#-----------------------------------------------------------------

fp-all: check-tree tool-dirs ${MODULE_OBJS} ${VERSION_OBJ} link

fp: ${VERSION_OBJ} link

tool-dirs:
	@for tool_dir in ${TOOL_DIRS};		\
	do									\
		${MAKE} -C code/$$tool_dir/;		\
	done

link:
	@if [ ! -d ${IMAGES_DIR} ];		\
		then mkdir -p ${IMAGES_DIR};		\
	fi
	${LD} ${RAM_LDFLAGS_WITH_SCRIPT} ${LD_DEBUG_FLAGS} \
						-o ${IMAGES_DIR}/${PROG} $(CRTBEGIN) $(CRTEND)	\
						${FAST_MODULE_OBJS} ${MODULE_OBJS} ${VERSION_OBJ}
	${NM} -o -n ${IMAGES_DIR}/${PROG} > ${IMAGES_DIR}/${PROG}.nm
	@if [ "${CONV}" != "" ];		\
		then ${PROM_CONV} -f bin -o ${IMAGES_DIR}/${PROG}.bin \
														${IMAGES_DIR}/${PROG};\
	fi
	cp ${IMAGES_DIR}/${PROG}.bin /tftpboot;
#	${PATH_TO_TOOLS}/makerom -s diag_sibyte ${IMAGES_DIR}/${PROG}diag.bin \
					${IMAGES_DIR}/${PROG}.bin ${IMAGES_DIR}/${PROG}.version 0
#	cp ${IMAGES_DIR}/${PROG}diag.bin /tftpboot/

install: 
	sudo install -o 0 -g 0 -m 0444 ${IMAGES_DIR}/${PROG}.bin \
		${DESTDIR}/usr/local/agile/Images
	@sudo rm -f ${DESTDIR}/usr/local/agile/Images/fp.1.0
	sudo ln -s ${PROG}.bin ${DESTDIR}/usr/local/agile/Images/fp.1.0

