#
#-----------------------------------------------------------------
#
# Name:	suffix.mk
#
# RCS:  $Id: suffix.mk,v 1.7 2001/10/15 16:11:18 maximk Exp $
#
# Copyright (C) 2001, Agile Storage, Inc.
#
# Description:	Suffix definitions
#
# Created by:	Rick Lund
#
# Date Created:	4/11/01
#
#-----------------------------------------------------------------
#

.SUFFIXES :
.SUFFIXES : %.d

%.d:

%: %.d

%.h %.c: %.sm ${PATH_TO_TOOLS}/${MKESM_TOOL}
	${PERL} ${PATH_TO_TOOLS}/${MKESM_TOOL} $<

#------------------------------------------------------------------
#
# .d file created from .c files
#
#------------------------------------------------------------------
${DEPENDS_DIR}/${MODULE}-%.d: %.c
	@if [ ! -d ${PATH_TO_TOOLS}/Depends ];				\
		then mkdir ${PATH_TO_TOOLS}/Depends;			\
	fi;
	@if [ ! -d ${PATH_TO_TOOLS}/Depends/${TARGET} ];	\
		then mkdir ${PATH_TO_TOOLS}/Depends/${TARGET};	\
	fi;
	${SHELL} -ec '${CC} -M ${CPPFLAGS} ${CFLAGS} ${DEBUG_FLAGS} \
		${TARGET_FLAGS} $<'	 > $@.tmp
	@${PERL} ${PATH_TO_TOOLS}/fix_deps.pl $(notdir $*.o) ../../Tools/Objects/${TARGET}/${MODULE}-$*.o ../../Tools/Depends/${TARGET}/${MODULE}-$*.d $@.tmp $@
	@if [ -s $@.tmp ]; then rm $@.tmp; fi

#	| sed "s/`basename $*.o`/..\/..\/Tools\/Objects\/${TARGET}\/${MODULE}-`dirname $*.o`\/`basename $*.o` ..\/..\/Tools\/Depends\/${TARGET}\/${MODULE}-`dirname $*.o`\/`basename $*.d`/1" > $@

#------------------------------------------------------------------
#
# .o file created from .c files
#
#------------------------------------------------------------------
${OBJECTS_DIR}/${MODULE}-%.o: %.c
	@if [ ! -d ${PATH_TO_TOOLS}/Objects ];				\
		then mkdir ${PATH_TO_TOOLS}/Objects;			\
	fi;
	@if [ ! -d ${PATH_TO_TOOLS}/Objects/${TARGET} ];		\
		then mkdir ${PATH_TO_TOOLS}/Objects/${TARGET};	\
	fi;
	$(COMPILE.c) -o $@ $<

#------------------------------------------------------------------
#
# .d file created from .S files
#
#------------------------------------------------------------------
${DEPENDS_DIR}/${MODULE}-%.d: %.S
	@if [ ! -d ${PATH_TO_TOOLS}/Depends ];				\
		then mkdir ${PATH_TO_TOOLS}/Depends;			\
	fi;
	@if [ ! -d ${PATH_TO_TOOLS}/Depends/${TARGET} ];	\
		then mkdir ${PATH_TO_TOOLS}/Depends/${TARGET};	\
	fi;
	${SHELL} -ec '${CC} -M ${CPPFLAGS} ${ASFLAGS} ${DEBUG_FLAGS} \
		${TARGET_FLAGS} $<' > $@.tmp
	@${PERL} ${PATH_TO_TOOLS}/fix_deps.pl $(notdir $*.o) ../../Tools/Objects/${TARGET}/${MODULE}-$*.o ../../Tools/Depends/${TARGET}/${MODULE}-$*.d $@.tmp $@
	@if [ -s $@.tmp ]; then rm $@.tmp; fi

#	| sed "s/$*.o/..\/..\/Tools\/Objects\/${TARGET}\/${MODULE}-$*.o ..\/..\/Tools\/Depends\/${TARGET}\/${MODULE}-$*.d/1" > $@

#------------------------------------------------------------------
#
# .o file created from .S files
#
#------------------------------------------------------------------
${OBJECTS_DIR}/${MODULE}-%.o: %.S
	@if [ ! -d ${PATH_TO_TOOLS}/Objects ];				\
		then mkdir ${PATH_TO_TOOLS}/Objects;			\
	fi;
	@if [ ! -d ${PATH_TO_TOOLS}/Objects/${TARGET} ];		\
		then mkdir ${PATH_TO_TOOLS}/Objects/${TARGET};	\
	fi;
	${COMPILE.S} -o $@ $<


%.o: %.c
	$(COMPILE.c) $<

%.so: %.c
	$(COMPILE.c) $(PICFLAGS) $< -o $@

%.p: %.c
	@cproto -E'$(CPP)' -D__extension__="" -D__restrict="" \
	$(CPPFLAGS) $(CPROTOFLAGS) $<  2>/dev/null

%.d: %.c
	@set -e; $(CC) -MM $(CPPFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

