/*
 *-----------------------------------------------------------------
 *
 * Name:	sb1250-promio.sx
 *
 * RCS:  $Id: sb1250-promio.S,v 1.3 2002/01/03 20:16:38 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	10/19/01
 *
 *-----------------------------------------------------------------
 */

#ifdef SIBYTE

#include <sys/mips.h>
#include <sys/sb1250/sb1250_uart.h>
#include <exports/promio-api.h>
 
	.set	noreorder

	.text


/*-----------------------------------------------------------------
 * Name:	promio_init()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							t2 = TEMP
 *							t3 = TEMP
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_init
	.ent	promio_init
promio_init:

	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	la	t2,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	la	t3,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))

	la		t0,PHYS_TO_K1(A_DUART_IMR_A)
	sd		zero,0(t0)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)
	la		t0,PHYS_TO_K1(A_DUART_IMR_B)
	sd		zero,0(t0)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

ser_init_channel:
	li		t0,V_DUART_BITS_PER_CHAR_8 | V_DUART_PARITY_MODE_NONE
	sd		t0,R_DUART_MODE_REG_1(UART)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

	li		t0,M_DUART_STOP_BIT_LEN_1
	sd		t0,R_DUART_MODE_REG_2(UART)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

	li		t0,V_DUART_BAUD_RATE(57600)
	sd		t0,R_DUART_CLK_SEL(UART)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

	li		t0,M_DUART_SET_OPR0 | M_DUART_SET_OPR2
	sd		t0,PHYS_TO_K1(A_DUART_SET_OPR)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

	li		t0,M_DUART_RX_EN | M_DUART_TX_EN
	sd		t0,R_DUART_CMD(UART)
	ld  t0,R_DUART_MODE_REG_1(t2)
	ld  t0,R_DUART_MODE_REG_1(t3)

	move	t0,UART
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	bne		t0,UART,ser_init_channel
	nop

	j		ra
	nop

	.end	promio_init

/*-----------------------------------------------------------------
 * Name:	promio_put_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_put_char
	.ent	promio_put_char
promio_put_char:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_TX_RDY
	beqz	TEMP,1b
	nop
	sd		ARG1,R_DUART_TX_HOLD(UART)
	la	UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	la	UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	nop
	j		ra
	nop

	.end	promio_put_char

/*-----------------------------------------------------------------
 * Name:	promio_get_char()
 *
 * Description:
 *			registers used: t1 = UART
 *							t0 = TEMP
 *							v0 = RET
 *							a0 = ARG1
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_get_char
	.ent	promio_get_char
promio_get_char:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_RX_RDY
	beqz	TEMP,1b
	nop
	ld		RET,R_DUART_RX_HOLD(UART)
	and		RET,RET,0xFF
	nop

1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_TX_RDY
	beqz	TEMP,1b
	nop
	sd		RET,R_DUART_TX_HOLD(UART)
	la	UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	la	UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*1))
	ld  TEMP,R_DUART_MODE_REG_1(UART)
	nop

	j		ra
	nop

	.end	promio_get_char

	.globl	promio_get_char_no_echo
	.ent	promio_get_char_no_echo
promio_get_char_no_echo:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
1:
	ld		TEMP,R_DUART_STATUS(UART)
	nop
	and		TEMP,TEMP,M_DUART_RX_RDY
	beqz	TEMP,1b
	nop
	ld		RET,R_DUART_RX_HOLD(UART)
	and		RET,RET,0xFF
	nop

	j		ra
	nop

	.end	promio_get_char_no_echo

/*-----------------------------------------------------------------
 * Name:	promio_char_avail()
 *
 * Description:
 *			registers used: t1 = UART
 *							v0 = RET
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_char_avail
	.ent	promio_char_avail
promio_char_avail:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld		RET,R_DUART_STATUS(UART)
	nop
	and		RET,RET,M_DUART_RX_RDY
	j		ra
	nop

	.end	promio_char_avail

/*-----------------------------------------------------------------
 * Name:	promio_tx_ready()
 *
 * Description:
 *			registers used:	t1 = UART
 *							v0 = RET
 *
 *			RET will be 0 or != 0 (NOT == 1, if transmitter is ready)
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/16/01
 *
 *-----------------------------------------------------------------
 */
	.globl	promio_tx_ready
	.ent	promio_tx_ready
promio_tx_ready:
	la		UART,PHYS_TO_K1(A_DUART + (DUART_CHANREG_SPACING*0))
	ld		RET,R_DUART_STATUS(UART)
	nop
	and		RET,RET,M_DUART_TX_RDY
	j		ra
	nop

	.end	promio_tx_ready

	.set	reorder

#endif	/* SIBYTE */

