/*
 *-----------------------------------------------------------------
 *
 * Name:	tlbinit.S
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2004, OnStor , Inc.
 *
 * Description:	TLB init code for R9000 
 *
 * Created by:		Shaun Hui
 *
 * Date Created:	03/18/04
 *
 *-----------------------------------------------------------------
 */
#ifdef PROM

#include <nfx-incl.h>
#include <sys/mips.h>

        .set    noreorder
                                                                                
        .globl  CPU_TLBClear
        .globl  CPU_TLBInit

	
/*
 *  Clear the TLB. Normally called from start.S.
 */
LEAF(CPU_TLBClear)
        li      a3, 0                   # First TLB index.
                                                                                
        li      a2, TLBMASK_MASK4Kb
        dmtc0   a2, C0_PGMASK   
                                                                                
1:
        dmtc0   zero, C0_TLBHI      # Clear entry high.
        dmtc0   zero, C0_TLBLO0     # Clear entry low0.
        dmtc0   zero, C0_TLBLO1     # Clear entry low1.
                                                                                
        mtc0    a3, C0_INX     # Set the index.
        addiu   a3, 1
        li      a2, 64
        nop
        nop
        tlbwi                           # Write the TLB
                                                                                
        bne     a3, a2, 1b
        nop
                                                                                
        jr      ra
        nop
END(CPU_TLBClear)
                                                                                
LEAF(CPU_TLBInit)
        mfc0    a3, C0_WIRED     # read next entry from wired 
                                                                                
        dmtc0   t2, C0_PGMASK   	# t2 has page mask
                                                                                
1:
        and     a2, a0, TLBHI_ADDR_MASK		# a0 - virtual address 
        dmtc0   a2, C0_TLBHI        		# Set vpn in entry high.
                                                                                
        move    a2, t0						# t0 - physical address 
        srl     a2, t0, TLBLO_ADDR_SHIFT
        and     a2, a2, TLBLO_PFNMASK
        ori     t3, (TLBLO_G | TLBLO_V | TLBLO_D ) # set cache mode
        or      a2, t3						
        dmtc0   a2, C0_TLBLO0       			# Set up entry low0.
        srl     t4, t1, TLBLO_ADDR_SHIFT
        addu    a2, t4 							# add page size (t1)
        dmtc0   a2, C0_TLBLO1       			# Set up entry low1.
                                                                                
        mtc0    a3, C0_INX     			# Set the index.
        addiu   a3, 1
        sll     a2, t1, 1				# a2 = 2 * page size
        subu    a1, a2
        nop
        tlbwi                           # Write the TLB
                                                                                
        addu    a0, a2                  # vir addr += 2*pagesize
        addu    t0, a2                  # phy addr += 2*pagesize
        bgtz    a1, 1b
		nop
                                                                                
        mtc0    a3, C0_WIRED     # Set wired to reserved entries.
        jr      ra
        nop
END(CPU_TLBInit)

                                                                                


#endif	/* PROM */

