/*
 *=============================================================================
 * File Name   :    bcm5600-socregs.c
 *
 *  RCS: $Id: bcm5600-socregs.c,v 1.1.1.1 2001/12/20 04:53:01 tonyw Exp $		Copied and modified from Broadcom
 *
 *  Description:
 *
 *  Created    :    09-04-2001
 *
 *  Author     :    Tony Wong
 *
 *  Copyright(c)  Agile Storage, Inc. 2001
 *=============================================================================
 */

#include <nfx-incl.h>

#include "bcm5600-socregs.h"

#define BCM5600

#ifdef NDEBUG
# define IFNND(x,y)
#else
# define IFNND(x,y) x,y
#endif

#ifdef NO_MEM_NAMES
# define IFMEMN(x,y)
#else
# define IFMEMN(x,y) x,y
#endif

#ifdef NO_REG_NAMES
# define IFREGN(x,y)
#else
# define IFREGN(x,y) x,y
#endif

#ifdef NO_RESET_INFO
# define IFRSTI(x,y,z)
#else
# define IFRSTI(x,y,z) x,y,z
#endif

#ifdef NO_DESCRIPTIONS
# define IFDESC(x,y)
#else
# define IFDESC(x,y) x,y
#endif

char sr_noinfo[] = "<No information>";

#if 0
char *soc_blocknames[] = {
	"EPIC0",
	"EPIC1",
	"EPIC2",
	"GPIC0",
	"GPIC1",
	"CMIC",
	"MMU",
	"ANY_EPIC",
	"ANY_GPIC",
	"ANY_PIC"
};

int soc_block2schblknum[] = {
	EPIC0_SCH_BLK_NUM,
	EPIC1_SCH_BLK_NUM,
	EPIC2_SCH_BLK_NUM,
	GPIC0_SCH_BLK_NUM,
	GPIC1_SCH_BLK_NUM,
	CMIC_SCH_BLK_NUM,
	MMU_SCH_BLK_NUM,
};

char *soc_regtypenames[] = {
    "general", "port", "cos"
};
#endif

#ifndef NO_FLD_NAMES
char *soc_fieldnames[] = {
	"FIELD",
	"ACTION",
	"ADDR1",
	"ADDR2",
	"ADPAD",
	"AGE_ENA",
	"AGE_VAL",
	"ANACK2",
	"ANCPLT",
	"ANEN",
	"ANERR",
	"ANMSG",
	"ANNP",
	"ANTOG",
	"ASMDR",
	"AUTOS",
	"AUTOZ",
	"AUTO_PAD",
	"BCAST_EN",
	"BIST_DONE",
	"BIT_MODE",
	"BPDU",
	"BPDU1",
	"BPDU2",
	"BPDU3",
	"BPDU4",
	"BP_NO_BOFF",
	"CAB0",
	"CAB0_DONE",
	"CAB1",
	"CAB1_DONE",
	"CAB2",
	"CAB2_DONE",
	"CAB3",
	"CAB3_DONE",
	"CABBOOTOUTTIMER",
	"CBD0",
	"CBD1",
	"CBD2",
	"CBD3",
	"CBH",
	"CBP0_DONE",
	"CBP1_DONE",
	"CBP2_DONE",
	"CBP3_DONE",
	"CBPH_DONE",
	"CCP_DONE",
	"CFAP",
	"CFAPPOOLSIZE",
	"CFAP_DONE",
	"CLK_GRAN",
	"CLRCNT",
	"CMICARBITERDELAY",
	"CML",
	"COL_WIN",
	"COS0",
	"COS1",
	"COS2",
	"COS3",
	"COS4",
	"COS5",
	"COS6",
	"COS7",
	"COS_DST",
	"COS_SRC",
	"COUNT",
	"CPU",
	"CPU_PRI",
	"CRCEN",
	"CRC_EN",
	"CRP",
	"DCC",
	"DCRC12",
	"DDR_SDRAMEN",
	"DDR_SDRAM_BSEL",
	"DDR_SDRAM_CLSEL",
	"DDR_SDRAM_TRP",
	"DEADADDRESS1",
	"DEADADDRESS2",
	"DEADADDRESSCOUNT",
	"DEBUG_ON",
	"DEL_CRC",
	"DLFBC_EN",
	"DPC",
	"DRRD",
	"DST_HIT",
	"DTRD",
	"DUMMY",
	"ECMDT",
	"EGRMASK",
	"ENBL_JABBR",
	"EPORT",
	"EWRAP",
	"EXC_DEF",
	"FCNT",
	"FCRX",
	"FCTX",
	"FD",
	"FE0",
	"FE1",
	"FE10",
	"FE11",
	"FE12",
	"FE13",
	"FE14",
	"FE15",
	"FE16",
	"FE17",
	"FE18",
	"FE19",
	"FE2",
	"FE20",
	"FE21",
	"FE22",
	"FE23",
	"FE3",
	"FE4",
	"FE5",
	"FE6",
	"FE7",
	"FE8",
	"FE9",
	"FILTER",
	"FIL_EN",
	"FLCHK",
	"FMASK",
	"FORCE_PORT_BITMAP",
	"FORCE_QUIET",
	"FSEL",
	"FTYPE",
	"FULLD",
	"FULL_DUP",
	"FX100",
	"GBPFULLCLEARPOINT",
	"GBPFULLSETPOINT",
	"GCC",
	"GE0",
	"GE1",
	"GETDEADADDRESS",
	"GLVR",
	"GRALN",
	"GRBCA",
	"GRBYT",
	"GRCDE",
	"GRCSE",
	"GRDISC",
	"GRFCS",
	"GRFLR",
	"GRIPC",
	"GRIPCHK",
	"GRIPD",
	"GRIPX",
	"GRIPXD",
	"GRJBR",
	"GRM",
	"GRMCA",
	"GROVR",
	"GRPKT",
	"GRUND",
	"GRUXO",
	"GRXCF",
	"GRXPF",
	"GTABRT",
	"GTAGE",
	"GTBCA",
	"GTBYT",
	"GTDFR",
	"GTFCS",
	"GTIP",
	"GTIPD",
	"GTIPX",
	"GTJBR",
	"GTMCA",
	"GTOVR",
	"GTPFH",
	"GTPKT",
	"GTR1023",
	"GTR127",
	"GTR255",
	"GTR511",
	"GTR64",
	"GTRMAX",
	"GTRMGV",
	"GTVLAN",
	"GTXCF",
	"GTXPF",
	"HIT",
	"HOL",
	"HUGEN",
	"HUGE_FR",
	"HWM",
	"IBP",
	"ICC",
	"INGMASK",
	"INTF",
	"IN_BIST",
	"IPGR1",
	"IPGR2",
	"IPGT",
	"IPORT",
	"IPX_SIZE",
	"IP_ADDR",
	"IP_CFG",
	"IP_SIZE",
	"JAM_EN",
	"JTRPS",
	"JTRPT",
	"JUMBO",
	"L10B",
	"L3",
	"L32B",
	"L3_ENA",
	"LBACK",
	"LCC",
	"LEARN_CNT",
	"LG_CHK",
	"LIMIT",
	"LINKOK",
	"LNK_FAIL",
	"LONGP",
	"LONG_PRE",
	"LPACK2",
	"LPANERR",
	"LPASMDR",
	"LPCF",
	"LPFD",
	"LPMSG",
	"LPNEXTP",
	"LPNP",
	"LPPAUSE",
	"LPTOG",
	"LWM",
	"MAC_ADDR",
	"MAXCELLSPERSLOT",
	"MAXFR",
	"MAXLATENCY",
	"MAXNUMBEROFCOS",
	"MAXOUTSTANDINGREAD",
	"MAXPACKETS",
	"MAXSLOTSPERCHAIN",
	"MAXTIME",
	"MCAST_EN",
	"MCLKFQ",
	"MI",
	"MIFG",
	"MIRR_EN",
	"MIRR_L3",
	"MONTH",
	"MPORT",
	"NATPRIENB",
	"NEXTP",
	"NO_BOFF",
	"NO_CIPHER",
	"NPLPCF",
	"OVHEADTIMEPRIENB",
	"PACKETPOINTERPOOLSIZE",
	"PADEN",
	"PAD_EN",
	"PARF",
	"PASSALL",
	"PAUSE",
	"PGRX",
	"PID",
	"PID_DONE",
	"POACHINGTIMER",
	"PORT",
	"PORT_BITMAP",
	"PPP",
	"PPP_DONE",
	"PRI",
	"PRT_DIS",
	"PRT_ENABLE",
	"PTYPE",
	"PUREP",
	"PURE_PAD",
	"RALN",
	"RANX",
	"RBCA",
	"RBYT",
	"RCDE",
	"RCSE",
	"RCSEL",
	"RDISC",
	"REF_CNT",
	"REQTIMERPRIENB",
	"RESERVED0",
	"RESERVED1",
	"RESERVED2",
	"RESERVED_WORD",
	"RESET_100X",
	"RESET_10T",
	"RESET_RMII",
	"RETRY",
	"REV",
	"RFCS",
	"RFIND",
	"RFLR",
	"RFRG",
	"RIPC",
	"RIPCHK",
	"RIPD",
	"RIPX",
	"RIPXD",
	"RJBR",
	"RMCA",
	"RMGT",
	"ROUNDROBINPRIENB",
	"ROUT_ADDR",
	"ROVR",
	"RPKT",
	"RREX",
	"RRFN",
	"RRMC",
	"RSTAN",
	"RST_RFUN",
	"RST_RMCS",
	"RST_SIM",
	"RST_TFUN",
	"RST_TMCS",
	"RTAG",
	"RTEX",
	"RTFN",
	"RTMC",
	"RUNBIST_CAB0",
	"RUNBIST_CAB1",
	"RUNBIST_CAB2",
	"RUNBIST_CAB3",
	"RUNBIST_CBP0",
	"RUNBIST_CBP1",
	"RUNBIST_CBP2",
	"RUNBIST_CBP3",
	"RUNBIST_CBPH",
	"RUNBIST_CCP",
	"RUNBIST_CFAP",
	"RUNBIST_PID",
	"RUNBIST_PPP",
	"RUNBIST_SFAP",
	"RUNBIST_XQ",
	"RUND",
	"RUXO",
	"RXCF",
	"RXEN0",
	"RXPF",
	"RX_EN",
	"RX_PAU",
	"SAFETYMARGIN",
	"SAUFULLPRIENB",
	"SAUFULLVALUE",
	"SAUTIMERVALUE",
	"SCLT",
	"SCP",
	"SDRAMCLK0DLL",
	"SDRAMCLK1DLL",
	"SDRAMCLK2DLL",
	"SDRAMCLK3DLL",
	"SDRAMSIZE",
	"SDUTIMERVALUE",
	"SD_DIS",
	"SFAP",
	"SFAPPOOLSIZE",
	"SFAPRDTIMERVALUE",
	"SFAPWRTIMERVALUE",
	"SFAP_DONE",
	"SHORTOUTUNUSEDBITS",
	"SHORT_QNTA",
	"SKIDMARK",
	"SLOTEJECTGAP",
	"SLOTFETCHGAP",
	"SOFT_RST",
	"SPEED",
	"SPQCT",
	"SP_ST",
	"SRP",
	"SRST",
	"ST",
	"STAD0",
	"STAD1",
	"STAD2",
	"STATUS_PORT_BITMAP",
	"ST_IS_MIRR",
	"ST_LINK",
	"ST_MCNT",
	"ST_MODULE",
	"ST_SIMPLEX",
	"SUBNET_LEN",
	"SUB_ADDR",
	"SUM",
	"SYNCOK",
	"TABRT",
	"TAGE",
	"TAG_EN",
	"TBCA",
	"TBMAP",
	"TBYT",
	"TDFR",
	"TEDF",
	"TEST_BACK",
	"TEST_PAUSE",
	"TFCS",
	"TFRG",
	"TGID",
	"TG_SIZE",
	"TIMER_EN",
	"TIP",
	"TIPD",
	"TIPX",
	"TJBR",
	"TLCL",
	"TMCA",
	"TMCL",
	"TMDS",
	"TNCL",
	"TOS_P",
	"TOVR",
	"TP0",
	"TP1",
	"TP2",
	"TP3",
	"TP4",
	"TP5",
	"TP6",
	"TP7",
	"TPAUSE",
	"TPFH",
	"TPKT",
	"TR1023",
	"TR127",
	"TR255",
	"TR511",
	"TR64",
	"TRMAX",
	"TRMGV",
	"TRUNK",
	"TSCL",
	"TVLAN",
	"TXCF",
	"TXCL",
	"TXEN0",
	"TXPF",
	"TX_PAU",
	"UT_PORT_BITMAP",
	"VLAN_PAD",
	"VLAN_TAG",
	"VLPAD",
	"XQ0",
	"XQ1",
	"XQ10",
	"XQ11",
	"XQ12",
	"XQ13",
	"XQ14",
	"XQ15",
	"XQ16",
	"XQ17",
	"XQ18",
	"XQ19",
	"XQ2",
	"XQ20",
	"XQ21",
	"XQ22",
	"XQ23",
	"XQ24",
	"XQ25",
	"XQ26",
	"XQ27",
	"XQ28",
	"XQ29",
	"XQ3",
	"XQ30",
	"XQ31",
	"XQ4",
	"XQ5",
	"XQ6",
	"XQ7",
	"XQ8",
	"XQ9",
	"XQ_DONE",
	"YEAR"
	"ValueEEPROM"};
#endif /* !NO_FLD_NAMES */

soc_fieldinfo_t sr_AGE_TIMER_fields[] = {
	{ AGE_ENAf, 1, 20, SOCF_LE },
	{ AGE_VALf, 20, 0, SOCF_LE }
};
soc_fieldinfo_t sr_ANCTL_fields[] = {
	{ ANENf, 1, 1, SOCF_LE },
	{ RSTANf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_ANLPA_fields[] = {
	{ LPNPf, 1, 31, SOCF_LE },
	{ LPMSGf, 1, 29, SOCF_LE },
	{ LPACK2f, 1, 28, SOCF_LE },
	{ LPTOGf, 1, 27, SOCF_LE },
	{ LPCFf, 11, 16, SOCF_LE },
	{ LPNEXTPf, 1, 15, SOCF_LE },
	{ LPANERRf, 2, 12, SOCF_LE },
	{ LPASMDRf, 1, 8, SOCF_LE },
	{ LPPAUSEf, 1, 7, SOCF_LE },
	{ LPFDf, 1, 5, SOCF_LE }
};
soc_fieldinfo_t sr_ANNPG_fields[] = {
	{ ANNPf, 1, 31, SOCF_LE },
	{ ANMSGf, 1, 29, SOCF_LE },
	{ ANACK2f, 1, 28, SOCF_LE },
	{ ANTOGf, 1, 27, SOCF_LE },
	{ NPLPCFf, 11, 16, SOCF_LE },
	{ NEXTPf, 1, 15, SOCF_LE },
	{ ANERRf, 2, 12, SOCF_LE },
	{ ASMDRf, 1, 8, SOCF_LE },
	{ PAUSEf, 1, 7, SOCF_LE },
	{ FDf, 1, 5, SOCF_LE }
};
soc_fieldinfo_t sr_ANSTT_fields[] = {
	{ RFINDf, 1, 4, SOCF_LE },
	{ ANCPLTf, 1, 3, SOCF_LE },
	{ PGRXf, 1, 2, SOCF_LE },
	{ LINKOKf, 1, 1, SOCF_LE },
	{ SYNCOKf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_BISTMEMFAILURE_fields[] = {
	{ DEADADDRESSCOUNTf, 4, 28, SOCF_LE|SOCF_RO|SOCF_SC },
	{ DEADADDRESS2f, 14, 14, SOCF_LE|SOCF_RO|SOCF_SC },
	{ GETDEADADDRESSf, 32, 0, SOCF_LE|SOCF_WO|SOCF_SC },
	{ DEADADDRESS1f, 14, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_CABCONTROL_fields[] = {
	{ CABBOOTOUTTIMERf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_CAR1_fields[] = {
	{ TR64f, 1, 31, SOCF_LE },
	{ TR127f, 1, 30, SOCF_LE },
	{ TR255f, 1, 29, SOCF_LE },
	{ TR511f, 1, 28, SOCF_LE },
	{ TR1023f, 1, 27, SOCF_LE },
	{ TRMAXf, 1, 26, SOCF_LE },
	{ TRMGVf, 1, 25, SOCF_LE },
	{ RBYTf, 1, 16, SOCF_LE },
	{ RPKTf, 1, 15, SOCF_LE },
	{ RFCSf, 1, 14, SOCF_LE },
	{ RMCAf, 1, 13, SOCF_LE },
	{ RBCAf, 1, 12, SOCF_LE },
	{ RXCFf, 1, 11, SOCF_LE },
	{ RXPFf, 1, 10, SOCF_LE },
	{ RUXOf, 1, 9, SOCF_LE },
	{ RALNf, 1, 8, SOCF_LE },
	{ RFLRf, 1, 7, SOCF_LE },
	{ RCDEf, 1, 6, SOCF_LE },
	{ RCSEf, 1, 5, SOCF_LE },
	{ RUNDf, 1, 4, SOCF_LE },
	{ ROVRf, 1, 3, SOCF_LE },
	{ RFRGf, 1, 2, SOCF_LE },
	{ RJBRf, 1, 1, SOCF_LE }
};
soc_fieldinfo_t sr_CAR2_fields[] = {
	{ TABRTf, 1, 31, SOCF_LE },
	{ TIPXf, 1, 30, SOCF_LE },
	{ TVLANf, 1, 29, SOCF_LE },
	{ TIPDf, 1, 28, SOCF_LE },
	{ TIPf, 1, 27, SOCF_LE },
	{ TAGEf, 1, 26, SOCF_LE },
	{ RDISCf, 1, 25, SOCF_LE },
	{ RIPXDf, 1, 24, SOCF_LE },
	{ RIPXf, 1, 23, SOCF_LE },
	{ RIPCHKf, 1, 22, SOCF_LE },
	{ RIPDf, 1, 21, SOCF_LE },
	{ RIPCf, 1, 20, SOCF_LE },
	{ TJBRf, 1, 19, SOCF_LE },
	{ TFCSf, 1, 18, SOCF_LE },
	{ TXCFf, 1, 17, SOCF_LE },
	{ TOVRf, 1, 16, SOCF_LE },
	{ TFRGf, 1, 14, SOCF_LE },
	{ TBYTf, 1, 13, SOCF_LE },
	{ TPKTf, 1, 12, SOCF_LE },
	{ TMCAf, 1, 11, SOCF_LE },
	{ TBCAf, 1, 10, SOCF_LE },
	{ TXPFf, 1, 9, SOCF_LE },
	{ TDFRf, 1, 8, SOCF_LE },
	{ TEDFf, 1, 7, SOCF_LE },
	{ TSCLf, 1, 6, SOCF_LE },
	{ TMCLf, 1, 5, SOCF_LE },
	{ TLCLf, 1, 4, SOCF_LE },
	{ TXCLf, 1, 3, SOCF_LE },
	{ TNCLf, 1, 2, SOCF_LE },
	{ TPFHf, 1, 1, SOCF_LE }
};
soc_fieldinfo_t sr_CBPCONTROL_fields[] = {
	{ SAFETYMARGINf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_CFAPPOOLSIZE_fields[] = {
	{ CFAPPOOLSIZEf, 16, 0, SOCF_LE|SOCF_SC }
};
soc_fieldinfo_t sr_CFAPREADPOINTER_fields[] = {
	{ CRPf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_CONFIG_fields[] = {
	{ FX100f, 1, 31, SOCF_LE },
	{ TIMER_ENf, 1, 26, SOCF_LE },
	{ ST_IS_MIRRf, 1, 25, SOCF_LE },
	{ ST_MCNTf, 5, 20, SOCF_LE },
	{ ST_SIMPLEXf, 1, 19, SOCF_LE },
	{ ST_MODULEf, 1, 18, SOCF_LE },
	{ ST_LINKf, 1, 17, SOCF_LE },
	{ TAG_ENf, 1, 16, SOCF_LE },
	{ CLK_GRANf, 3, 13, SOCF_LE },
	{ BIST_DONEf, 2, 11, SOCF_LE },
	{ IN_BISTf, 2, 9, SOCF_LE },
	{ CPU_PRIf, 3, 6, SOCF_LE },
	{ DST_HITf, 1, 5, SOCF_LE },
	{ JAM_ENf, 1, 4, SOCF_LE },
	{ FIL_ENf, 1, 3, SOCF_LE },
	{ L3_ENAf, 1, 2, SOCF_LE },
	{ IP_CFGf, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_COS_ENABLE_fields[] = {
	{ PORT_BITMAPf, 28, 0, SOCF_LE }
};
soc_fieldinfo_t sr_COS_SEL_fields[] = {
	{ COS7f, 3, 21, SOCF_LE },
	{ COS6f, 3, 18, SOCF_LE },
	{ COS5f, 3, 15, SOCF_LE },
	{ COS4f, 3, 12, SOCF_LE },
	{ COS3f, 3, 9, SOCF_LE },
	{ COS2f, 3, 6, SOCF_LE },
	{ COS1f, 3, 3, SOCF_LE },
	{ COS0f, 3, 0, SOCF_LE }
};
soc_fieldinfo_t sr_DROPPEDCELLCOUNT_fields[] = {
	{ DCCf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_DROPPEDPACKETCOUNT_fields[] = {
	{ DPCf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_EGR_ENABLE_fields[] = {
	{ PRT_ENABLEf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EGR_MAXTIME_fields[] = {
	{ MAXTIMEf, 14, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_BIST1_fields[] = {
	{ FCNTf, 4, 28, SOCF_LE },
	{ ADDR2f, 14, 14, SOCF_LE },
	{ ADDR1f, 14, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_BPDU1_fields[] = {
	{ BPDU1f, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_BPDU2_fields[] = {
	{ BPDU3f, 16, 16, SOCF_LE },
	{ BPDU2f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_BPDU4_fields[] = {
	{ BPDU4f, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_EGR_DBG_fields[] = {
	{ DEBUG_ONf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_PFM0_fields[] = {
	{ FE15f, 2, 30, SOCF_LE },
	{ FE14f, 2, 28, SOCF_LE },
	{ FE13f, 2, 26, SOCF_LE },
	{ FE12f, 2, 24, SOCF_LE },
	{ FE11f, 2, 22, SOCF_LE },
	{ FE10f, 2, 20, SOCF_LE },
	{ FE9f, 2, 18, SOCF_LE },
	{ FE8f, 2, 16, SOCF_LE },
	{ FE7f, 2, 14, SOCF_LE },
	{ FE6f, 2, 12, SOCF_LE },
	{ FE5f, 2, 10, SOCF_LE },
	{ FE4f, 2, 8, SOCF_LE },
	{ FE3f, 2, 6, SOCF_LE },
	{ FE2f, 2, 4, SOCF_LE },
	{ FE1f, 2, 2, SOCF_LE },
	{ FE0f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_PFM1_fields[] = {
	{ GE1f, 2, 18, SOCF_LE },
	{ GE0f, 2, 16, SOCF_LE },
	{ FE23f, 2, 14, SOCF_LE },
	{ FE22f, 2, 12, SOCF_LE },
	{ FE21f, 2, 10, SOCF_LE },
	{ FE20f, 2, 8, SOCF_LE },
	{ FE19f, 2, 6, SOCF_LE },
	{ FE18f, 2, 4, SOCF_LE },
	{ FE17f, 2, 2, SOCF_LE },
	{ FE16f, 2, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_RATE_N_IP_fields[] = {
	{ IPX_SIZEf, 5, 26, SOCF_LE },
	{ IP_SIZEf, 5, 21, SOCF_LE },
	{ BCAST_ENf, 1, 20, SOCF_LE },
	{ MCAST_ENf, 1, 19, SOCF_LE },
	{ DLFBC_ENf, 1, 18, SOCF_LE },
	{ LIMITf, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sr_EPC_STAD1_fields[] = {
	{ DUMMYf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_ESA0_fields[] = {
	{ STAD0f, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_CLRT_fields[] = {
	{ COL_WINf, 6, 8, SOCF_LE },
	{ RETRYf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_IPGR_fields[] = {
	{ IPGR1f, 8, 8, SOCF_LE },
	{ IPGR2f, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_IPGT_fields[] = {
	{ IPGTf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_MAC1_fields[] = {
	{ SOFT_RSTf, 1, 15, SOCF_LE },
	{ RST_SIMf, 1, 14, SOCF_LE },
	{ RST_RMCSf, 1, 11, SOCF_LE },
	{ RST_RFUNf, 1, 10, SOCF_LE },
	{ RST_TMCSf, 1, 9, SOCF_LE },
	{ RST_TFUNf, 1, 8, SOCF_LE },
	{ LBACKf, 1, 4, SOCF_LE },
	{ TX_PAUf, 1, 3, SOCF_LE },
	{ RX_PAUf, 1, 2, SOCF_LE },
	{ PASSALLf, 1, 1, SOCF_LE },
	{ RX_ENf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_MAC2_fields[] = {
	{ AUTOZf, 1, 15, SOCF_LE },
	{ EXC_DEFf, 1, 14, SOCF_LE },
	{ BP_NO_BOFFf, 1, 13, SOCF_LE },
	{ NO_BOFFf, 1, 12, SOCF_LE },
	{ CLRCNTf, 1, 11, SOCF_LE },
	{ LONG_PREf, 1, 9, SOCF_LE },
	{ PURE_PADf, 1, 8, SOCF_LE },
	{ AUTO_PADf, 1, 7, SOCF_LE },
	{ VLAN_PADf, 1, 6, SOCF_LE },
	{ PAD_ENf, 1, 5, SOCF_LE },
	{ CRC_ENf, 1, 4, SOCF_LE },
	{ DEL_CRCf, 1, 3, SOCF_LE },
	{ HUGE_FRf, 1, 2, SOCF_LE },
	{ LG_CHKf, 1, 1, SOCF_LE },
	{ FULL_DUPf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_MAXF_fields[] = {
	{ MAXFRf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_SUPP_fields[] = {
	{ RESET_RMIIf, 1, 11, SOCF_LE },
	{ SPEEDf, 1, 8, SOCF_LE },
	{ RESET_100Xf, 1, 7, SOCF_LE },
	{ FORCE_QUIETf, 1, 6, SOCF_LE },
	{ NO_CIPHERf, 1, 5, SOCF_LE },
	{ LNK_FAILf, 1, 4, SOCF_LE },
	{ RESET_10Tf, 1, 2, SOCF_LE },
	{ ENBL_JABBRf, 1, 1, SOCF_LE },
	{ BIT_MODEf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FE_TEST_fields[] = {
	{ TEST_BACKf, 1, 2, SOCF_LE },
	{ TEST_PAUSEf, 1, 1, SOCF_LE },
	{ SHORT_QNTAf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_FLOWCONTROL_fields[] = {
	{ MAXPACKETSf, 8, 16, SOCF_LE },
	{ MAXLATENCYf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GCAR1_fields[] = {
	{ GTR64f, 1, 31, SOCF_LE },
	{ GTR127f, 1, 30, SOCF_LE },
	{ GTR255f, 1, 29, SOCF_LE },
	{ GTR511f, 1, 28, SOCF_LE },
	{ GTR1023f, 1, 27, SOCF_LE },
	{ GTRMAXf, 1, 26, SOCF_LE },
	{ GTRMGVf, 1, 25, SOCF_LE },
	{ GRBYTf, 1, 16, SOCF_LE },
	{ GRPKTf, 1, 15, SOCF_LE },
	{ GRFCSf, 1, 14, SOCF_LE },
	{ GRMCAf, 1, 13, SOCF_LE },
	{ GRBCAf, 1, 12, SOCF_LE },
	{ GRXCFf, 1, 11, SOCF_LE },
	{ GRXPFf, 1, 10, SOCF_LE },
	{ GRUXOf, 1, 9, SOCF_LE },
	{ GRALNf, 1, 8, SOCF_LE },
	{ GRFLRf, 1, 7, SOCF_LE },
	{ GRCDEf, 1, 6, SOCF_LE },
	{ GRCSEf, 1, 5, SOCF_LE },
	{ GRUNDf, 1, 4, SOCF_LE },
	{ GROVRf, 1, 3, SOCF_LE },
	{ GRJBRf, 1, 1, SOCF_LE }
};
soc_fieldinfo_t sr_GCAR2_fields[] = {
	{ GTABRTf, 1, 31, SOCF_LE },
	{ GTIPXf, 1, 30, SOCF_LE },
	{ GTVLANf, 1, 29, SOCF_LE },
	{ GTIPDf, 1, 28, SOCF_LE },
	{ GTIPf, 1, 27, SOCF_LE },
	{ GTAGEf, 1, 26, SOCF_LE },
	{ GRDISCf, 1, 25, SOCF_LE },
	{ GRIPXDf, 1, 24, SOCF_LE },
	{ GRIPXf, 1, 23, SOCF_LE },
	{ GRIPCHKf, 1, 22, SOCF_LE },
	{ GRIPDf, 1, 21, SOCF_LE },
	{ GRIPCf, 1, 20, SOCF_LE },
	{ GTJBRf, 1, 19, SOCF_LE },
	{ GTFCSf, 1, 18, SOCF_LE },
	{ GTXCFf, 1, 17, SOCF_LE },
	{ GTOVRf, 1, 16, SOCF_LE },
	{ GTBYTf, 1, 13, SOCF_LE },
	{ GTPKTf, 1, 12, SOCF_LE },
	{ GTMCAf, 1, 11, SOCF_LE },
	{ GTBCAf, 1, 10, SOCF_LE },
	{ GTXPFf, 1, 9, SOCF_LE },
	{ GTDFRf, 1, 8, SOCF_LE },
	{ GTPFHf, 1, 1, SOCF_LE }
};
soc_fieldinfo_t sr_GCCCOUNT_fields[] = {
	{ GCCf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_GEGR_ENABLE_fields[] = {
	{ PRT_ENABLEf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GLOBALRETURNMARKER_fields[] = {
	{ GRMf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GMACC0_fields[] = {
	{ SRSTf, 1, 31, SOCF_LE },
	{ RMGTf, 1, 25, SOCF_LE },
	{ RANXf, 1, 24, SOCF_LE },
	{ RRMCf, 1, 22, SOCF_LE },
	{ RRFNf, 1, 21, SOCF_LE },
	{ RREXf, 1, 20, SOCF_LE },
	{ RTMCf, 1, 18, SOCF_LE },
	{ RTFNf, 1, 17, SOCF_LE },
	{ RTEXf, 1, 16, SOCF_LE },
	{ L10Bf, 1, 9, SOCF_LE },
	{ L32Bf, 1, 8, SOCF_LE },
	{ TMDSf, 8, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GMACC1_fields[] = {
	{ AUTOZf, 1, 31, SOCF_LE },
	{ TXEN0f, 1, 30, SOCF_LE },
	{ RXEN0f, 1, 28, SOCF_LE },
	{ CLRCNTf, 1, 27, SOCF_LE },
	{ DCRC12f, 2, 22, SOCF_LE },
	{ GLVRf, 1, 19, SOCF_LE },
	{ MIFGf, 3, 16, SOCF_LE },
	{ LONGPf, 1, 12, SOCF_LE },
	{ PARFf, 1, 11, SOCF_LE },
	{ FCRXf, 1, 10, SOCF_LE },
	{ FCTXf, 1, 9, SOCF_LE },
	{ PUREPf, 1, 8, SOCF_LE },
	{ JUMBOf, 1, 7, SOCF_LE },
	{ HUGENf, 1, 6, SOCF_LE },
	{ FLCHKf, 1, 5, SOCF_LE },
	{ CRCENf, 1, 4, SOCF_LE },
	{ ADPADf, 1, 3, SOCF_LE },
	{ VLPADf, 1, 2, SOCF_LE },
	{ PADENf, 1, 1, SOCF_LE },
	{ FULLDf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GMACC2_fields[] = {
	{ MCLKFQf, 3, 16, SOCF_LE },
	{ IPGTf, 6, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GPCSC_fields[] = {
	{ JTRPSf, 3, 28, SOCF_LE },
	{ JTRPTf, 10, 16, SOCF_LE },
	{ SCLTf, 1, 14, SOCF_LE },
	{ DRRDf, 1, 13, SOCF_LE },
	{ DTRDf, 1, 12, SOCF_LE },
	{ AUTOSf, 1, 8, SOCF_LE },
	{ RCSELf, 1, 2, SOCF_LE },
	{ EWRAPf, 1, 1, SOCF_LE },
	{ ECMDTf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GPC_EGR_DBG_fields[] = {
	{ DEBUG_ONf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GRALN_fields[] = {
	{ COUNTf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GRBCA_fields[] = {
	{ COUNTf, 24, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GRBYT_fields[] = {
	{ COUNTf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GRIPX_fields[] = {
	{ COUNTf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GSA0_fields[] = {
	{ STAD1f, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sr_GSA1_fields[] = {
	{ STAD2f, 16, 16, SOCF_LE }
};
soc_fieldinfo_t sr_HIGHWATERMARKER_fields[] = {
	{ HWMf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_HOLBLOCKINGMARKER_fields[] = {
	{ HOLf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_IBPCOUNT_fields[] = {
	{ ICCf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_INGRESSBACKPRESSURE_fields[] = {
	{ IBPf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_INITIATEBIST1_fields[] = {
	{ CBP3_DONEf, 1, 13, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CBP3f, 1, 13, SOCF_LE|SOCF_WO|SOCF_SC },
	{ RUNBIST_CBP2f, 1, 12, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CBP2_DONEf, 1, 12, SOCF_LE|SOCF_RO|SOCF_SC },
	{ CBP1_DONEf, 1, 11, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CBP1f, 1, 11, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CBP0_DONEf, 1, 10, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CBP0f, 1, 10, SOCF_LE|SOCF_WO|SOCF_SC },
	{ PID_DONEf, 1, 9, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_PIDf, 1, 9, SOCF_LE|SOCF_WO|SOCF_SC },
	{ RUNBIST_SFAPf, 1, 8, SOCF_LE|SOCF_WO|SOCF_SC },
	{ SFAP_DONEf, 1, 8, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CFAPf, 1, 7, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CFAP_DONEf, 1, 7, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_PPPf, 1, 6, SOCF_LE|SOCF_WO|SOCF_SC },
	{ PPP_DONEf, 1, 6, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CCPf, 1, 5, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CCP_DONEf, 1, 5, SOCF_LE|SOCF_RO|SOCF_SC },
	{ CBPH_DONEf, 1, 4, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CBPHf, 1, 4, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CAB3_DONEf, 1, 3, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CAB3f, 1, 3, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CAB2_DONEf, 1, 2, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CAB2f, 1, 2, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CAB1_DONEf, 1, 1, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_CAB1f, 1, 1, SOCF_LE|SOCF_WO|SOCF_SC },
	{ RUNBIST_CAB0f, 1, 0, SOCF_LE|SOCF_WO|SOCF_SC },
	{ CAB0_DONEf, 1, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_INITIATEBIST2_fields[] = {
	{ XQ_DONEf, 32, 0, SOCF_LE|SOCF_RO|SOCF_SC },
	{ RUNBIST_XQf, 32, 0, SOCF_LE|SOCF_WO|SOCF_SC }
};
soc_fieldinfo_t sr_LCCCOUNT_fields[] = {
	{ LCCf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_LOWWATERMARKER_fields[] = {
	{ LWMf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_MIRROR_fields[] = {
	{ MIRR_L3f, 1, 7, SOCF_LE },
	{ MIRR_ENf, 1, 6, SOCF_LE },
	{ MPORTf, 6, 0, SOCF_LE }
};
soc_fieldinfo_t sr_MISCCONFIG_fields[] = {
	{ POACHINGTIMERf, 16, 16, SOCF_LE },
	{ SKIDMARKf, 4, 12, SOCF_LE|SOCF_SC },
	{ CMICARBITERDELAYf, 4, 8, SOCF_LE|SOCF_SC },
	{ MAXOUTSTANDINGREADf, 4, 4, SOCF_LE|SOCF_SC },
	{ RESERVED2f, 1, 3, SOCF_LE|SOCF_SC|SOCF_RES },
	{ RESERVED1f, 1, 2, SOCF_LE|SOCF_SC|SOCF_RES },
	{ SHORTOUTUNUSEDBITSf, 1, 1, SOCF_LE|SOCF_SC },
	{ RESERVED0f, 1, 0, SOCF_LE|SOCF_SC|SOCF_RES }
};
soc_fieldinfo_t sr_MMUPORTENABLE_fields[] = {
	{ PORT_BITMAPf, 32, 0, SOCF_LE|SOCF_SC }
};
soc_fieldinfo_t sr_PPPEMPTY_fields[] = {
	{ PORT_BITMAPf, 32, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_RALN_fields[] = {
	{ COUNTf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_RBCA_fields[] = {
	{ COUNTf, 20, 0, SOCF_LE }
};
soc_fieldinfo_t sr_REROUTING_fields[] = {
	{ STATUS_PORT_BITMAPf, 32, 0, SOCF_LE|SOCF_RO|SOCF_SC },
	{ FORCE_PORT_BITMAPf, 32, 0, SOCF_LE|SOCF_WO|SOCF_SC }
};
soc_fieldinfo_t sr_REVCD_fields[] = {
	{ YEARf, 8, 8, SOCF_LE },
	{ MONTHf, 4, 4, SOCF_LE },
	{ REVf, 4, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SCHEDULERCONTROL_fields[] = {
	{ PACKETPOINTERPOOLSIZEf, 1, 16, SOCF_LE },
	{ MAXNUMBEROFCOSf, 2, 0, SOCF_LE|SOCF_RES }
};
soc_fieldinfo_t sr_SDRAMCONTROL_fields[] = {
	{ DDR_SDRAM_TRPf, 1, 29, SOCF_LE },
	{ DDR_SDRAM_BSELf, 2, 27, SOCF_LE },
	{ DDR_SDRAM_CLSELf, 2, 25, SOCF_LE },
	{ DDR_SDRAMENf, 1, 24, SOCF_LE },
	{ SDRAMCLK3DLLf, 4, 20, SOCF_LE },
	{ SDRAMCLK2DLLf, 4, 16, SOCF_LE },
	{ SDRAMCLK1DLLf, 4, 12, SOCF_LE },
	{ SDRAMCLK0DLLf, 4, 8, SOCF_LE },
	{ MAXSLOTSPERCHAINf, 4, 4, SOCF_LE },
	{ MAXCELLSPERSLOTf, 4, 0, SOCF_LE|SOCF_SC|SOCF_RES }
};
soc_fieldinfo_t sr_SDRAMCONTROL2_fields[] = {
	{ SFAPRDTIMERVALUEf, 3, 29, SOCF_LE|SOCF_SC },
	{ SFAPWRTIMERVALUEf, 3, 26, SOCF_LE|SOCF_SC },
	{ SAUTIMERVALUEf, 3, 23, SOCF_LE|SOCF_SC },
	{ SDUTIMERVALUEf, 3, 20, SOCF_LE|SOCF_SC },
	{ SAUFULLPRIENBf, 1, 19, SOCF_LE|SOCF_SC },
	{ REQTIMERPRIENBf, 1, 18, SOCF_LE|SOCF_SC },
	{ OVHEADTIMEPRIENBf, 1, 17, SOCF_LE|SOCF_SC },
	{ NATPRIENBf, 1, 16, SOCF_LE|SOCF_SC },
	{ ROUNDROBINPRIENBf, 1, 15, SOCF_LE|SOCF_SC },
	{ SAUFULLVALUEf, 3, 12, SOCF_LE|SOCF_SC },
	{ REF_CNTf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SFAPPOOLSIZE_fields[] = {
	{ GBPFULLSETPOINTf, 5, 27, SOCF_LE },
	{ GBPFULLCLEARPOINTf, 5, 22, SOCF_LE },
	{ SLOTEJECTGAPf, 5, 17, SOCF_LE|SOCF_SC },
	{ SLOTFETCHGAPf, 5, 12, SOCF_LE|SOCF_SC },
	{ SDRAMSIZEf, 2, 10, SOCF_LE|SOCF_RES },
	{ SFAPPOOLSIZEf, 10, 0, SOCF_LE }
};
soc_fieldinfo_t sr_SFAPREADPOINTER_fields[] = {
	{ SRPf, 16, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};
soc_fieldinfo_t sr_SUM_LWMS_fields[] = {
	{ SUMf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sr_TEST2_fields[] = {
	{ TPAUSEf, 1, 1, SOCF_LE },
	{ SPQCTf, 1, 0, SOCF_LE }
};
soc_fieldinfo_t sr_XQEMPTY_fields[] = {
	{ COS3f, 1, 3, SOCF_LE|SOCF_RO|SOCF_SC },
	{ COS2f, 1, 2, SOCF_LE|SOCF_RO|SOCF_SC },
	{ COS1f, 1, 1, SOCF_LE|SOCF_RO|SOCF_SC },
	{ COS0f, 1, 0, SOCF_LE|SOCF_RO|SOCF_SC }
};

soc_reginfo_t soc_registers[] = {

	{ IFNND(AGE_TIMERr,) IFREGN("AGE_TIMER",) ANY_EPIC,
		soc_genreg, 0x80009, 2, sr_AGE_TIMER_fields
		IFRSTI(,0x0010012c,0x001fffff)
		IFDESC(,"Spanning Tree Age Timer Register")
	},
	{ IFNND(ANCTLr,) IFREGN("ANCTL",) ANY_GPIC,
		soc_portreg, 0x0000c, 2, sr_ANCTL_fields
		IFRSTI(,0x00000000,0x00000003)
		IFDESC(,"Auto-negotiation")
	},
	{ IFNND(ANLPAr,) IFREGN("ANLPA",) ANY_GPIC,
		soc_portreg, 0x0000f, 10, sr_ANLPA_fields
		IFRSTI(,0x00000000,0xbfffb1a0)
		IFDESC(,"Autoneg LP")
	},
	{ IFNND(ANNPGr,) IFREGN("ANNPG",) ANY_GPIC,
		soc_portreg, 0x0000e, 10, sr_ANNPG_fields
		IFRSTI(,0x00000000,0xbfffb1a0)
		IFDESC(,"Auto Neg Page")
	},
	{ IFNND(ANSTTr,) IFREGN("ANSTT",) ANY_GPIC,
		soc_portreg, 0x0000d, 5, sr_ANSTT_fields
		IFRSTI(,0x00000000,0x0000001e)
		IFDESC(,"Auto Neg Status")
	},
	{ IFNND(BISTMEMFAILUREr,) IFREGN("BISTMEMFAILURE",) MMUb,
		soc_genreg, 0x80110, 4, sr_BISTMEMFAILURE_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Triggers a DeadAddress read and responds with the Address")
	},
	{ IFNND(CABCONTROLr,) IFREGN("CABCONTROL",) MMUb,
		soc_genreg, 0x8000d, 1, sr_CABCONTROL_fields
		IFRSTI(,0x00000003,0x000000ff)
		IFDESC(,"Specifies the Control bits for the CAB")
	},
	{ IFNND(CAR1r,) IFREGN("CAR1",) ANY_EPIC,
		soc_portreg, 0x0004c, 23, sr_CAR1_fields
		IFRSTI(,0x00000000,0xfe01fffe)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(CAR2r,) IFREGN("CAR2",) ANY_EPIC,
		soc_portreg, 0x0004d, 30, sr_CAR2_fields
		IFRSTI(,0x00000000,0xffff7ffe)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(CBPCONTROLr,) IFREGN("CBPCONTROL",) MMUb,
		soc_genreg, 0x80002, 1, sr_CBPCONTROL_fields
		IFRSTI(,0x00000300,0x0000ffff)
		IFDESC(,"Configuration of CBP behavior")
	},
	{ IFNND(CFAPPOOLSIZEr,) IFREGN("CFAPPOOLSIZE",) MMUb,
		soc_genreg, 0x80000, 1, sr_CFAPPOOLSIZE_fields
		IFRSTI(,0x00000fff,0x0000ffff)
		IFDESC(,"Controls the CFAP behavior")
	},
	{ IFNND(CFAPREADPOINTERr,) IFREGN("CFAPREADPOINTER",) MMUb,
		soc_genreg, 0x80007, 1, sr_CFAPREADPOINTER_fields
		IFRSTI(,0x00000040,0x0000ffff)
		IFDESC(,"Displays the total number of Cells outstanding in the CBP")
	},
	{ IFNND(CONFIGr,) IFREGN("CONFIG",) ANY_PIC,
		soc_genreg, 0x80000, 17, sr_CONFIG_fields
		IFRSTI(,0x00008000,0x87ffffff)
		IFDESC(,"Switch Configuration Register")
	},
	{ IFNND(COS_ENABLEr,) IFREGN("COS_ENABLE",) ANY_PIC,
		soc_cosreg, 0x40000, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,"Active Port Register 0-3")
	},
	{ IFNND(COS_SELr,) IFREGN("COS_SEL",) ANY_PIC,
		soc_genreg, 0x8000b, 8, sr_COS_SEL_fields
		IFRSTI(,0x00000000,0x00ffffff)
		IFDESC(,"COS Queue Mapping Register")
	},
	{ IFNND(DEST_MIRRr,) IFREGN("DEST_MIRR",) ANY_PIC,
		soc_genreg, 0x8000d, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(DROPPEDCELLCOUNTr,) IFREGN("DROPPEDCELLCOUNT",) MMUb,
		soc_genreg, 0x80009, 1, sr_DROPPEDCELLCOUNT_fields
		IFRSTI(,0x00000000,0x0000ffff)
		IFDESC(,"Displays the total number of Cells dropped by the MMU")
	},
	{ IFNND(DROPPEDPACKETCOUNTr,) IFREGN("DROPPEDPACKETCOUNT",) MMUb,
		soc_genreg, 0x8000a, 1, sr_DROPPEDPACKETCOUNT_fields
		IFRSTI(,0x00000000,0x0000ffff)
		IFDESC(,"Displays the total number of Packets dropped by the MMU")
	},
	{ IFNND(EGR_BKP_DISr,) IFREGN("EGR_BKP_DIS",) ANY_PIC,
		soc_genreg, 0x80005, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,"Back Pressure Discard Register")
	},
	{ IFNND(EGR_ENABLEr,) IFREGN("EGR_ENABLE",) ANY_EPIC,
		soc_genreg, 0x80001, 1, sr_EGR_ENABLE_fields
		IFRSTI(,0x00000000,0x000000ff)
		IFDESC(,"Egress Enable Register")
	},
	{ IFNND(EGR_MAXTIMEr,) IFREGN("EGR_MAXTIME",) ANY_PIC,
		soc_genreg, 0x8000a, 1, sr_EGR_MAXTIME_fields
		IFRSTI(,0x00003fff,0x00003fff)
		IFDESC(,"Packet Age Limit Register")
	},
	{ IFNND(EN_IFILTERr,) IFREGN("EN_IFILTER",) ANY_PIC,
		soc_genreg, 0x8000c, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,"Ingress Filtering Control Register")
	},
	{ IFNND(EPC_BIST1r,) IFREGN("EPC_BIST1",) ANY_EPIC,
		soc_genreg, 0x80012, 3, sr_EPC_BIST1_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"Bist Address for L2 RAM")
	},
	{ IFNND(EPC_BIST2r,) IFREGN("EPC_BIST2",) ANY_EPIC,
		soc_genreg, 0x80011, 3, sr_EPC_BIST1_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"Bist Address for L3 RAM")
	},
	{ IFNND(EPC_BPDU1r,) IFREGN("EPC_BPDU1",) ANY_PIC,
		soc_genreg, 0x8000e, 1, sr_EPC_BPDU1_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"BPDU Register 31:0")
	},
	{ IFNND(EPC_BPDU2r,) IFREGN("EPC_BPDU2",) ANY_PIC,
		soc_genreg, 0x8000f, 2, sr_EPC_BPDU2_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"BPDU Register 47:32")
	},
	{ IFNND(EPC_BPDU4r,) IFREGN("EPC_BPDU4",) ANY_PIC,
		soc_genreg, 0x80010, 1, sr_EPC_BPDU4_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"BPDU Register 31:0")
	},
	{ IFNND(EPC_EGR_DBGr,) IFREGN("EPC_EGR_DBG",) ANY_EPIC,
		soc_genreg, 0x80013, 1, sr_EPC_EGR_DBG_fields
		IFRSTI(,0x00000000,0x000000ff)
		IFDESC(,"Tell egress to request 1 cell from mmu (debug only)")
	},
	{ IFNND(EPC_EGR_SNGL_OUTr,) IFREGN("EPC_EGR_SNGL_OUT",) ANY_EPIC,
		soc_genreg, 0x80015, 1, sr_EGR_ENABLE_fields
		IFRSTI(,0x00000000,0x000000ff)
		IFDESC(,"If in sngl pkt mode, egress allowed to send out 1 pkt")
	},
	{ IFNND(EPC_EGR_SNGL_PKTr,) IFREGN("EPC_EGR_SNGL_PKT",) ANY_EPIC,
		soc_genreg, 0x80014, 1, sr_EGR_ENABLE_fields
		IFRSTI(,0x00000000,0x000000ff)
		IFDESC(,"Put egress in single packet output mode")
	},
	{ IFNND(EPC_HOLr,) IFREGN("EPC_HOL",) ANY_PIC,
		soc_genreg, 0x80002, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,"HOL Blocking Control Register")
	},
	{ IFNND(EPC_LINKr,) IFREGN("EPC_LINK",) ANY_PIC,
		soc_genreg, 0x80004, 1, sr_COS_ENABLE_fields
		IFRSTI(,0x00000000,0x0fffffff)
		IFDESC(,"Forwarding Port Register")
	},
	{ IFNND(EPC_PFM0r,) IFREGN("EPC_PFM0",) ANY_PIC,
		soc_genreg, 0x80007, 16, sr_EPC_PFM0_fields
		IFRSTI(,0x55555555,0xffffffff)
		IFDESC(,"Port Filtering Mode Register 1 for Ports 0-15. The 2-bit values are interpreted as follows:\n2'b00 = Filtering mode A\n2'b01 = Filtering mode B\n2'b10 = Filtering mode C\n2'b11 = Unused\n")
	},
	{ IFNND(EPC_PFM1r,) IFREGN("EPC_PFM1",) ANY_PIC,
		soc_genreg, 0x80008, 10, sr_EPC_PFM1_fields
		IFRSTI(,0x00055555,0x000fffff)
		IFDESC(,"Port Filtering Mode Register 1 for Ports 16-23. The 2-bit values are interpreted as follows:\n2'b00 = Filtering mode A\n2'b01 = Filtering mode B\n2'b10 = Filtering mode C\n2'b11 = Unused\n")
	},
	{ IFNND(EPC_RATE_N_IPr,) IFREGN("EPC_RATE_N_IP",) ANY_PIC,
		soc_genreg, 0x80003, 6, sr_EPC_RATE_N_IP_fields
		IFRSTI(,0x0003ffff,0x7fffffff)
		IFDESC(,"Rate Control Register")
	},
	{ IFNND(EPC_STAD1r,) IFREGN("EPC_STAD1",) ANY_EPIC,
		soc_genreg, 0x8001f, 1, sr_EPC_STAD1_fields
		IFRSTI(,0x00000000,0x00000001)
		IFDESC(,"DUMMY NEED TO BE DELETED")
	},
	{ IFNND(ESA0r,) IFREGN("ESA0",) ANY_EPIC,
		soc_portreg, 0x00010, 1, sr_ESA0_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Station Adress[15:0]")
	},
	{ IFNND(ESA1r,) IFREGN("ESA1",) ANY_EPIC,
		soc_portreg, 0x00011, 1, sr_ESA0_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Station Adress[31:16]")
	},
	{ IFNND(ESA2r,) IFREGN("ESA2",) ANY_EPIC,
		soc_portreg, 0x00012, 1, sr_ESA0_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Station Adress[47:32]")
	},
	{ IFNND(FE_CLRTr,) IFREGN("FE_CLRT",) ANY_EPIC,
		soc_portreg, 0x00004, 2, sr_FE_CLRT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Fast Ethernet Collision Window/Retry Register.")
	},
	{ IFNND(FE_IPGRr,) IFREGN("FE_IPGR",) ANY_EPIC,
		soc_portreg, 0x00003, 2, sr_FE_IPGR_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Fast Ethernet IPGR Register for non back to back transmit.")
	},
	{ IFNND(FE_IPGTr,) IFREGN("FE_IPGT",) ANY_EPIC,
		soc_portreg, 0x00002, 1, sr_FE_IPGT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Fast Ethernet IPGT Register for back to back transmit.")
	},
	{ IFNND(FE_MAC1r,) IFREGN("FE_MAC1",) ANY_EPIC,
		soc_portreg, 0x00000, 11, sr_FE_MAC1_fields
		IFRSTI(,0x00008000,0x0000cf1f)
		IFDESC(,"Fast Ethernet MAC Configuration 1 Register.")
	},
	{ IFNND(FE_MAC2r,) IFREGN("FE_MAC2",) ANY_EPIC,
		soc_portreg, 0x00001, 15, sr_FE_MAC2_fields
		IFRSTI(,0x00000000,0x0000fbff)
		IFDESC(,"Fast Ethernet MAC Configuration 2 Register.")
	},
	{ IFNND(FE_MAXFr,) IFREGN("FE_MAXF",) ANY_EPIC,
		soc_portreg, 0x00005, 1, sr_FE_MAXF_fields
		IFRSTI(,0x000005f8,0x0000ffff)
		IFDESC(,"Fast Ethernet Maximum Frame Length Register.")
	},
	{ IFNND(FE_SUPPr,) IFREGN("FE_SUPP",) ANY_EPIC,
		soc_portreg, 0x00006, 9, sr_FE_SUPP_fields
		IFRSTI(,0x00000000,0x000009f7)
		IFDESC(,"Fast Ethernet Support Register.")
	},
	{ IFNND(FE_TESTr,) IFREGN("FE_TEST",) ANY_EPIC,
		soc_portreg, 0x00007, 3, sr_FE_TEST_fields
		IFRSTI(,0x00000000,0x00000007)
		IFDESC(,"Fast Ethernet Test Register.")
	},
	{ IFNND(FLOWCONTROLr,) IFREGN("FLOWCONTROL",) MMUb,
		soc_cosreg, 0x40000, 2, sr_FLOWCONTROL_fields
		IFRSTI(,0x00000000,0x00ff00ff)
		IFDESC(,"Controls the flow of packets into the Packet Pointer Pool")
	},
	{ IFNND(GCAR1r,) IFREGN("GCAR1",) ANY_GPIC,
		soc_portreg, 0x0004c, 22, sr_GCAR1_fields
		IFRSTI(,0x00000000,0xfe01fffa)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(GCAR2r,) IFREGN("GCAR2",) ANY_GPIC,
		soc_portreg, 0x0004d, 23, sr_GCAR2_fields
		IFRSTI(,0x00000000,0xffff3f02)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(GCCCOUNTr,) IFREGN("GCCCOUNT",) MMUb,
		soc_portreg, 0x00007, 1, sr_GCCCOUNT_fields
		IFRSTI(,0x00000000,0x0000ffff)
		IFDESC(,"Displays the Global Cell Count for this Egress")
	},
	{ IFNND(GEGR_ENABLEr,) IFREGN("GEGR_ENABLE",) ANY_GPIC,
		soc_genreg, 0x80001, 1, sr_GEGR_ENABLE_fields
		IFRSTI(,0x00000000,0x00000001)
		IFDESC(,"Egress Enable Register")
	},
	{ IFNND(GLOBALRETURNMARKERr,) IFREGN("GLOBALRETURNMARKER",) MMUb,
		soc_portreg, 0x00003, 1, sr_GLOBALRETURNMARKER_fields
		IFRSTI(,0x00000000,0x0000000f)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(GMACC0r,) IFREGN("GMACC0",) ANY_GPIC,
		soc_portreg, 0x00000, 12, sr_GMACC0_fields
		IFRSTI(,0x00000000,0x837703ff)
		IFDESC(,"GIG Port Control Reg 0")
	},
	{ IFNND(GMACC1r,) IFREGN("GMACC1",) ANY_GPIC,
		soc_portreg, 0x00001, 20, sr_GMACC1_fields
		IFRSTI(,0x00021001,0xd8cf1fff)
		IFDESC(,"GIG Port Control Reg 1")
	},
	{ IFNND(GMACC2r,) IFREGN("GMACC2",) ANY_GPIC,
		soc_portreg, 0x00002, 2, sr_GMACC2_fields
		IFRSTI(,0x0005000c,0x0007003f)
		IFDESC(,"GIG Port Control Reg 2")
	},
	{ IFNND(GPCSCr,) IFREGN("GPCSC",) ANY_GPIC,
		soc_portreg, 0x00003, 9, sr_GPCSC_fields
		IFRSTI(,0x00000001,0x73ff7107)
		IFDESC(,"Jitter Reg")
	},
	{ IFNND(GPC_EGR_DBGr,) IFREGN("GPC_EGR_DBG",) ANY_GPIC,
		soc_genreg, 0x80012, 1, sr_GPC_EGR_DBG_fields
		IFRSTI(,0x00000000,0x00000001)
		IFDESC(,"Put Egress in debug mode")
	},
	{ IFNND(GPC_EGR_SNGL_OUTr,) IFREGN("GPC_EGR_SNGL_OUT",) ANY_GPIC,
		soc_genreg, 0x80015, 1, sr_GEGR_ENABLE_fields
		IFRSTI(,0x00000000,0x00000001)
		IFDESC(,"If in sngl pkt mode, egress allowed to send out 1 pkt")
	},
	{ IFNND(GPC_EGR_SNGL_PKTr,) IFREGN("GPC_EGR_SNGL_PKT",) ANY_GPIC,
		soc_genreg, 0x80014, 1, sr_GEGR_ENABLE_fields
		IFRSTI(,0x00000000,0x00000001)
		IFDESC(,"Put egress in single packet output mode")
	},
	{ IFNND(GRALNr,) IFREGN("GRALN",) ANY_GPIC,
		soc_portreg, 0x0002f, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Alignment Error Frame Counter")
	},
	{ IFNND(GRBCAr,) IFREGN("GRBCA",) ANY_GPIC,
		soc_portreg, 0x0002b, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Broadcast Frame Counter")
	},
	{ IFNND(GRBYTr,) IFREGN("GRBYT",) ANY_GPIC,
		soc_portreg, 0x00027, 1, sr_GRBYT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Byte Counter")
	},
	{ IFNND(GRCDEr,) IFREGN("GRCDE",) ANY_GPIC,
		soc_portreg, 0x00031, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Code Error Counter")
	},
	{ IFNND(GRDISCr,) IFREGN("GRDISC",) ANY_GPIC,
		soc_portreg, 0x00055, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Discard Packet Counter")
	},
	{ IFNND(GRFCRr,) IFREGN("GRFCR",) ANY_GPIC,
		soc_portreg, 0x00032, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive False Carrier Counter")
	},
	{ IFNND(GRFCSr,) IFREGN("GRFCS",) ANY_GPIC,
		soc_portreg, 0x00029, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive FCS Error Frame Counter")
	},
	{ IFNND(GRFLRr,) IFREGN("GRFLR",) ANY_GPIC,
		soc_portreg, 0x00030, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Length Out of Range Frame Counter")
	},
	{ IFNND(GRIPCr,) IFREGN("GRIPC",) ANY_GPIC,
		soc_portreg, 0x00050, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 Unicast Frame Counter")
	},
	{ IFNND(GRIPCHKr,) IFREGN("GRIPCHK",) ANY_GPIC,
		soc_portreg, 0x00052, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IP Header Error Packet Counter")
	},
	{ IFNND(GRIPDr,) IFREGN("GRIPD",) ANY_GPIC,
		soc_portreg, 0x00051, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 Discard Packet Counter")
	},
	{ IFNND(GRIPXr,) IFREGN("GRIPX",) ANY_GPIC,
		soc_portreg, 0x00053, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IPX Packet Counter")
	},
	{ IFNND(GRIPXDr,) IFREGN("GRIPXD",) ANY_GPIC,
		soc_portreg, 0x00054, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IPX Error Packet Counter")
	},
	{ IFNND(GRJBRr,) IFREGN("GRJBR",) ANY_GPIC,
		soc_portreg, 0x00036, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Jabber Frame Counter")
	},
	{ IFNND(GRMCAr,) IFREGN("GRMCA",) ANY_GPIC,
		soc_portreg, 0x0002a, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Multicast Frame Counter")
	},
	{ IFNND(GROVRr,) IFREGN("GROVR",) ANY_GPIC,
		soc_portreg, 0x00034, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Oversize Frame Counter")
	},
	{ IFNND(GRPKTr,) IFREGN("GRPKT",) ANY_GPIC,
		soc_portreg, 0x00028, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Frame Counter")
	},
	{ IFNND(GRUNDr,) IFREGN("GRUND",) ANY_GPIC,
		soc_portreg, 0x00033, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Undersize Frame Counter")
	},
	{ IFNND(GRXCFr,) IFREGN("GRXCF",) ANY_GPIC,
		soc_portreg, 0x0002c, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Control Frame Counter")
	},
	{ IFNND(GRXPFr,) IFREGN("GRXPF",) ANY_GPIC,
		soc_portreg, 0x0002d, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Pause Frame Counter")
	},
	{ IFNND(GRXUOr,) IFREGN("GRXUO",) ANY_GPIC,
		soc_portreg, 0x0002e, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Unsupported Opcode Frame Counter")
	},
	{ IFNND(GSA0r,) IFREGN("GSA0",) ANY_GPIC,
		soc_portreg, 0x00004, 1, sr_GSA0_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Station Address 31:0")
	},
	{ IFNND(GSA1r,) IFREGN("GSA1",) ANY_GPIC,
		soc_portreg, 0x00005, 1, sr_GSA1_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Station Address 47:32")
	},
	{ IFNND(GTABRTr,) IFREGN("GTABRT",) ANY_GPIC,
		soc_portreg, 0x0005b, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Aborted Packet Counter")
	},
	{ IFNND(GTAGEr,) IFREGN("GTAGE",) ANY_GPIC,
		soc_portreg, 0x00056, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Egress Aging Discard Packet Counter")
	},
	{ IFNND(GTBCAr,) IFREGN("GTBCA",) ANY_GPIC,
		soc_portreg, 0x0003b, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Broadcast Frame Counter")
	},
	{ IFNND(GTBYTr,) IFREGN("GTBYT",) ANY_GPIC,
		soc_portreg, 0x00038, 1, sr_GRBYT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Byte Counter")
	},
	{ IFNND(GTFCSr,) IFREGN("GTFCS",) ANY_GPIC,
		soc_portreg, 0x00047, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit FCS Error Frame Counter")
	},
	{ IFNND(GTIPr,) IFREGN("GTIP",) ANY_GPIC,
		soc_portreg, 0x00057, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit L3 Packet Counter")
	},
	{ IFNND(GTIPDr,) IFREGN("GTIPD",) ANY_GPIC,
		soc_portreg, 0x00058, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit L3 Aborted Packet Counter")
	},
	{ IFNND(GTIPXr,) IFREGN("GTIPX",) ANY_GPIC,
		soc_portreg, 0x0005a, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit IPX Packet Counter")
	},
	{ IFNND(GTJBRr,) IFREGN("GTJBR",) ANY_GPIC,
		soc_portreg, 0x00046, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Jabber Frame Counter")
	},
	{ IFNND(GTMCAr,) IFREGN("GTMCA",) ANY_GPIC,
		soc_portreg, 0x0003a, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Multicast Frame Counter")
	},
	{ IFNND(GTOVRr,) IFREGN("GTOVR",) ANY_GPIC,
		soc_portreg, 0x00049, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Oversize Frame Counter")
	},
	{ IFNND(GTPKTr,) IFREGN("GTPKT",) ANY_GPIC,
		soc_portreg, 0x00039, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Frame Counter")
	},
	{ IFNND(GTR1023r,) IFREGN("GTR1023",) ANY_GPIC,
		soc_portreg, 0x00024, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 512-1023 Byte Frame Counter")
	},
	{ IFNND(GTR127r,) IFREGN("GTR127",) ANY_GPIC,
		soc_portreg, 0x00021, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 65-127 Byte Frame Counter")
	},
	{ IFNND(GTR255r,) IFREGN("GTR255",) ANY_GPIC,
		soc_portreg, 0x00022, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 128-255 Byte Frame Counter")
	},
	{ IFNND(GTR511r,) IFREGN("GTR511",) ANY_GPIC,
		soc_portreg, 0x00023, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 256-511 Byte Frame Counter")
	},
	{ IFNND(GTR64r,) IFREGN("GTR64",) ANY_GPIC,
		soc_portreg, 0x00020, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 64 Byte Frame Counter")
	},
	{ IFNND(GTRMAXr,) IFREGN("GTRMAX",) ANY_GPIC,
		soc_portreg, 0x00025, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 1024-MAX Byte Frame Counter")
	},
	{ IFNND(GTRMGVr,) IFREGN("GTRMGV",) ANY_GPIC,
		soc_portreg, 0x00026, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 1519-1522 Byte Good VLAN Frame Counter")
	},
	{ IFNND(GTVLANr,) IFREGN("GTVLAN",) ANY_GPIC,
		soc_portreg, 0x00059, 1, sr_GRBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Tagged VLAN Packet Counter")
	},
	{ IFNND(GTXCFr,) IFREGN("GTXCF",) ANY_GPIC,
		soc_portreg, 0x00048, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit COntrol Frame Counter")
	},
	{ IFNND(GTXPFr,) IFREGN("GTXPF",) ANY_GPIC,
		soc_portreg, 0x0003c, 1, sr_GRALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Pause Control Frame Counter")
	},
	{ IFNND(HIGHWATERMARKERr,) IFREGN("HIGHWATERMARKER",) MMUb,
		soc_portreg, 0x00001, 1, sr_HIGHWATERMARKER_fields
		IFRSTI(,0x0000007e,0x00000fff)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(HOLBLOCKINGMARKERr,) IFREGN("HOLBLOCKINGMARKER",) MMUb,
		soc_portreg, 0x00002, 1, sr_HOLBLOCKINGMARKER_fields
		IFRSTI(,0x00001c00,0x0000ffff)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(IBPCOUNTr,) IFREGN("IBPCOUNT",) MMUb,
		soc_portreg, 0x00008, 1, sr_IBPCOUNT_fields
		IFRSTI(,0x00000000,0x0000ffff)
		IFDESC(,"Displays the outstanding Cell Count for this Ingress")
	},
	{ IFNND(INGRESSBACKPRESSUREr,) IFREGN("INGRESSBACKPRESSURE",) MMUb,
		soc_portreg, 0x00004, 1, sr_INGRESSBACKPRESSURE_fields
		IFRSTI(,0x00002000,0x0000ffff)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(INITIATEBIST1r,) IFREGN("INITIATEBIST1",) MMUb,
		soc_genreg, 0x80100, 28, sr_INITIATEBIST1_fields
		IFRSTI(,0x00000000,0x00003fff)
		IFDESC(,"Initiates and gives back BIST Status")
	},
	{ IFNND(INITIATEBIST2r,) IFREGN("INITIATEBIST2",) MMUb,
		soc_genreg, 0x80101, 2, sr_INITIATEBIST2_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"Initiates and gives back BIST Status")
	},
	{ IFNND(LCCCOUNTr,) IFREGN("LCCCOUNT",) MMUb,
		soc_portreg, 0x00006, 1, sr_LCCCOUNT_fields
		IFRSTI(,0x00000000,0x0000ffff)
		IFDESC(,"Displays the Local Cell Count for this Egress")
	},
	{ IFNND(LOWWATERMARKERr,) IFREGN("LOWWATERMARKER",) MMUb,
		soc_portreg, 0x00000, 1, sr_LOWWATERMARKER_fields
		IFRSTI(,0x0000004c,0x00000fff)
		IFDESC(,sr_noinfo)
	},
	{ IFNND(MAXFRr,) IFREGN("MAXFR",) ANY_GPIC,
		soc_portreg, 0x00008, 1, sr_FE_MAXF_fields
		IFRSTI(,0x000005f8,0x0000ffff)
		IFDESC(,"Max Frame Length")
	},
	{ IFNND(MIRRORr,) IFREGN("MIRROR",) ANY_PIC,
		soc_genreg, 0x80006, 3, sr_MIRROR_fields
		IFRSTI(,0x00000000,0x000000ff)
		IFDESC(,"Port Mirroring Control Register")
	},
	{ IFNND(MISCCONFIGr,) IFREGN("MISCCONFIG",) MMUb,
		soc_genreg, 0x80004, 8, sr_MISCCONFIG_fields
		IFRSTI(,0x0400ff42,0xffffffff)
		IFDESC(,"Controls various functions in the MMU")
	},
	{ IFNND(MMUPORTENABLEr,) IFREGN("MMUPORTENABLE",) MMUb,
		soc_genreg, 0x8000b, 1, sr_MMUPORTENABLE_fields
		IFRSTI(,0x0bffffff,0xffffffff)
		IFDESC(,"Which Egress Ports the MMU will accept packets to")
	},
	{ IFNND(PPPEMPTYr,) IFREGN("PPPEMPTY",) MMUb,
		soc_genreg, 0x8000e, 1, sr_PPPEMPTY_fields
		IFRSTI(,0xffffffff,0xffffffff)
		IFDESC(,"Displays the PPP Empty status")
	},
	{ IFNND(PPPFULLr,) IFREGN("PPPFULL",) MMUb,
		soc_genreg, 0x8000f, 1, sr_PPPEMPTY_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"Displays the PPP Full status")
	},
	{ IFNND(RALNr,) IFREGN("RALN",) ANY_EPIC,
		soc_portreg, 0x0002f, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Alignment Error Frame Counter")
	},
	{ IFNND(RBCAr,) IFREGN("RBCA",) ANY_EPIC,
		soc_portreg, 0x0002b, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Broadcast Frame Counter")
	},
	{ IFNND(RBYTr,) IFREGN("RBYT",) ANY_EPIC,
		soc_portreg, 0x00027, 1, sr_GRBYT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Byte Counter")
	},
	{ IFNND(RCDEr,) IFREGN("RCDE",) ANY_EPIC,
		soc_portreg, 0x00031, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Code Error Counter")
	},
	{ IFNND(RDISCr,) IFREGN("RDISC",) ANY_EPIC,
		soc_portreg, 0x00055, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Discard Packet Counter")
	},
	{ IFNND(REROUTINGr,) IFREGN("REROUTING",) MMUb,
		soc_genreg, 0x8000c, 2, sr_REROUTING_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"Ports currently rerouted to the GBP")
	},
	{ IFNND(RESURRECTr,) IFREGN("RESURRECT",) MMUb,
		soc_genreg, 0x80010, 1, sr_MMUPORTENABLE_fields
		IFRSTI(,0x00000000,0xffffffff)
		IFDESC(,"The MMU resurrects packets purged by the ingress to this egress")
	},
	{ IFNND(REVCDr,) IFREGN("REVCD",) ANY_GPIC,
		soc_portreg, 0x0000b, 3, sr_REVCD_fields
		IFRSTI(,0x00000501,0x0000ffff)
		IFDESC(,"Revision Info")
	},
	{ IFNND(RFCRr,) IFREGN("RFCR",) ANY_EPIC,
		soc_portreg, 0x00032, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive False Carrier Counter")
	},
	{ IFNND(RFCSr,) IFREGN("RFCS",) ANY_EPIC,
		soc_portreg, 0x00029, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive FCS Error Frame Counter")
	},
	{ IFNND(RFLRr,) IFREGN("RFLR",) ANY_EPIC,
		soc_portreg, 0x00030, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Length Out of Range Frame Counter")
	},
	{ IFNND(RFRGr,) IFREGN("RFRG",) ANY_EPIC,
		soc_portreg, 0x00035, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Fragment Counter")
	},
	{ IFNND(RIPCr,) IFREGN("RIPC",) ANY_EPIC,
		soc_portreg, 0x00050, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 Unicast Frame Counter")
	},
	{ IFNND(RIPCHKr,) IFREGN("RIPCHK",) ANY_EPIC,
		soc_portreg, 0x00052, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IP Header Error Packet Counter")
	},
	{ IFNND(RIPDr,) IFREGN("RIPD",) ANY_EPIC,
		soc_portreg, 0x00051, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 Discard Packet Counter")
	},
	{ IFNND(RIPXr,) IFREGN("RIPX",) ANY_EPIC,
		soc_portreg, 0x00053, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IPX Packet Counter")
	},
	{ IFNND(RIPXDr,) IFREGN("RIPXD",) ANY_EPIC,
		soc_portreg, 0x00054, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive L3 IPX Error Packet Counter")
	},
	{ IFNND(RJBRr,) IFREGN("RJBR",) ANY_EPIC,
		soc_portreg, 0x00036, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Jabber Frame Counter")
	},
	{ IFNND(RMCAr,) IFREGN("RMCA",) ANY_EPIC,
		soc_portreg, 0x0002a, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Multicast Frame Counter")
	},
	{ IFNND(ROVRr,) IFREGN("ROVR",) ANY_EPIC,
		soc_portreg, 0x00034, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Oversize Frame Counter")
	},
	{ IFNND(RPKTr,) IFREGN("RPKT",) ANY_EPIC,
		soc_portreg, 0x00028, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Frame Counter")
	},
	{ IFNND(RUNDr,) IFREGN("RUND",) ANY_EPIC,
		soc_portreg, 0x00033, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Undersize Frame Counter")
	},
	{ IFNND(RXCFr,) IFREGN("RXCF",) ANY_EPIC,
		soc_portreg, 0x0002c, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Control Frame Counter")
	},
	{ IFNND(RXPFr,) IFREGN("RXPF",) ANY_EPIC,
		soc_portreg, 0x0002d, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Pause Frame Counter")
	},
	{ IFNND(RXUOr,) IFREGN("RXUO",) ANY_EPIC,
		soc_portreg, 0x0002e, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Receive Unsupported Opcode Frame Counter")
	},
	{ IFNND(SCHEDULERCONTROLr,) IFREGN("SCHEDULERCONTROL",) MMUb,
		soc_portreg, 0x00005, 2, sr_SCHEDULERCONTROL_fields
		IFRSTI(,0x00010000,0x00010003)
		IFDESC(,"Controls the data flow to each Egress")
	},
	{ IFNND(SDRAMCONTROLr,) IFREGN("SDRAMCONTROL",) MMUb,
		soc_genreg, 0x80005, 10, sr_SDRAMCONTROL_fields
		IFRSTI(,0x3400000c,0x3fffffff)
		IFDESC(,"Controls the SDRAM behavior")
	},
	{ IFNND(SDRAMCONTROL2r,) IFREGN("SDRAMCONTROL2",) MMUb,
		soc_genreg, 0x80006, 11, sr_SDRAMCONTROL2_fields
		IFRSTI(,0x71df0600,0xffffffff)
		IFDESC(,"Controls various SDRAM Controller functions")
	},
	{ IFNND(SFAPPOOLSIZEr,) IFREGN("SFAPPOOLSIZE",) MMUb,
		soc_genreg, 0x80001, 6, sr_SFAPPOOLSIZE_fields
		IFRSTI(,0x20d8c0ff,0xffffffff)
		IFDESC(,"Controls the SFAP behavior")
	},
	{ IFNND(SFAPREADPOINTERr,) IFREGN("SFAPREADPOINTER",) MMUb,
		soc_genreg, 0x80008, 1, sr_SFAPREADPOINTER_fields
		IFRSTI(,0x00000020,0x0000ffff)
		IFDESC(,"Displays the total number of Slots outstanding in the GBP")
	},
	{ IFNND(SUM_LWMSr,) IFREGN("SUM_LWMS",) MMUb,
		soc_genreg, 0x80003, 1, sr_SUM_LWMS_fields
		IFRSTI(,0x00000a8c,0x0000ffff)
		IFDESC(,"The Sum of the Low water Markers.  This is used for \"preallocating\" space in the CBP.  After Ver. A0 this register is invalid!")
	},
	{ IFNND(TABRTr,) IFREGN("TABRT",) ANY_EPIC,
		soc_portreg, 0x0005b, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Aborted Packet Counter")
	},
	{ IFNND(TAGEr,) IFREGN("TAGE",) ANY_EPIC,
		soc_portreg, 0x00056, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Egress Aging Discard Packet Counter")
	},
	{ IFNND(TBCAr,) IFREGN("TBCA",) ANY_EPIC,
		soc_portreg, 0x0003b, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Broadcast Frame Counter")
	},
	{ IFNND(TBYTr,) IFREGN("TBYT",) ANY_EPIC,
		soc_portreg, 0x00038, 1, sr_GRBYT_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Byte Counter")
	},
	{ IFNND(TDFRr,) IFREGN("TDFR",) ANY_EPIC,
		soc_portreg, 0x0003d, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Single Deferral Frame Counter")
	},
	{ IFNND(TEDFr,) IFREGN("TEDF",) ANY_EPIC,
		soc_portreg, 0x0003e, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Multiple Deferral Frame Counter")
	},
	{ IFNND(TEST2r,) IFREGN("TEST2",) ANY_GPIC,
		soc_portreg, 0x00019, 2, sr_TEST2_fields
		IFRSTI(,0x00000000,0x00000003)
		IFDESC(,"Test control")
	},
	{ IFNND(TFCSr,) IFREGN("TFCS",) ANY_EPIC,
		soc_portreg, 0x00047, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit FCS Error Frame Counter")
	},
	{ IFNND(TFRGr,) IFREGN("TFRG",) ANY_EPIC,
		soc_portreg, 0x0004b, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Fragment packets")
	},
	{ IFNND(TIPr,) IFREGN("TIP",) ANY_EPIC,
		soc_portreg, 0x00057, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit L3 Packet Counter")
	},
	{ IFNND(TIPDr,) IFREGN("TIPD",) ANY_EPIC,
		soc_portreg, 0x00058, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit L3 Aborted Packet Counter")
	},
	{ IFNND(TIPXr,) IFREGN("TIPX",) ANY_EPIC,
		soc_portreg, 0x0005a, 1, sr_GRIPX_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit IPX Packet Counter")
	},
	{ IFNND(TJBRr,) IFREGN("TJBR",) ANY_EPIC,
		soc_portreg, 0x00046, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Jabber Frame Counter")
	},
	{ IFNND(TLCLr,) IFREGN("TLCL",) ANY_EPIC,
		soc_portreg, 0x00041, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Late Collision Frame Counter")
	},
	{ IFNND(TMCAr,) IFREGN("TMCA",) ANY_EPIC,
		soc_portreg, 0x0003a, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Multicast Frame Counter")
	},
	{ IFNND(TMCLr,) IFREGN("TMCL",) ANY_EPIC,
		soc_portreg, 0x00040, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Multiple Collision Frame Counter")
	},
	{ IFNND(TNCLr,) IFREGN("TNCL",) ANY_EPIC,
		soc_portreg, 0x00043, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Total Collision Counter")
	},
	{ IFNND(TOVRr,) IFREGN("TOVR",) ANY_EPIC,
		soc_portreg, 0x00049, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Oversize Frame Counter")
	},
	{ IFNND(TPKTr,) IFREGN("TPKT",) ANY_EPIC,
		soc_portreg, 0x00039, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Frame Counter")
	},
	{ IFNND(TR1023r,) IFREGN("TR1023",) ANY_EPIC,
		soc_portreg, 0x00024, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 512-1023 Byte Frame Counter")
	},
	{ IFNND(TR127r,) IFREGN("TR127",) ANY_EPIC,
		soc_portreg, 0x00021, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 65-127 Byte Frame Counter")
	},
	{ IFNND(TR255r,) IFREGN("TR255",) ANY_EPIC,
		soc_portreg, 0x00022, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 128-255 Byte Frame Counter")
	},
	{ IFNND(TR511r,) IFREGN("TR511",) ANY_EPIC,
		soc_portreg, 0x00023, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 256-511 Byte Frame Counter")
	},
	{ IFNND(TR64r,) IFREGN("TR64",) ANY_EPIC,
		soc_portreg, 0x00020, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 64 Byte Frame Counter")
	},
	{ IFNND(TRMAXr,) IFREGN("TRMAX",) ANY_EPIC,
		soc_portreg, 0x00025, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 1024-MAX Byte Frame Counter")
	},
	{ IFNND(TRMGVr,) IFREGN("TRMGV",) ANY_EPIC,
		soc_portreg, 0x00026, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit & Receive 1519-1522 Byte Good VLAN Frame Counter")
	},
	{ IFNND(TSCLr,) IFREGN("TSCL",) ANY_EPIC,
		soc_portreg, 0x0003f, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Single Collision Frame Counter")
	},
	{ IFNND(TVLANr,) IFREGN("TVLAN",) ANY_EPIC,
		soc_portreg, 0x00059, 1, sr_RBCA_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Tagged VLAN Packet Counter")
	},
	{ IFNND(TXCFr,) IFREGN("TXCF",) ANY_EPIC,
		soc_portreg, 0x00048, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit COntrol Frame Counter")
	},
	{ IFNND(TXCLr,) IFREGN("TXCL",) ANY_EPIC,
		soc_portreg, 0x00042, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Excessive Collision Frame Counter")
	},
	{ IFNND(TXPFr,) IFREGN("TXPF",) ANY_EPIC,
		soc_portreg, 0x0003c, 1, sr_RALN_fields
		IFRSTI(,0x00000000,0x00000000)
		IFDESC(,"Transmit Pause Control Frame Counter")
	},
	{ IFNND(XQEMPTYr,) IFREGN("XQEMPTY",) MMUb,
		soc_portreg, 0x00009, 4, sr_XQEMPTY_fields
		IFRSTI(,0x0000000f,0x0000000f)
		IFDESC(,"Displays the EmptyFlags of COSs for this Egress")
	}
};

soc_block_t sm_ARL__blocks[] = {
	EPIC0b, EPIC1b, EPIC2b
};
soc_fieldinfo_t sm_ARL__fields[] = {
	{ SCPf, 1, 85, SOCF_LE },
	{ PORTf, 6, 79, SOCF_LE },
	{ RTAGf, 3, 76, SOCF_LE },
	{ TGIDf, 3, 73, SOCF_LE },
	{ TRUNKf, 1, 72, SOCF_LE },
	{ COS_SRCf, 3, 69, SOCF_LE },
	{ HITf, 1, 68, SOCF_LE },
	{ STf, 1, 67, SOCF_LE },
	{ SD_DISf, 2, 65, SOCF_LE },
	{ L3f, 1, 64, SOCF_LE },
	{ CPUf, 1, 63, SOCF_LE },
	{ COS_DSTf, 3, 60, SOCF_LE },
	{ VLAN_TAGf, 12, 48, SOCF_LE },
	{ MAC_ADDRf, 48, 0, SOCF_LE }
};
soc_fieldinfo_t sm_ARL_CNT__fields[] = {
	{ LEARN_CNTf, 13, 0, SOCF_LE }
};
soc_fieldinfo_t sm_FILTER_IMASK_fields[] = {
	{ RESERVED_WORDf, 32, 544, SOCF_LE|SOCF_RES },
	{ INGMASKf, 6, 518, SOCF_LE },
	{ EGRMASKf, 6, 512, SOCF_LE },
	{ FMASKf, 512, 0, SOCF_LE }
};
soc_fieldinfo_t sm_FILTER_IRULE_fields[] = {
	{ PRIf, 3, 544, SOCF_LE },
	{ PORTf, 6, 538, SOCF_LE },
	{ TOS_Pf, 4, 534, SOCF_LE },
	{ ACTIONf, 7, 527, SOCF_LE },
	{ FSELf, 3, 524, SOCF_LE },
	{ IPORTf, 6, 518, SOCF_LE },
	{ EPORTf, 6, 512, SOCF_LE },
	{ FILTERf, 512, 0, SOCF_LE }
};
soc_fieldinfo_t sm_GBP_fields[] = {
	{ FIELDf, 128, 0, SOCF_LE }
};
soc_block_t sm_GFILTER_IMASK_blocks[] = {
	GPIC0b, GPIC1b
};
soc_fieldinfo_t sm_L3_DEF_IP_fields[] = {
	{ CPUf, 1, 96, SOCF_LE },
	{ SUBNET_LENf, 5, 91, SOCF_LE },
	{ INTFf, 5, 86, SOCF_LE },
	{ PORTf, 6, 80, SOCF_LE },
	{ MAC_ADDRf, 48, 32, SOCF_LE },
	{ SUB_ADDRf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sm_L3_L3_fields[] = {
	{ FTYPEf, 2, 92, SOCF_LE|SOCF_RES },
	{ HITf, 1, 91, SOCF_LE },
	{ INTFf, 5, 86, SOCF_LE },
	{ PORTf, 6, 80, SOCF_LE },
	{ MAC_ADDRf, 48, 32, SOCF_LE },
	{ IP_ADDRf, 32, 0, SOCF_LE }
};
soc_fieldinfo_t sm_L3_L3INTF_fields[] = {
	{ VLAN_TAGf, 12, 48, SOCF_LE },
	{ ROUT_ADDRf, 48, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MARL__fields[] = {
	{ UT_PORT_BITMAPf, 28, 96, SOCF_LE },
	{ PORT_BITMAPf, 28, 64, SOCF_LE },
	{ COS_DSTf, 3, 60, SOCF_LE },
	{ VLAN_TAGf, 12, 48, SOCF_LE },
	{ MAC_ADDRf, 48, 0, SOCF_LE }
};
soc_block_t sm_MMU_MEMORIES1_CAB0_blocks[] = {
	MMUb
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CAB0_fields[] = {
	{ CAB0f, 78, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CAB1_fields[] = {
	{ CAB1f, 78, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CAB2_fields[] = {
	{ CAB2f, 78, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CAB3_fields[] = {
	{ CAB3f, 78, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CBPDATA0_fields[] = {
	{ CBD0f, 128, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CBPDATA1_fields[] = {
	{ CBD1f, 128, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CBPDATA2_fields[] = {
	{ CBD2f, 128, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CBPDATA3_fields[] = {
	{ CBD3f, 128, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CBPHEADER_fields[] = {
	{ CBHf, 64, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CCP_fields[] = {
	{ CBHf, 5, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_CFAP_fields[] = {
	{ CFAPf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_PID_fields[] = {
	{ PIDf, 16, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_PPP_fields[] = {
	{ PPPf, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES1_SFAP_fields[] = {
	{ SFAPf, 128, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ0_fields[] = {
	{ XQ0f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ1_fields[] = {
	{ XQ1f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ10_fields[] = {
	{ XQ10f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ11_fields[] = {
	{ XQ11f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ12_fields[] = {
	{ XQ12f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ13_fields[] = {
	{ XQ13f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ14_fields[] = {
	{ XQ14f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ15_fields[] = {
	{ XQ15f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ2_fields[] = {
	{ XQ2f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ3_fields[] = {
	{ XQ3f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ4_fields[] = {
	{ XQ4f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ5_fields[] = {
	{ XQ5f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ6_fields[] = {
	{ XQ6f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ7_fields[] = {
	{ XQ7f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ8_fields[] = {
	{ XQ8f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES2_XQ9_fields[] = {
	{ XQ9f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ16_fields[] = {
	{ XQ16f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ17_fields[] = {
	{ XQ17f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ18_fields[] = {
	{ XQ18f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ19_fields[] = {
	{ XQ19f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ20_fields[] = {
	{ XQ20f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ21_fields[] = {
	{ XQ21f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ22_fields[] = {
	{ XQ22f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ23_fields[] = {
	{ XQ23f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ24_fields[] = {
	{ XQ24f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ25_fields[] = {
	{ XQ25f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ26_fields[] = {
	{ XQ26f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ27_fields[] = {
	{ XQ27f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ28_fields[] = {
	{ XQ28f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ29_fields[] = {
	{ XQ29f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ30_fields[] = {
	{ XQ30f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_MMU_MEMORIES3_XQ31_fields[] = {
	{ XQ31f, 18, 0, SOCF_LE }
};
soc_fieldinfo_t sm_PTABLE__fields[] = {
	{ UT_PORT_BITMAPf, 28, 64, SOCF_LE },
	{ CMLf, 2, 61, SOCF_LE },
	{ MIf, 1, 60, SOCF_LE },
	{ PORT_BITMAPf, 28, 32, SOCF_LE },
	{ BPDUf, 1, 31, SOCF_LE },
	{ PTYPEf, 2, 29, SOCF_LE },
	{ CPUf, 1, 28, SOCF_LE },
	{ TRUNKf, 1, 27, SOCF_LE },
	{ TGIDf, 3, 24, SOCF_LE },
	{ RTAGf, 3, 21, SOCF_LE },
	{ JUMBOf, 1, 20, SOCF_LE },
	{ PRT_DISf, 6, 14, SOCF_LE },
	{ SP_STf, 2, 12, SOCF_LE },
	{ VLAN_TAGf, 12, 0, SOCF_LE }
};
soc_fieldinfo_t sm_TTABLE_TBMAP_fields[] = {
	{ TBMAPf, 28, 0, SOCF_LE }
};
soc_fieldinfo_t sm_TTABLE_TTR_fields[] = {
	{ TG_SIZEf, 4, 50, SOCF_LE },
	{ TP7f, 6, 44, SOCF_LE },
	{ TP6f, 6, 38, SOCF_LE },
	{ TP5f, 6, 32, SOCF_LE },
	{ TP4f, 6, 24, SOCF_LE },
	{ TP3f, 6, 18, SOCF_LE },
	{ TP2f, 6, 12, SOCF_LE },
	{ TP1f, 6, 6, SOCF_LE },
	{ TP0f, 6, 0, SOCF_LE }
};
soc_fieldinfo_t sm_VTABLE__fields[] = {
	{ UT_PORT_BITMAPf, 28, 64, SOCF_LE },
	{ PORT_BITMAPf, 28, 32, SOCF_LE },
	{ VLAN_TAGf, 12, 0, SOCF_LE }
};

soc_meminfo_t soc_memories[] = {

	{ IFNND(ARL_m,) IFMEMN("ARL_",) 0,
		3, sm_ARL__blocks, 0x0200, 11,
		14, sm_ARL__fields
	},
	{ IFNND(ARL_CNT_m,) IFMEMN("ARL_CNT_",) 0,
		3, sm_ARL__blocks, 0x0100, 2,
		1, sm_ARL_CNT__fields
	},
	{ IFNND(FILTER_IMASKm,) IFMEMN("FILTER_IMASK",) 1,
		3, sm_ARL__blocks, 0x0700, 72,
		4, sm_FILTER_IMASK_fields
	},
	{ IFNND(FILTER_IRULEm,) IFMEMN("FILTER_IRULE",) 1,
		3, sm_ARL__blocks, 0x0702, 69,
		8, sm_FILTER_IRULE_fields
	},
	{ IFNND(GBPm,) IFMEMN("GBP",) 0,
		0, 0, 0x1200, 16,
		1, sm_GBP_fields
	},
	{ IFNND(GFILTER_IMASKm,) IFMEMN("GFILTER_IMASK",) 1,
		2, sm_GFILTER_IMASK_blocks, 0x0700, 72,
		4, sm_FILTER_IMASK_fields
	},
	{ IFNND(GFILTER_IRULEm,) IFMEMN("GFILTER_IRULE",) 1,
		2, sm_GFILTER_IMASK_blocks, 0x0702, 69,
		8, sm_FILTER_IRULE_fields
	},
	{ IFNND(L3_DEF_IPm,) IFMEMN("L3_DEF_IP",) 0,
		3, sm_ARL__blocks, 0x0901, 13,
		6, sm_L3_DEF_IP_fields
	},
	{ IFNND(L3_DEF_IPXm,) IFMEMN("L3_DEF_IPX",) 0,
		3, sm_ARL__blocks, 0x0903, 13,
		6, sm_L3_DEF_IP_fields
	},
	{ IFNND(L3_L3m,) IFMEMN("L3_L3",) 0,
		3, sm_ARL__blocks, 0x0900, 12,
		6, sm_L3_L3_fields
	},
	{ IFNND(L3_L3INTFm,) IFMEMN("L3_L3INTF",) 0,
		3, sm_ARL__blocks, 0x0902, 8,
		2, sm_L3_L3INTF_fields
	},
	{ IFNND(MARL_m,) IFMEMN("MARL_",) 0,
		3, sm_ARL__blocks, 0x0800, 16,
		5, sm_MARL__fields
	},
	{ IFNND(MMU_MEMORIES1_CAB0m,) IFMEMN("MMU_MEMORIES1_CAB0",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a01, 10,
		1, sm_MMU_MEMORIES1_CAB0_fields
	},
	{ IFNND(MMU_MEMORIES1_CAB1m,) IFMEMN("MMU_MEMORIES1_CAB1",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a02, 10,
		1, sm_MMU_MEMORIES1_CAB1_fields
	},
	{ IFNND(MMU_MEMORIES1_CAB2m,) IFMEMN("MMU_MEMORIES1_CAB2",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a03, 10,
		1, sm_MMU_MEMORIES1_CAB2_fields
	},
	{ IFNND(MMU_MEMORIES1_CAB3m,) IFMEMN("MMU_MEMORIES1_CAB3",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a04, 10,
		1, sm_MMU_MEMORIES1_CAB3_fields
	},
	{ IFNND(MMU_MEMORIES1_CBPDATA0m,) IFMEMN("MMU_MEMORIES1_CBPDATA0",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a0a, 16,
		1, sm_MMU_MEMORIES1_CBPDATA0_fields
	},
	{ IFNND(MMU_MEMORIES1_CBPDATA1m,) IFMEMN("MMU_MEMORIES1_CBPDATA1",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a0b, 16,
		1, sm_MMU_MEMORIES1_CBPDATA1_fields
	},
	{ IFNND(MMU_MEMORIES1_CBPDATA2m,) IFMEMN("MMU_MEMORIES1_CBPDATA2",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a0c, 16,
		1, sm_MMU_MEMORIES1_CBPDATA2_fields
	},
	{ IFNND(MMU_MEMORIES1_CBPDATA3m,) IFMEMN("MMU_MEMORIES1_CBPDATA3",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a0d, 16,
		1, sm_MMU_MEMORIES1_CBPDATA3_fields
	},
	{ IFNND(MMU_MEMORIES1_CBPHEADERm,) IFMEMN("MMU_MEMORIES1_CBPHEADER",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a00, 8,
		1, sm_MMU_MEMORIES1_CBPHEADER_fields
	},
	{ IFNND(MMU_MEMORIES1_CCPm,) IFMEMN("MMU_MEMORIES1_CCP",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a05, 1,
		1, sm_MMU_MEMORIES1_CCP_fields
	},
	{ IFNND(MMU_MEMORIES1_CFAPm,) IFMEMN("MMU_MEMORIES1_CFAP",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a07, 2,
		1, sm_MMU_MEMORIES1_CFAP_fields
	},
	{ IFNND(MMU_MEMORIES1_PIDm,) IFMEMN("MMU_MEMORIES1_PID",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a09, 2,
		1, sm_MMU_MEMORIES1_PID_fields
	},
	{ IFNND(MMU_MEMORIES1_PPPm,) IFMEMN("MMU_MEMORIES1_PPP",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a06, 3,
		1, sm_MMU_MEMORIES1_PPP_fields
	},
	{ IFNND(MMU_MEMORIES1_SFAPm,) IFMEMN("MMU_MEMORIES1_SFAP",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0a08, 16,
		1, sm_MMU_MEMORIES1_SFAP_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ0m,) IFMEMN("MMU_MEMORIES2_XQ0",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b00, 3,
		1, sm_MMU_MEMORIES2_XQ0_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ1m,) IFMEMN("MMU_MEMORIES2_XQ1",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b01, 3,
		1, sm_MMU_MEMORIES2_XQ1_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ10m,) IFMEMN("MMU_MEMORIES2_XQ10",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0a, 3,
		1, sm_MMU_MEMORIES2_XQ10_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ11m,) IFMEMN("MMU_MEMORIES2_XQ11",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0b, 3,
		1, sm_MMU_MEMORIES2_XQ11_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ12m,) IFMEMN("MMU_MEMORIES2_XQ12",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0c, 3,
		1, sm_MMU_MEMORIES2_XQ12_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ13m,) IFMEMN("MMU_MEMORIES2_XQ13",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0d, 3,
		1, sm_MMU_MEMORIES2_XQ13_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ14m,) IFMEMN("MMU_MEMORIES2_XQ14",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0e, 3,
		1, sm_MMU_MEMORIES2_XQ14_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ15m,) IFMEMN("MMU_MEMORIES2_XQ15",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b0f, 3,
		1, sm_MMU_MEMORIES2_XQ15_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ2m,) IFMEMN("MMU_MEMORIES2_XQ2",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b02, 3,
		1, sm_MMU_MEMORIES2_XQ2_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ3m,) IFMEMN("MMU_MEMORIES2_XQ3",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b03, 3,
		1, sm_MMU_MEMORIES2_XQ3_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ4m,) IFMEMN("MMU_MEMORIES2_XQ4",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b04, 3,
		1, sm_MMU_MEMORIES2_XQ4_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ5m,) IFMEMN("MMU_MEMORIES2_XQ5",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b05, 3,
		1, sm_MMU_MEMORIES2_XQ5_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ6m,) IFMEMN("MMU_MEMORIES2_XQ6",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b06, 3,
		1, sm_MMU_MEMORIES2_XQ6_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ7m,) IFMEMN("MMU_MEMORIES2_XQ7",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b07, 3,
		1, sm_MMU_MEMORIES2_XQ7_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ8m,) IFMEMN("MMU_MEMORIES2_XQ8",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b08, 3,
		1, sm_MMU_MEMORIES2_XQ8_fields
	},
	{ IFNND(MMU_MEMORIES2_XQ9m,) IFMEMN("MMU_MEMORIES2_XQ9",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0b09, 3,
		1, sm_MMU_MEMORIES2_XQ9_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ16m,) IFMEMN("MMU_MEMORIES3_XQ16",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c00, 3,
		1, sm_MMU_MEMORIES3_XQ16_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ17m,) IFMEMN("MMU_MEMORIES3_XQ17",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c01, 3,
		1, sm_MMU_MEMORIES3_XQ17_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ18m,) IFMEMN("MMU_MEMORIES3_XQ18",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c02, 3,
		1, sm_MMU_MEMORIES3_XQ18_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ19m,) IFMEMN("MMU_MEMORIES3_XQ19",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c03, 3,
		1, sm_MMU_MEMORIES3_XQ19_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ20m,) IFMEMN("MMU_MEMORIES3_XQ20",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c04, 3,
		1, sm_MMU_MEMORIES3_XQ20_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ21m,) IFMEMN("MMU_MEMORIES3_XQ21",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c05, 3,
		1, sm_MMU_MEMORIES3_XQ21_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ22m,) IFMEMN("MMU_MEMORIES3_XQ22",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c06, 3,
		1, sm_MMU_MEMORIES3_XQ22_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ23m,) IFMEMN("MMU_MEMORIES3_XQ23",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c07, 3,
		1, sm_MMU_MEMORIES3_XQ23_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ24m,) IFMEMN("MMU_MEMORIES3_XQ24",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c08, 3,
		1, sm_MMU_MEMORIES3_XQ24_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ25m,) IFMEMN("MMU_MEMORIES3_XQ25",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c09, 3,
		1, sm_MMU_MEMORIES3_XQ25_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ26m,) IFMEMN("MMU_MEMORIES3_XQ26",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0a, 3,
		1, sm_MMU_MEMORIES3_XQ26_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ27m,) IFMEMN("MMU_MEMORIES3_XQ27",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0b, 3,
		1, sm_MMU_MEMORIES3_XQ27_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ28m,) IFMEMN("MMU_MEMORIES3_XQ28",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0c, 3,
		1, sm_MMU_MEMORIES3_XQ28_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ29m,) IFMEMN("MMU_MEMORIES3_XQ29",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0d, 3,
		1, sm_MMU_MEMORIES3_XQ29_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ30m,) IFMEMN("MMU_MEMORIES3_XQ30",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0e, 3,
		1, sm_MMU_MEMORIES3_XQ30_fields
	},
	{ IFNND(MMU_MEMORIES3_XQ31m,) IFMEMN("MMU_MEMORIES3_XQ31",) 0,
		1, sm_MMU_MEMORIES1_CAB0_blocks, 0x0c0f, 3,
		1, sm_MMU_MEMORIES3_XQ31_fields
	},
	{ IFNND(PTABLE_m,) IFMEMN("PTABLE_",) 0,
		3, sm_ARL__blocks, 0x0300, 12,
		14, sm_PTABLE__fields
	},
	{ IFNND(TTABLE_TBMAPm,) IFMEMN("TTABLE_TBMAP",) 0,
		3, sm_ARL__blocks, 0x0601, 4,
		1, sm_TTABLE_TBMAP_fields
	},
	{ IFNND(TTABLE_TTRm,) IFMEMN("TTABLE_TTR",) 0,
		3, sm_ARL__blocks, 0x0600, 7,
		9, sm_TTABLE_TTR_fields
	},
	{ IFNND(VTABLE_m,) IFMEMN("VTABLE_",) 0,
		3, sm_ARL__blocks, 0x0500, 12,
		3, sm_VTABLE__fields
	}
};


soc_portinfo_t soc_ports[] = {
	{ IFNND(0x00,) EPIC0b, 0x00 },
	{ IFNND(0x01,) EPIC0b, 0x01 },
	{ IFNND(0x02,) EPIC0b, 0x02 },
	{ IFNND(0x03,) EPIC0b, 0x03 },
	{ IFNND(0x04,) EPIC0b, 0x04 },
	{ IFNND(0x05,) EPIC0b, 0x05 },
	{ IFNND(0x06,) EPIC0b, 0x06 },
	{ IFNND(0x07,) EPIC0b, 0x07 },
	{ IFNND(0x08,) EPIC1b, 0x00 },
	{ IFNND(0x09,) EPIC1b, 0x01 },
	{ IFNND(0x0a,) EPIC1b, 0x02 },
	{ IFNND(0x0b,) EPIC1b, 0x03 },
	{ IFNND(0x0c,) EPIC1b, 0x04 },
	{ IFNND(0x0d,) EPIC1b, 0x05 },
	{ IFNND(0x0e,) EPIC1b, 0x06 },
	{ IFNND(0x0f,) EPIC1b, 0x07 },
	{ IFNND(0x10,) EPIC2b, 0x00 },
	{ IFNND(0x11,) EPIC2b, 0x01 },
	{ IFNND(0x12,) EPIC2b, 0x02 },
	{ IFNND(0x13,) EPIC2b, 0x03 },
	{ IFNND(0x14,) EPIC2b, 0x04 },
	{ IFNND(0x15,) EPIC2b, 0x05 },
	{ IFNND(0x16,) EPIC2b, 0x06 },
	{ IFNND(0x17,) EPIC2b, 0x07 },
	{ IFNND(0x18,) GPIC0b, 0x00 },
	{ IFNND(0x19,) GPIC1b, 0x00 },
	{ IFNND(0x1a,) -1, -1 },
	{ IFNND(0x1b,) CMICb, 0x00 }
};

char *socreg_info(soc_reg_t idx) {
        static char tmp[128];
        sprintf(tmp,"\t%s - %s",
#ifdef NO_REG_NAMES
                "A SOC register",
#else
                soc_registers[idx].name,
#endif
#ifdef NO_DESCRIPTIONS
                sr_noinfo
#else
                soc_registers[idx].desc
#endif
        );
        return tmp;
}

int isPIC(soc_block_t eblock) {
        switch(eblock) {
        case ANY_EPIC:
        case ANY_GPIC:
        case ANY_PIC:
                return 1;
        default:
                return 0;
        }
}

#if 0
/* 
 *picp is not set if no match or not a PIC.
 */
int match_block(
        soc_block_t block, soc_block_t eblock, int *picp
) {
        int epicOK, gpicOK;

        switch(eblock) {
        case ANY_EPIC:
                epicOK=1;
                gpicOK=0;
                break;
        case ANY_GPIC:
                epicOK=0;
                gpicOK=1;
                break;
        case ANY_PIC:
                epicOK=1;
                gpicOK=1;
                break;
        default:
                return (block==eblock);
        }
        if(epicOK && (block>=MIN_EPIC_5600 && block<=MAX_EPIC_5600)) {
                if(picp) *picp=block-MIN_EPIC_5600;
                return 1;
        }
        if(gpicOK && (block>=MIN_GPIC_5600 && block<=MAX_GPIC_5600)) {
                if(picp) *picp=NUM_EPIC_5600+block-MIN_GPIC_5600;
                return 1;
        }
        return 0;
}
#endif
/* returns -1 if port is not valid in eblock
 */
int get_port_index(soc_port_t port,
                   soc_block_t eblock, soc_block_t *blockp) {
        int result;
        soc_block_t block;

        if(port<0 || port>MAX_PORT_5600) return -1;
        if(soc_ports[port].block==-1) return -1;
        block=soc_ports[port].block;
        result=soc_ports[port].index;
        switch(eblock) {
        case ANY_EPIC:
                if(port>=NUM_FE_PORT_5600) return -1;
                if(block<MIN_EPIC_5600 || block>MAX_EPIC_5600) return -1;
                break;
        case ANY_GPIC:
                if(port<NUM_FE_PORT_5600 || port>=NUM_E_PORT_5600) return -1;
                if(block<MIN_GPIC_5600 || block>MAX_GPIC_5600) return -1;
                break;
        case ANY_PIC:
                if(port>=NUM_E_PORT_5600) return -1;
                if(
                        (block<MIN_EPIC_5600 || block>MAX_EPIC_5600) &&
                        (block<MIN_GPIC_5600 || block>MAX_GPIC_5600)
                ) return -1;
                break;
        default:
                block=eblock;
                result=port;
        }
        if(blockp) *blockp=block;
        return result;
}

soc_block_t pic2block(unsigned pic) {
        if(pic<NUM_EPIC_5600) {
                return MIN_EPIC_5600+pic;
        }
        return MIN_GPIC_5600+pic-NUM_EPIC_5600;
}

#if 0
int block2schblknum(soc_block_t b) {
        return soc_block2schblknum[(int) b];
}
#endif

uint32 reg_addr(soc_reg_t reg, ...)
{
        va_list ap;
        soc_cos_t cos=0;        /* COS index, or 0 */
        int idx;                /* PIC or port index, or undef */
        soc_block_t block;

        va_start(ap, reg);
        block=soc_registers[reg].block;
        switch(soc_registers[reg].regtype) {
        case soc_portreg:
                idx=va_arg(ap, int);
                idx=get_port_index(idx,block,&block);
                break;
        case soc_cosreg:
                cos=va_arg(ap, soc_cos_t);
                /* fall thru */
        case soc_genreg:
                if(isPIC(block)) {
                        idx=va_arg(ap, int);
                        block=pic2block(idx);
                }
                idx=cos;
                break;
        default:
                idx=0; /* To avoid warning */
                break;
        }
        va_end(ap);
        return  block<<SR_BLOCK_BP |
                idx<<SR_REGIDX_BP |
                soc_registers[reg].offset<<SR_REGOFS_BP;
}

uint32 mem_addr(soc_mem_t mem, ...)
{
        va_list ap;
        int index;
        int blkidx=0;   /* block index, or 0 */
        soc_block_t block;

        va_start(ap, mem);
        if(soc_memories[mem].nBlocks) {
                blkidx=va_arg(ap, int);
                block=soc_memories[mem].blocks[blkidx];
        }
        else {
                block=0;
        }
        index=va_arg(ap, int);
        va_end(ap);
        return  block<<SR_BLOCK_BP |
                soc_memories[mem].offset<<SR_MEMOFS_BP |
                index<<SR_MEMIDX_BP;
}

unsigned get_mem_numcopies(soc_mem_t mem) {
        return soc_memories[mem].nBlocks;
}

soc_fieldinfo_t *find_field(
 soc_field_t field, unsigned n, soc_fieldinfo_t *fields
) {
        int i;

        for(i=0; i<n; i++) {
                if(fields[i].field == field) {
                        return &(fields[i]);
                }
        }
        return 0;
}

/* Fixes the endianness of 'v' based on '*f'. */
#define FIX_REG_VALUE_E(v,f) \
if(!((f)->flags & SOCF_LE)) { \
        int tmp=0; \
        int i; \
        for(i=0; i<(f)->len; i++) { \
                tmp=(tmp<<1)|((v)&1); \
                (v)>>=1; \
        } \
        (v)=tmp; \
}

uint32 get_reg_field(
 soc_reg_t reg, uint32 current, soc_field_t field
) {
        soc_reginfo_t *reginfo=&(soc_registers[reg]);
        soc_fieldinfo_t *fieldinfo;
        uint32 value;

        fieldinfo=find_field(field,reginfo->nFields,reginfo->fields);
        value=(current>>fieldinfo->bp)&((1<<(fieldinfo->len-1)<<1)-1);
        FIX_REG_VALUE_E(value,fieldinfo);
        return value;
}

uint32 set_reg_field(
 soc_reg_t reg, uint32 current, soc_field_t field, uint32 value
) {
        soc_reginfo_t *reginfo=&(soc_registers[reg]);
        soc_fieldinfo_t *fieldinfo;
        int mask;

        fieldinfo=find_field(field,reginfo->nFields,reginfo->fields);
        FIX_REG_VALUE_E(value,fieldinfo);
        mask=(1<<(fieldinfo->len-1)<<1)-1;
        return (current&~(mask<<fieldinfo->bp))|value<<fieldinfo->bp;
}

/* flags can be SOCF_RO, SOCF_WO, or zero (read/write) */

#if 0
uint32 get_reg_datamask(soc_reg_t reg, int flags) {
        int i, start, end;
        soc_fieldinfo_t *fieldp;
        soc_reginfo_t *regp;
        uint32 result=0;

        regp=&(soc_registers[reg]);
        for(i=0; i<regp->nFields; i++) {
                fieldp=&(regp->fields[i]);
                if ((fieldp->flags & flags) == flags) {
                        start=fieldp->bp;
                        end=fieldp->bp+fieldp->len-1;
                        result |= ((-1<<start) & ((1<<end<<1)-1));
                }
        }
        return result;
}
/* This is inefficient, because it does a lookup for each field. */
void sprint_reg_data(
        char *bp, char *infix, soc_reg_t reg, uint32 value
) {
        int i,n;
        soc_field_t field;
        int len;
        char buf[24];

        n=soc_registers[reg].nFields;
        for(i=0; i<n; i++) {
                field=soc_registers[reg].fields[i].field;
                len=soc_registers[reg].fields[i].len;
                if(i==n-1) {
                        infix="";
                }
#ifdef NO_FLD_NAMES
                sprintf(buf,"#%%d = 0x%%0%dx%%s",(len+3)>>2);
                sprintf(bp,buf,
                        field, get_reg_field(reg,value,field), infix
                );
#else
                sprintf(buf,"%%s = 0x%%0%dx%%s",(len+3)>>2);
                sprintf(bp,buf,
                        soc_fieldnames[field],
                        get_reg_field(reg,value,field), infix
                );
#endif
                while(*bp) bp++;
        }
}
#endif /* if 0 */

#define BUF1SIZE 256
#define NEXT_COMP() \
        for(i=0; s[i] && s[i]!='.' && i<BUF1SIZE-1; i++) { \
                buf[i]=s[i]; \
        } \
        buf[i]=0; \
        s+=i; \
        if(*s) s++;
#define BUF2SIZE (2*BUF1SIZE)

#if 0
void sprint_reg_addr(char *bp, soc_regaddrinfo_t *ainfo) {
        soc_fieldinfo_t *finfop=0;
        int msb,lsb;

        if(ainfo->valid) {
                if(ainfo->reg!=INVALIDr && ainfo->field!=INVALIDf) {
                        finfop=find_field(ainfo->field,
                                soc_registers[ainfo->reg].nFields,
                                soc_registers[ainfo->reg].fields
                        );
                        if(finfop->flags & SOCF_LE) {
                                msb=finfop->bp+finfop->len-1;
                                lsb=finfop->bp;
                        }
                        else {
                                msb=finfop->bp;
                                lsb=finfop->bp+finfop->len-1;
                        }
                        sprintf(bp,"[%d:%d] ",msb,lsb);
                        while(*bp) bp++;
                }
                if(ainfo->reg!=INVALIDr) {
#ifdef NO_REG_NAMES
                        sprintf(bp,"#%d",ainfo->reg);
                        while(*bp) bp++;
#else
                        sprintf(bp,"%s",soc_registers[ainfo->reg].name);
                        while(*bp) bp++;
#endif /* NO_REG_NAMES */
                        if(ainfo->cos!=-1) {
                                sprintf(bp,".%d",ainfo->cos);
                                while(*bp) bp++;
                        }
                        if(ainfo->block>=MIN_EPIC_5600 && ainfo->block<=MAX_EPIC_5600) {
                                sprintf(bp,".E%d",ainfo->block - MIN_EPIC_5600);
                                while(*bp) bp++;
                        }
                        if(ainfo->block>=MIN_GPIC_5600 && ainfo->block<=MAX_GPIC_5600) {
                                sprintf(bp,".G%d",ainfo->block - MIN_GPIC_5600);
                                while(*bp) bp++;
                        }
                        if(ainfo->port!=-1) {
                                *bp++ = '.';
                                if (ainfo->port>=MIN_FE_PORT_5600 && ainfo->port<=MAX_FE_PORT_5600)
                                        sprintf(bp,"FE%d",ainfo->port-MIN_FE_PORT_5600);
                                else if (ainfo->port>=MIN_GE_PORT_5600 && ainfo->port<=MAX_GE_PORT_5600)
                                        sprintf(bp,"GE%d",ainfo->port-MIN_GE_PORT_5600);
                                else if (ainfo->port==CMIC_PORT_5600)
                                        sprintf(bp,"CPU");
                                else
                                        sprintf(bp,"%d",ainfo->port);
                                while(*bp) bp++;
                        }
                        if(finfop) {
#ifdef NO_FLD_NAMES
                                sprintf(bp,".#%d",ainfo->field);
                                while(*bp) bp++;
#else
                                sprintf(bp,".%s",soc_fieldnames[ainfo->field]);
                                while(*bp) bp++;
#endif /* NO_FLD_NAMES */
                        }
                }
                else {
                        sprintf(bp,"Reserved");
                        while(*bp) bp++;
                }
        }
        else {
                sprintf(bp,"Invalid Address");
                while(*bp) bp++;
        }
}
#endif

#define FIX_MEM_ORDER_E(v,m) ((m)->be ? BYTES2WORDS((m)->bytes)-1-(v) : (v))

#if 0
uint32 *get_mem_field(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
) {
        soc_meminfo_t *meminfo=&(soc_memories[mem]);
        soc_fieldinfo_t *fieldinfo;
        int i,wp,bp,len;

        fieldinfo=find_field(field,meminfo->nFields,meminfo->fields);
        bp=fieldinfo->bp;
        if (fieldinfo->flags & SOCF_LE) {
                wp=bp>>5;
                bp=bp & 0x1f;
                i=0;
                for(len=fieldinfo->len; len>0; len-=32) {
                        if(bp) {
                                fldbuf[i] =
                                 entbuf[FIX_MEM_ORDER_E(wp++,meminfo)]>>bp &
                                 ((1<<(32-bp))-1);
                                fldbuf[i] |=
                                 entbuf[FIX_MEM_ORDER_E(wp,meminfo)]<<(32-bp);
                        }
                        else {
                                fldbuf[i]=entbuf[FIX_MEM_ORDER_E(wp++,meminfo)];
                        }
                        if(len<32) {
                                fldbuf[i] &= ((1<<len)-1);
                        }
                        i++;
                }
        }
        else {
                len=fieldinfo->len;
                i=(len-1)>>5;
                while(len>0) {
                        fldbuf[i]=0;
                        do {
                                fldbuf[i]=
                                 (fldbuf[i]<<1) |
                                 (
                                  (entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] >>
                                        (bp&0x1f)
                                  )&1
                                 );
                                len--;
                                bp++;
                        } while(len & 0x1f);
                        i--;
                }
        }
        return fldbuf;
}
#endif

uint32 *set_mem_field(
 soc_mem_t mem, uint32 *entbuf, soc_field_t field, uint32 *fldbuf
) {
        soc_meminfo_t *meminfo=&(soc_memories[mem]);
        soc_fieldinfo_t *fieldinfo;
        uint32 mask;
        int i,wp,bp,len;

        fieldinfo=find_field(field,meminfo->nFields,meminfo->fields);
        bp=fieldinfo->bp;
        if(fieldinfo->flags & SOCF_LE) {
                wp=bp>>5;
                bp=bp & 0x1f;
                i=0;
                for(len=fieldinfo->len; len>0; len-=32) {
                        if(bp) {
                                if(len<32) {
                                        mask=(1<<len)-1;
                                }
                                else {
                                        mask=-1;
                                }
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                        ~(mask<<bp);
                                entbuf[FIX_MEM_ORDER_E(wp++,meminfo)] |=
                                        fldbuf[i]<<bp;
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                        ~(mask>>(32-bp));
                                entbuf[FIX_MEM_ORDER_E(wp,meminfo)] |=
                                        fldbuf[i]>>(32-bp) & ((1<<bp)-1);
                        }
                        else {
                                if(len<32) {
                                        mask=(1<<len)-1;
                                        entbuf[FIX_MEM_ORDER_E(wp,meminfo)] &=
                                                ~mask;
                                        entbuf[FIX_MEM_ORDER_E(wp++,meminfo)]|=
                                                fldbuf[i]<<bp;
                                }
                                else {
                                        entbuf[FIX_MEM_ORDER_E(wp++,meminfo)] =
                                                fldbuf[i];
                                }
                        }
                        i++;
                }
        }
        else /* Big endian: swap bits */ {
                len=fieldinfo->len;
                while(len>0) {
                        len--;
                        entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] &=
                                ~(1<<(bp&0x1f));
                        entbuf[FIX_MEM_ORDER_E(bp>>5,meminfo)] |=
                                (fldbuf[len>>5]>>(len&0x1f) & 1) << (bp&0x1f);
                        bp++;
                }
        }
        return entbuf;
}

unsigned get_mem_field_numwords(soc_mem_t mem, soc_field_t field) {
        soc_meminfo_t *meminfo;
        soc_fieldinfo_t *fieldinfo;

        meminfo=&(soc_memories[mem]);
        fieldinfo=find_field(field,meminfo->nFields,meminfo->fields);
        return (fieldinfo->len+31)>>5;
}

unsigned get_mem_numbytes(soc_mem_t mem) {
        soc_meminfo_t *meminfo;

        meminfo=&(soc_memories[mem]);
        return meminfo->bytes;
}

uint32 *zero_mem_value(soc_mem_t mem, uint32 *buf) {
        int i;

        for(i=0; i<BYTES2WORDS(get_mem_numbytes(mem)); i++) {
                buf[i]=0;
        }
        return buf;
}
#if 0
uint32 *get_mem_datamask(soc_mem_t mem, uint32 *buf) {
        int f, b, start, end;
        soc_fieldinfo_t *fieldp;
        soc_meminfo_t *memp;
        uint32 tmp;

        (void) zero_mem_value(mem,buf);
        memp=&(soc_memories[mem]);
        for(f=0; f<memp->nFields; f++) {
                fieldp=&(memp->fields[f]);
                if (!(fieldp->flags & SOCF_RES)) { /* not reserved */
                    start=fieldp->bp;
                    end=fieldp->bp+fieldp->len-1;
                    for(b=start>>5; b<=end>>5; b++) {
                        tmp=-1;
                        if(b==start>>5) {
                                tmp &= -1<<(start%32);
                        }
                        if(b==end>>5) {
                                tmp &= (1<<(end%32)<<1)-1;
                        }
                        buf[FIX_MEM_ORDER_E(b,memp)] |= tmp;
                    }
                }
        }
        return buf;
}
#endif
uint32 make_reg_addr(
        soc_block_t block, soc_regtype_t type, uint32 offset,
        soc_port_t port, soc_cos_t cos
) {
        switch(type) {
        case soc_genreg:
                return (block<<20)|(2<<18)|offset;
        case soc_portreg:
                return (block<<20)|(port<<12)|offset;
        case soc_cosreg:
                return (block<<20)|(1<<18)|(cos<<12)|offset;
        default:
                return(0);
        }
}
#if 0
soc_regaddrfields_t get_regaddrfields(soc_reg_t reg) {
        soc_reginfo_t reginfo=soc_registers[reg];
        soc_regaddrfields_t result;
        int i,j,n;

        result.type=reginfo.regtype;
        result.offset=reginfo.offset & 0xFFF;
        result.minCOS = -1;
        result.maxCOS = -1;
        switch(result.type) {
        case soc_portreg:
                switch(reginfo.block) {
                case ANY_EPIC:
                        n=0;
                        for(i=MIN_EPIC_5600; i<=MAX_EPIC_5600; i++) {
                                for(j=0; j<8; j++) {
                                        result.bps[n].block=i;
                                        result.bps[n].port=j;
                                        n++;
                                }
                        }
                        result.nBPs=n;
                        break;
                case ANY_GPIC:
                        n=0;
                        for(i=MIN_GPIC_5600; i<=MAX_GPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=0;
                                n++;
                        }
                        result.nBPs=n;
                        break;
                case ANY_PIC:
                        n=0;
                        for(i=MIN_EPIC_5600; i<=MAX_EPIC_5600; i++) {
                                for(j=0; j<8; j++) {
                                        result.bps[n].block=i;
                                        result.bps[n].port=j;
                                        n++;
                                }
                        }
                        for(i=MIN_GPIC_5600; i<=MAX_GPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=0;
                                n++;
                        }
                        result.nBPs=n;
                        break;
                default:
                        n=0;
                        for(i=0; i<=MAX_PORT_5600; i++) {
                                if(soc_ports[i].block!=-1) {
                                        result.bps[n].block=
                                                reginfo.block;
                                        result.bps[n].port=i;
                                        n++;
                                }
                        }
                        result.nBPs=n;
                }
                break;
        case soc_cosreg:
                result.minCOS = 0;
                result.maxCOS = NUM_COS_5600-1;
                /* Fall Thru */
        case soc_genreg:
                switch(reginfo.block) {
                case ANY_EPIC:
                        n=0;
                        for(i=MIN_EPIC_5600; i<=MAX_EPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=-1;
                                n++;
                        }
                        result.nBPs=n;
                        break;
                case ANY_GPIC:
                        n=0;
                        for(i=MIN_GPIC_5600; i<=MAX_GPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=-1;
                                n++;
                        }
                        result.nBPs=n;
                        break;
                case ANY_PIC:
                        n=0;
                        for(i=MIN_EPIC_5600; i<=MAX_EPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=-1;
                                n++;
                        }
                        for(i=MIN_GPIC_5600; i<=MAX_GPIC_5600; i++) {
                                result.bps[n].block=i;
                                result.bps[n].port=-1;
                                n++;
                        }
                        result.nBPs=n;
                        break;
                default:
                        result.nBPs = 1;
                        result.bps[0].block=reginfo.block;
                        result.bps[0].port=-1;
                }
                break;
        default:
                break;
        }
        return result;
}
#endif

/* Return the min/max PIC Number for this type of PIC */
soc_block_t minblock(soc_block_t block) {
        switch(block) {
        case ANY_EPIC:
        case ANY_PIC:
                return 0;
        case ANY_GPIC:
                return NUM_EPIC_5600;
        default:
                return INVALIDb;
        }
}
soc_block_t maxblock(soc_block_t block) {
        switch(block) {
        case ANY_EPIC:
                return NUM_EPIC_5600-1;
        case ANY_GPIC:
        case ANY_PIC:
                return NUM_PIC_5600-1;
        default:
                return INVALIDb;
        }
}

/* Return the min/max Port Number for this type of PIC */
soc_port_t minport(soc_block_t block) {
        switch(block) {
        case ANY_GPIC:
                return NUM_FE_PORT_5600;
        case ANY_EPIC:
        case ANY_PIC:
        case MMUb:
                return 0;
        default:
                return -1;
        }
}
soc_port_t maxport(soc_block_t block) {
        switch(block) {
        case ANY_EPIC:
                return NUM_FE_PORT_5600-1;
        case ANY_GPIC:
        case ANY_PIC:
                return NUM_E_PORT_5600-1;
        case MMUb:
                return CMIC_PORT_5600;
        default:
                return -1;
        }
}

