/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name: bsd-event.c
 *
 * RCS:  $Id: 
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: functions for event handling
 *
 * Created by:   Su Wang
 *
 * Date Created: 08/19/2002
 *
 *-----------------------------------------------------------------
 */

#if !defined(PROM)
#include <nfx-incl.h>
#include "exports/event-api.h"
#include "exports/bsdnet-api.h"

static void bsdevt_Handler(nfx_eventMsg_t  *evtMsgPtr);

/* 
 *-----------------------------------------------------------------
 *
 * Name: bsdevt_Init
 *
 * Description: initialize event.
 *
 * Created by:	Su Wang
 *
 * Date Created: 08/19/2002
 *
 *-----------------------------------------------------------------
 */
void
bsdevt_Init()
{
	event_registerClient(NFX_EVENT_VOLUME, bsdevt_Handler);
	return;
}

/* 
 *-----------------------------------------------------------------
 *
 * Name: bsdevt_Handler
 *
 * Description: event handler.
 *
 * Created by:	Su Wang
 *
 * Date Created: 08/19/2002
 *
 *-----------------------------------------------------------------
 */
static void
bsdevt_Handler(nfx_eventMsg_t  *evtMsgPtr)
{
	// printf("event handler called, %d\n", evtMsgPtr->param.volEvent.event);
	
	if (evtMsgPtr->param.volEvent.event == EVENT_VOL_TAKEOVER) {
//		printf("bsdevt: vol takeover occured, remove all interface\n");
		bsd_DeleteIpAll(NULL);
	}
	return;
}
#endif /* PROM */
