/*  File Name  :    agilelogin.c 
 *
 *  Description:    HTTPD action functions for admin login
 *
 *  Created    :    5/23/2002
 *
 *  Author     :    Shyh-Pei Yen
 *
 *  Copyright(c)  Agile Storage, Inc. 2002
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include <grp.h>
#include <utmp.h>

#include <sys/time.h>
#include <anpssc-api.h>

#include "agilepost.h"
#include "agileutil.h"
#include "../agent/httpdagent.h"
#include "agilesession.h"

#define INVALID_TAG			0
#define NUM_OF_TAGS			0

#define PARAM_USER			1
#define PARAM_PASS			2
#define NUM_OF_PARAMS		2

static paramNameTable_t paramTable[NUM_OF_PARAMS] = {
	{PARAM_USER,	"User"},
	{PARAM_PASS,	"Password"},
};


/* HERE ARE VARIABLES FOR USER INFORMATION */
char inUser[256];
char inPass[256];



static int verifyLogin(char *newfname);



/***********************************************************
 * routines to retrieve user information 
 **********************************************************/

static int getInputParams(int count, char **argname, char **argval)
{
	int argind, paramType;

	for (argind = 0; argind < count; argind ++)
	{
		paramType = GetParamType(argname[argind], paramTable, NUM_OF_PARAMS);
		if (paramType == INVALID_PARAM)
			continue;

		switch (paramType) 
		{
		case PARAM_USER:
			strcpy(inUser, argval[argind]);
			break;
		case PARAM_PASS:
			strcpy(inPass, argval[argind]);
			break;
		}
	}

	return 0;
}


/***********************************************************/

static int verifyLogin(char *newfname)
{
char reqbuf[512];
char rspbuf[512];
haMessage_t *req;
haMessage_t *rsp;
haUserPass_t *p;
struct timeval tval = {5, 0};
int rc, login_ok = 0;

	/* do login check here and set login_ok properly */

    memset(rspbuf, 0, sizeof(rspbuf));
	rsp = (haMessage_t *) rspbuf;
    memset(reqbuf, 0, sizeof(reqbuf));
	req = (haMessage_t *) reqbuf;

	p = (haUserPass_t *) req->data;

    req->type = HA_VERIFYUSERPASS;
	strcpy(p->user, inUser);
	strcpy(p->pass, inPass);
	req->datalen = sizeof(haUserPass_t);

    rc = sendAgileMsg(-1, reqbuf, HAMESSAGE_HEADER_SIZE + req->datalen,
                        "httpdagent", NFX_SSC_UNIX, SSC_SLOT, MGMTPLANE,
                        &tval, rspbuf, sizeof(rspbuf));
	if ((rc > 0) && (rsp->rspstatus == HARSP_OK))
		login_ok = 1;

	if (login_ok)
		strcpy(newfname, "/AgileView/html/AgileView.html");
	else
	{
		/* should delay a few second here for security reason */
		strcpy(newfname, "/error_login.html");
	}
	return login_ok;
}


/*
 * actRptTagFunc()
 */
static int actRptTagFunc(tagCallbackParams_t *tp)
{
char *value = tp->value;

	strcpy(value, "");
	return 1;
}


int actionLogin(void *r, int count, char **argname, char **argval)
{
char newfname[128];

	inUser[0] = '\0';
	inPass[0] = '\0';
	getInputParams(count, argname, argval);

	memset(newfname, 0, sizeof(newfname));
	if (verifyLogin(newfname))
		agile_setup_session(r);
	prepare_agile_template(r, newfname);

	agile_scan_and_send(r, actRptTagFunc);

	return 1;
}
