/*  File Name  :    agileutil.h 
 *
 *  Description:    HTTPD utilities.
 *
 *  Created    :    1/31/2002
 *
 *  Author     :    Tiffany Chiang
 *
 *  Copyright(c)  Agile Storage, Inc. 2001
 *
 */

#include <nfx-types.h>
#include <evm_com_defs.h>

/* global structures */
#define MAX_PARAMNAME_SIZE	32
#define INVALID_PARAM		0

#define PRIV_VIEW			0
#define PRIV_ADD			1
#define PRIV_CHANGE			2
#define PRIV_FULL			3
#define PRIV_DIAG			4


typedef struct _paramNameTable {
	int	paramType;
	char paramName[MAX_PARAMNAME_SIZE];
} paramNameTable_t;

extern char *strAdd;
extern char *strMod;
extern char *strDel;

/* export functions */
int GetDelimiteredParam(int from, char *srcbuf, char *dstbuf);
void GetWwnStr(uint64 wwn, char* buf);
void GetIpAddressStr(uint32 src, char* buf);
uint32 GetIpAddressFromStr(char* buf);
void GetMacAddressStr(char* mac, char* buf);
void GetInterfaceStrs(uchar8* ifname, char* typebuf, char* slotbuf, char* linkbuf);
void GetInterfaceTypeStr(uchar8* ifname, char* buf);
void GetInterfaceSlotStr(uchar8* ifname, char* buf);
void GetInterfaceLinkStr(uchar8* ifname, char* buf);
void GetInterfaceNameStr(char* ifname, char* typebuf, char* slotbuf, char* linkbuf);
int GetParamType(char* paramName, paramNameTable_t* table, int count);
int IsStoragePortAlive(int32 slot, int32 port);
#ifdef ISABELLE // code to delete
void GetVolTypeStr(evm_lVol_t type, char* buf);
#endif // ISABELLE
void GetRaidLevelStr(evm_raid_t raid, char* buf);
evm_raid_t GetRaidLevelFromStr(char* buf);
void GetSystemIP(char* buf);
void GetSystemHostName(char* buf);

uint64 GetVolumeDispUsedSize(uint64 intSize);
uint64 GetVolumeIntUsedSize(uint64 dispSize);
uint64 GetVolumeDispCurrSize(uint64 intSize);
uint64 GetVolumeIntCurrSize(uint64 dispSize);
uint64 GetMBfromBlock(uint64 block);
uint64 GetKBfromBlock(uint64 block);
uint64 GetBlockfromMB(uint64 mb);
uint64 GetBlockfromKB(uint64 kb);
int GetNfsPermission(char* exportInfo);
int GetNfsRootSquash(char* exportInfo);
void removeTrailingBlank(char *s);
void convertSpecCharToUrlChar(char *s);
void convertUrlCharToSpecChar(char *s);
