/* vi:ts=4 
 *-----------------------------------------------------------------
 *
 * Name: udp_stats.h
 *
 * RCS:  $Id: udp_stats.h,v 1.1 2002/05/06 22:12:18 swang Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: separated from udp_var.h
 *
 * Created by:	Su Wang
 *
 * Date Created: 05/06/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _NETINET_UDP_STATS_H
#define _NETINET_UDP_STATS_H
struct	udpstat {
				/* input statistics: */
	uint32	udps_ipackets;		/* total input packets */
	uint32	udps_hdrops;		/* packet shorter than header */
	uint32	udps_badsum;		/* checksum error */
	uint32	udps_badlen;		/* data length larger than packet */
	uint32	udps_noport;		/* no socket on port */
	uint32	udps_noportbcast;	/* of above, arrived as broadcast */
	uint32	udps_fullsock;		/* not delivered, input socket full */
	uint32	udpps_pcbcachemiss;	/* input packets missing pcb cache */
	uint32	udpps_pcbhashmiss;	/* input packets not for hashed pcb */
				/* output statistics: */
	uint32	udps_opackets;		/* total output packets */
	uint32	udps_fastout;		/* output packets on fast path */
#if defined(AG_EXTENSIONS)
    uint32  udps_fastin;		/* input packets on fast path */
#endif /* AG_EXTENSIONS */
};

extern struct	udpstat udpstat;

#endif 
