/* This file is combination of bsd.h netbsd.h openbsd.h */
/* Original bsd.h and netbsd.h are removed and the context */
/* of those two files are merged into this file. */


/*=========================== following is from generic.h ===============*/
#define bsdlike 1

/* nlist symbols in ip.c */
#define IPSTAT_SYMBOL "ipstat"
#define IP_FORWARDING_SYMBOL "ipforwarding"
#define TCP_TTL_SYMBOL "tcpDefaultTTL"

/* nlist symbols in interfaces.c */
#define IFNET_SYMBOL "ifnet"
#define IFADDR_SYMBOL "in_ifaddr"

/* nlist symbols in at.c */
#define ARPTAB_SYMBOL "arptab"
#define ARPTAB_SIZE_SYMBOL "arptab_size"

/* load average lookup symbol */
#define LOADAVE_SYMBOL "avenrun"

/* nlist symbols in hr_proc.c and memory.c */
#define PHYSMEM_SYMBOL "physmem"
#define TOTAL_MEMORY_SYMBOL "total"
#define MBSTAT_SYMBOL "mbstat"
#define SWDEVT_SYMBOL "swdevt"
#define FSWDEVT_SYMBOL "fswdevt"
#define NSWAPFS_SYMBOL "nswapfs"
#define NSWAPDEV_SYMBOL "nswapdev"

/* process nlist symbols. */
#define NPROC_SYMBOL "nproc"
#define PROC_SYMBOL "proc"

/* icmp.c nlist symbols */
#define ICMPSTAT_SYMBOL "icmpstat"

/* tcp.c nlist symbols */
#define TCPSTAT_SYMBOL "tcpstat"
#define TCP_SYMBOL "tcb"

/* upd.c nlist symbols */
#define UDPSTAT_SYMBOL "udpstat"
#define UDB_SYMBOL "udb"

/* var_route.c nlist symbols */
#define RTTABLES_SYMBOL "rt_table"
#define RTHASHSIZE_SYMBOL "rthashsize"
#define RTHOST_SYMBOL "rthost"
#define RTNET_SYMBOL "rtnet"

/* udp_inpcb list symbol */
#define INP_NEXT_SYMBOL inp_next
#define INP_PREV_SYMBOL inp_prev



/*=========================== following is from bsd.h ===============*/
/* #include "generic.h"  it's in this file above... */

/* the bsd route symbol adds an 's' at the end to this symbol name */
#undef RTTABLES_SYMBOL
#define RTTABLES_SYMBOL "rt_tables"

/* BSD systems use a different method of looking up sockaddr_in values */
#define NEED_KLGETSA 1

/* ARP_Scan_Next needs a 4th ifIndex argument */
#define ARP_SCAN_FOUR_ARGUMENTS 1

#define UTMP_HAS_NO_TYPE 1



/*=========================== following is from netbsd.h ============*/
#define PCB_TABLE 1
#undef TCP_SYMBOL
#define TCP_SYMBOL "tcbtable"
#undef TCP_TTL_SYMBOL
#define TCP_TTL_SYMBOL "ip_defttl"
#undef UDB_SYMBOL
#define UDB_SYMBOL "udbtable"
#undef NPROC_SYMBOL
#undef PROC_SYMBOL

#define MBPOOL_SYMBOL	"mbpool"
#define MCLPOOL_SYMBOL	"mclpool"

/* inp_next symbol */
#undef INP_NEXT_SYMBOL
#define INP_NEXT_SYMBOL inp_queue.cqe_next
#undef INP_PREV_SYMBOL
#define INP_PREV_SYMBOL inp_queue.cqe_prev
#define HAVE_INPCBTABLE 1

#define UTMP_FILE _PATH_UTMP

#ifndef netbsd1
# define netbsd1 1
#endif

/* fixups for broken AC_CHECK_IFNET_FOR() */
/* Remove when fixed in configure.in */
#undef STRUCT_IFNET_HAS_IF_BAUDRATE
#define STRUCT_IFNET_HAS_IF_BAUDRATE 1
#undef STRUCT_IFNET_HAS_IF_TYPE
#define STRUCT_IFNET_HAS_IF_TYPE 1
#undef STRUCT_IFNET_HAS_IF_IMCASTS
#define STRUCT_IFNET_HAS_IF_IMCASTS 1
#undef STRUCT_IFNET_HAS_IF_IQDROPS
#define STRUCT_IFNET_HAS_IF_IQDROPS 1
#undef STRUCT_IFNET_HAS_IF_NOPROTO
#define STRUCT_IFNET_HAS_IF_NOPROTO 1
#undef STRUCT_IFNET_HAS_IF_OMCASTS
#define STRUCT_IFNET_HAS_IF_OMCASTS 1
#undef STRUCT_IFNET_HAS_IF_IBYTES
#define STRUCT_IFNET_HAS_IF_IBYTES 1
#undef STRUCT_IFNET_HAS_IF_OBYTES
#define STRUCT_IFNET_HAS_IF_OBYTES 1

/*=========================== following is from openbsd.h ===========*/
#define UVM

#undef MBPOOL_SYMBOL
#undef MCLPOOL_SYMBOL
#undef TOTAL_MEMORY_SYMBOL

