/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: cache-sibyte.c,v 1.1 2002/09/07 01:33:22 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/23/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>

#ifdef SIBYTE

#define SIBYTE_CACHEOP(_op, _addr) {		\
	uint32  _r;								\
	__asm__ __volatile (					\
	"	.set noreorder	\n"					\
	"	and %0,%2,~0x1F	\n"					\
	"	and %0,%0,%0	\n"					\
	"	cache %1,0(%0)	\n"					\
	"	.set reorder	\n"					\
	: "=r" (_r) : "i" (_op), "r" (_addr));	\
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/23/02
 *
 *-----------------------------------------------------------------
 */
void
sibyte_cacheWritebackInv(
	address_t	_sa,
	uint32		_nbytes
)
{
	uint32  _clines, _i;
	address_t   _addr;

	if ((_sa) & CACHELINE_MASK)
		panic("unaligned invalidate command, 0x%x\n", (_sa));

	_clines = ((_nbytes) + (CACHELINE_SIZE - 1)) >> CACHELINE_SHIFT;

	for (_i = 0, _addr = (_sa); _i < _clines; _i++) {
		SIBYTE_CACHEOP(Hit_Writeback_Inv_D, _addr);
		_addr += CACHELINE_SIZE;
	}
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	8/23/02
 *
 *-----------------------------------------------------------------
 */
void
sibyte_cacheInvalidate(
	address_t	_sa,
	uint32		_nbytes
)
{
	uint32  _clines, _i;
	address_t   _addr;

	if ((_sa) & CACHELINE_MASK)
		panic("unaligned invalidate command, 0x%x\n", (_sa));

	_clines = ((_nbytes) + (CACHELINE_SIZE - 1)) >> CACHELINE_SHIFT;

	for (_i = 0, _addr = (_sa); _i < _clines; _i++) {
		SIBYTE_CACHEOP(Hit_Invalidate_D, _addr);
		_addr += CACHELINE_SIZE;
	}
}

#endif

