/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: chassis-strings.c,v 1.4 2002/07/04 02:10:05 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/24/02
 *
 *-----------------------------------------------------------------
 */

#include <stdio.h>
#include <nfx-incl.h>
#include <exports/cm-api.h>

char * chassis_ui_getModuleString(int);
char * chassis_ui_getCPUString(int, int);
char * chassis_ui_getCPUState(int);

static char * cpuStateStr[16] = {
    CM_SLICE_STATE_NOT_PRESENT_STR,
    CM_SLICE_STATE_PROM_INIT_STR,
    CM_SLICE_STATE_PROM_NO_AUTOBOOT_STR,
    CM_SLICE_STATE_PROM_CRASHED_STR,
    CM_SLICE_STATE_PROM_LOADING_STR,
    CM_SLICE_STATE_SWITCH_TO_RUNTIME_STR,
    CM_SLICE_STATE_RUNTIME_INIT_STR,
    CM_SLICE_STATE_RUNTIME_STR,
    CM_SLICE_STATE_RUNTIME_CRASHED_STR,
    CM_SLICE_STATE_RUNTIME_REBOOT_STR,
    CM_SLICE_STATE_RESET_WAIT_STR,
	"UNKNOWNB",
	"UNKNOWNC",
	"UNKNOWND",
	"UNKNOWNE",
	"UNKNOWNF",
};

static char * moduleNameStr[CM_NUM_CARDTYPES] = {
     CM_CARD_TYPE_SSC_STR,
     CM_CARD_TYPE_GARFIELD_STR,
     CM_CARD_TYPE_CHEETAH_STR,
     CM_CARD_TYPE_FCNIM_STR,
};

static char * cpuNameStr[CM_NUM_CARDTYPES][CM_NUM_CPUS] = {
	{
        CM_CPU_TYPE_SSC_STR,
        CM_CPU_TYPE_SSC_MGMT_STR,
        "UNKNOWN2",
        "UNKNOWN3"
    },
	{
        CM_CPU_TYPE_TXRX0_STR,
        CM_CPU_TYPE_TXRX1_STR,
        CM_CPU_TYPE_FP0_STR,
        CM_CPU_TYPE_FP1_STR
    },
	{
        CM_CPU_TYPE_TXRX0_STR,
        CM_CPU_TYPE_TXRX1_STR,
        CM_CPU_TYPE_FP0_STR,
        CM_CPU_TYPE_FP1_STR
    },
	{
        CM_CPU_TYPE_FC0_STR,
        CM_CPU_TYPE_FC1_STR,
        CM_CPU_TYPE_FC2_STR,
        CM_CPU_TYPE_FC3_STR
    }
};

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/24/02
 *
 *-----------------------------------------------------------------
 */
char *
chassis_ui_getModuleString(
	int		board_type
)
{
	if (board_type >= CM_NUM_CARDTYPES)
		return "UNKNOWN-Module";

	return moduleNameStr[board_type];
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/24/02
 *
 *-----------------------------------------------------------------
 */
char *
chassis_ui_getCPUString(
	int		board_type,
	int		cpu_num
)
{
	if ((board_type >= CM_NUM_CARDTYPES) || (cpu_num >= CM_NUM_CPUS))
		return "UNKNOWN-Cpu";

	return cpuNameStr[board_type][cpu_num];
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/24/02
 *
 *-----------------------------------------------------------------
 */
char *
chassis_ui_getCPUState(
	int		cpu_state
)
{
	if (cpu_state >= 16)
		return "UNKNOWN-State";

	return cpuStateStr[cpu_state];
}

