/*
 *-----------------------------------------------------------------
 *
 * Name:	cm-ui.c
 *
 * RCS:  $Id: cm-ui.c,v 1.7 2002/10/08 03:16:17 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/18/02
 *
 *-----------------------------------------------------------------
 */

#ifndef SSC

#include <nfx-incl.h>
#include <sys/bmfpga.h>
#include <exports/cm-api.h>
#include "cm.h"

#if defined(NFP_TXRX) || defined(FCNIM) || defined(SSC_MGMT)

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/25/02
 *
 *-----------------------------------------------------------------
 */
int32
do_chassis(
	int32	argc,
	uchar8	* argv[]
)
{
	uchar8	cmd[80];
	uint32	icmd;

	while (1) {
		printf("0. Change Board Type\n");
		printf("1. Change CPU State\n");
		printf("2. Set Temperature\n");
		printf("3. Set Power\n");
		printf("4. Send Message\n");
		printf("5. Toggle debug level\n");
		printf("99. quit\n");

		printf("Enter Selection > ");

		get_input(cmd);

		if (!strlen(cmd))
			continue;

		icmd = atoi(cmd);

		switch (icmd) {
			case 0:
#ifndef SSC_MGMT
					printf("Enter new board type (0 = SSC, 1 = Garfield, 2 = Cheetah, 3 = FCNIM) > ");
					get_input(cmd);
					icmd = atox(cmd);
					if ((icmd >= 0) && (icmd <= 3)) {
						bmfpga_setCardType(icmd);
					}
					else
						printf("Invalid selection, %d\n", icmd);
#else
					printf("unsupported\n");
#endif
					break;
			case 1:
#ifndef SSC_MGMT
					printf("Enter CPU state (0-9) > ");
					get_input(cmd);
					icmd = atox(cmd);
					if ((icmd >= 0) && (icmd <= 9)) {
						cmSetCPUState(icmd);
					}
					else
						printf("Invalid selection, %d\n", icmd);
#else
					printf("unsupported\n");
#endif
					break;
			case 2:
#ifndef SSC_MGMT
					printf("Enter new Temperature > ");
					get_input(cmd);
					icmd = atox(cmd);
					cmSetCardTemp(icmd);
#else
					printf("unsupported\n");
#endif
					break;
			case 3:
#ifndef SSC_MGMT
					printf("Enter new Power > ");
					get_input(cmd);
					icmd = atox(cmd);
					cmSetCardPower(icmd);
#else
					printf("unsupported\n");
#endif
					break;
			case 4:
#ifndef SSC_MGMT
					printf("Enter message > ");
					get_input(cmd);
					bmfpga_sendMessage(0, 0, (uint32 *)cmd, strlen(cmd));
#else
					printf("unsupported\n");
#endif
					break;
			case 5:
					if (cm_debug)
						cm_debug = 0;
					else
						cm_debug = 1;
					printf("cm_debug = %s\n", (cm_debug == 0) ? "OFF":"ON");
			case 99:
					return 0;
			default:
					printf("Invalid selection, %d\n\n", icmd);
		}
	}

	return 0;
}

#endif	/* NFP_TXRX || FCNIM || SSC_MGMT */

#endif	/* !SSC */

