/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2002, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-rpc-utils.h,v 1.1.1.1 2002/04/23 17:47:36 laurentb Exp $
 *
 * Name			: cifs-rpc-srvsvc.h
 *
 * Description	: Contains CIFS DCE/RPC utility functions header 
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 01/17/2002
 *
 *-----------------------------------------------------------------
 */

#ifndef _CIFS_RPC_UTILS_H
#define _CIFS_RPC_UTILS_H


/*-----------------------------------------------------------------
 * Name			: fillUniStrucWithoutAlloc
 *
 * Description	: fill a unicode structure without allocating memory
 * 					for the string
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 01/16/2002
 *
 *-----------------------------------------------------------------
 */
void
fillUniStrucWithoutAlloc(cifsrpc_uniStruc *usp, uni16 *str);


/*-----------------------------------------------------------------
 * Name			: fillUniStrucWithAlloc
 *
 * Description	: fill a unicode structure with allocating memory
 * 					for the string
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 01/16/2002
 *
 *-----------------------------------------------------------------
 */
void
fillUniStrucWithAlloc(cifsrpc_pipe *rpip, cifsrpc_uniStruc *usp, uni16 *str);


/*-----------------------------------------------------------------
 * Name			: strncpyFromUniStruc
 *
 * Description	: strncpy from an uniStruct structure
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 01/17/2002
 *
 *-----------------------------------------------------------------
 */
int32	//NFX_OK if fits, NFX_ERR if truncated
strncpyFromUniStruc(uni16 *dstp, cifsrpc_uniStruc *usp, uint32 maxLen);


#endif // #ifndef _CIFS_RPC_UTILS_H
