/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2002, Agile Storage Inc.
 *
 * RCS:  $Id: cifs-rpc-wkssvc.h,v 1.1.1.1 2002/04/23 17:47:36 laurentb Exp $
 *
 * Name			: cifs-rpc-wkssvc.h
 *
 * Description	: Contains CIFS DCE/RPC workstation services definitions.
 *
 * Created by	: Xiaobing Zhang
 *
 * Date Created	: 02/28/2002
 *
 *-----------------------------------------------------------------*/
   
#ifndef _CIFS_RPC_WKSSVC_H
#define _CIFS_RPC_WKSSVC_H

//Workstation services operation numbers
#define WKSSVC_QUERYINFO			0x00

//WKSSVC information level 100
typedef struct wkssvc_infoLv100
{
	uint32				platformId;
	uint32				serverNamep;
	uint32				domainNamep;
	uint32				majorVersion;
	uint32				minorVersion;
	cifsrpc_uniStruc	serverName;
	cifsrpc_uniStruc	domainName;
} wkssvc_infoLv100;

//WKSSVC queryInfo function call
typedef struct wkssvc_queryInfoCall
{
	uint32				serverNamep;		//name pointer
	cifsrpc_uniStruc	serverName;			//name
	ushort16			level;				//info level
} wkssvc_queryInfoCall;

//WKSSVC queryInfo function response
typedef struct wkssvc_queryInfoResp
{
	ushort16			level;			//Only support info level 100 for now
	uint32				ptr;
	wkssvc_infoLv100	wksInfoLv100;
	uint32				returnValue;
} wkssvc_queryInfoResp;

// WKSSVC subcommands
int32 wkssvc_queryInfo(cifsrpc_pipe *rpip);

//Workstation services api entry point function
int32 cifsrpc_wkssvc(cifsrpc_pipe *rpip);

#endif // #ifndef _CIFS_RPC_WKSSVC_H 

