/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-rpc.x,v 1.1.1.1 2002/04/23 17:47:36 laurentb Exp $
 *
 * Name			: cifs-rpc.x
 *
 * Description	: Contains CIFS RPC utility macros
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 12/11/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_RPC_X
#define _CIFS_RPC_X

//RPC Header offsets
#define RPCHO_MAJVERS		(0)
#define RPCHO_MINVERS		(1)
#define RPCHO_PKTYPE		(2)	
#define RPCHO_FLAGS			(3)
#define RPCHO_ENDIAN		(4)
#define RPCHO_FRAGLEN		(8)
#define RPCHO_AUTHLEN		(10)
#define RPCHO_CALLID		(12)

//RPC dummy pointer value
#define RPC_DUMMY_PTR	0x78563412

//Extraction macros taking into account the endian
#define GETXE2(d,o,bigEndian)	((bigEndian) ? GETBE2(d,o)  : GETLE2(d,o))
#define GETXE4(d,o,bigEndian)	((bigEndian) ? GETBE4(d,o)  : GETLE4(d,o))
#define GETXE2S(d,o,bigEndian)	((bigEndian) ? GETBE2S(d,o) : GETLE2S(d,o))
#define GETXE4S(d,o,bigEndian)	((bigEndian) ? GETBE4S(d,o) : GETLE4S(d,o))

#define PUTXE2(d,o,v,bigEndian)	 ((bigEndian) ? PUTBE2(d,o,v)  : PUTLE2(d,o,v))
#define PUTXE4(d,o,v,bigEndian)	 ((bigEndian) ? PUTBE4(d,o,v)  : PUTLE4(d,o,v))
#define PUTXE2S(d,o,v,bigEndian) ((bigEndian) ? PUTBE2S(d,o,v) : PUTLE2S(d,o,v))
#define PUTXE4S(d,o,v,bigEndian) ((bigEndian) ? PUTBE4S(d,o,v) : PUTLE4S(d,o,v))

//RPC types macros
#define GETENUMHANDLE(ehp)	(((ehp)->handlep) ? (ehp)->handle : 0)
#define SETENUMHANDLE(ehp, h)	\
	((ehp)->handlep = (((ehp)->handle = h) != 0) ? RPC_DUMMY_PTR : 0)
#define SETRPCPOINTER(pp, p)	((pp) = (p != NULL) ? RPC_DUMMY_PTR : 0)


#endif /* #ifndef _CIFS_UTILS_X */

