/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-ipc.h,v 1.1.1.1 2002/04/23 17:41:16 laurentb Exp $
 * 
 * Name			: cifs-ipc.h
 *
 * Description	: CIFS ipc related functions and definitions header
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 12/05/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_IPC_H
#define _CIFS_IPC_H

#define CIFS_NAMEDPIPESUBCMD_CALL			0x54
#define CIFS_NAMEDPIPESUBCMD_WAIT			0x52
#define CIFS_NAMEDPIPESUBCMD_PEEK			0x23
#define CIFS_NAMEDPIPESUBCMD_GETHANDSTATE	0x21
#define CIFS_NAMEDPIPESUBCMD_SETHANDSTATE	0x01
#define CIFS_NAMEDPIPESUBCMD_WAITHANDSTATE	0x53
#define CIFS_NAMEDPIPESUBCMD_QUERYINFO		0x22
#define CIFS_NAMEDPIPESUBCMD_TRANSAC		0x26
#define CIFS_NAMEDPIPESUBCMD_RAWREAD		0x11
#define CIFS_NAMEDPIPESUBCMD_RAWWRITE		0x31



void cifs_buildBrowseAnnouncementMsg(cifs_server *svp, cifs_cmdDesc *cmddp);


int32 cifsm_ipcNtCreateNX(	cifs_client *clp, 
							cifs_session *ssp,
							cifs_shareInUse *siup,
							cifs_operation *opp,
							uchar8 *icmdp,
							uchar8 *ocmdp);


int32 cifsm_ipcOpenNX(	cifs_client *clp,
						cifs_session *ssp,
						cifs_shareInUse *siup,
						cifs_operation *opp,
						uchar8 *icmdp,
						uchar8 *ocmdp);


int32 cifsm_ipcReadNX(	cifs_shareInUse *siup,
						cifs_operation *opp,
						uchar8 *icmdp,
						uchar8 *ocmdp,
						ushort16 fid);

int32 cifsm_ipcWriteNX( cifs_shareInUse *siup,
						cifs_operation *opp,
						uchar8 *icmdp,
						uchar8 *ocmdp,
						ushort16 fid);

int32 cifsm_ipcClose(cifs_shareInUse *siup, cifs_operation *opp, ushort16 fid);


void cifs_replyTransac( cifs_operation  *opp,
						uchar8          *parp,
						ushort16        paraToSendCnt,
						uchar8          *datp,
						ushort16        dataToSendCnt,
						boolean         moreData);


		
#endif

