/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Copyright (C) 2001, Agile Storage Inc.
 * 
 * RCS:  $Id: cifs-utils.h,v 1.1.1.1 2002/04/23 17:41:15 laurentb Exp $
 *
 * Name			: cifs-utils.h
 *
 * Description	: Contains CIFS utility functions.
 *
 * Created by	: Laurent Brard
 *
 * Date Created	: 11/07/2001
 *
 *-----------------------------------------------------------------
 */
#ifndef _CIFS_UTILS_H
#define _CIFS_UTILS_H



//Functions in cifs.c

void cifs_createEncryptionKey(char *encryptKey);

ushort16 cifs_newTid(cifs_client *clp);

ushort16 cifs_newUid(cifs_client *clp);

ushort16 cifs_newFid(cifs_shareInUse *siup);

int32 cifs_initServers(void);


//Functions in cifs-objects.c

int32 cifs_initObjects(void);

void cifs_closeOperation(cifs_operation *opp);

cifs_pipe *cifs_findShareInUsePipe(cifs_shareInUse *siup, ushort16 fid);

cifs_fileOpen *cifs_findFileOpenByFid(cifs_shareInUse *siup, ushort16 fid);

cifs_share *cifs_findServerShareByName(cifs_server *svp, uni16 *shareName);

cifs_share *cifs_findServerShareByThread(cifs_server *svp, esm_handle_t threadId);

cifs_shareInUse *
cifs_findClientSessionShareInUse(cifs_client *clp,
								cifs_session *ssp,
								ushort16 tid);

cifs_session *cifs_findClientSession(cifs_client *clp, ushort16 uid);

void cifs_abortClientConnection(cifs_client *clp);

cifs_server *cifs_createServer(cifs_serverCfg *svCfgp);

cifs_server *cifs_addServer(cifs_serverCfg *svCfgp);

cifs_share *cifs_addShare(cifs_server *svp, cifs_shareCfg *shCfgp);

cifs_client *cifs_addClient(cifs_server *svp);

cifs_session *cifs_addSession(cifs_client *clp);

cifs_shareInUse *cifs_addShareInUse(cifs_session *ssp);
		
cifs_pipe *cifs_addPipe(cifs_shareInUse *siup);

cifs_fileOpen *cifs_addFileOpen(cifs_shareInUse *siup);

void cifs_deleteShare(cifs_server *svp, cifs_share *shp);

void cifs_deleteServer(cifs_server *svp);

void cifs_closeClient(cifs_client *clp);

void cifs_closeClientSession(cifs_client *clp, cifs_session *ssp);
		
void cifs_closeSessionShareInUse(cifs_session *ssp, cifs_shareInUse *suip);
		
void cifs_closeShareInUsePipe(cifs_shareInUse *siup, cifs_pipe *pip);

void cifs_closeShareInUseFileOpen(cifs_shareInUse *siup, cifs_fileOpen *fop);	

cifs_search *cifs_addSearch(cifs_operation *opp);

cifs_search *cifs_findSearch(cifs_operation *opp, ushort16 sid);

void cifs_closeSearchBySid(cifs_shareInUse *siup, short16 sid);

void cifs_closeSearchByPtr(cifs_shareInUse *siup, cifs_search *searchp);


//Functions in cifs-utils.c

void memDump(void *address, uint32 size);

void memDumplight(void *address, uint32 size);
	
		

#endif /* #ifndef _CIFS_UTILS_H */

