
#define MHZ     250
#define RAMCYCLE    60          /* ~60ns dram cycle */
#define ROMCYCLE    1500            /* ~1500ns rom cycle */
#define CACHECYCLE  (1000/MHZ)      /* pipeline clock */
#define CYCLETIME   CACHECYCLE
#define CACHEMISS   (CYCLETIME * 6)


/* soft copies of the board registers are kept in low memory */
#define SOFTC_BASE  (0x180-16)
#define SOFTC_BCR0  0x0 /* bcr0 register */
#define SOFTC_BCR1  0x1 /* bcr1 register */
#define SOFTC_DCR0  0x2 /* dcr0 register */
#define SOFTC_DCR1  0x3 /* dcr1 register */
#define SOFTC_IMASK 0x4 /* icu mask registers (4b) */
#define SOFTC_MEMSZ 0x8 /* memory size in 4Mb units */

#ifndef __ASSEMBLER__
typedef struct p5064softc {
    unsigned char   bcr0;
    unsigned char   bcr1;
    unsigned char   dcr0;
    unsigned char   dcr1;
    unsigned int    imask;
    unsigned char   memsz;
} p5064softc;
#endif

#define DRAM_BASE	0x00000000
#define UART_BASE0	0x1d000000
#define UART_BASE1	0x1d000020

