/*------------------------------------------------------------------------------
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : evm-hash.h
 *
 * Description  : Volume Manager (EVM) - hash management
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 19-DEC-2001
 *
 *------------------------------------------------------------------------------
 */

#ifndef _EVM_HASH_H_
#define _EVM_HASH_H_

#include "nfx-incl.h"
#include "exports/hash-api.h"
#include "evm-io.h"
#include "evm-srvr-includes.h"

/*------------------------------------------------------------------------------
 * Function prototypes.
 *------------------------------------------------------------------------------
 */

uint32
evm_vol_hash(const void * key);

int32
evm_vol_compare(const void * obj1,
                const void * obj2);

void
evm_vol_release(void * key,
                void * obj);

uint32
evm_lun_hash(const void * key);

int32
evm_lun_compare(const void * obj1,
                const void * obj2);

void
evm_lun_release(void * key,
                void * obj);

/*----------------------------------------------------------------------------*/

#endif // _EVM_HASH_H_
