/*------------------------------------------------------------------------------
 * RCS:  $Id: evm-takeover.h,v 1.6 2002/09/15 00:51:48 isabellec Exp $
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Name         : evm-takeover.h
 *
 * Description  : Volume Manager (EVM) - volume takeover management
 *
 * Created by   : Isabelle Cnudde
 *
 * Date Created : 23-JAN-2002
 *
 *------------------------------------------------------------------------------
 */

#ifndef _EVM_TAKEOVER_H_
#define _EVM_TAKEOVER_H_

#include "nfx-incl.h"

/*------------------------------------------------------------------------------
 * Global variables.
 *------------------------------------------------------------------------------
 */

#define EVM_TK_TICK NFX_VOL_TSTAMP_PERIOD

/*------------------------------------------------------------------------------
 * Type definition.
 *------------------------------------------------------------------------------
 */

/*------------------------------------------------------------------------------
 * Function prototypes.
 *------------------------------------------------------------------------------
 */

int32
evm_tk_init(void);

void
evm_tk_clockTick(void);

int32
evm_takeoverVol(evm_MsgVolTakeover_t *  req,
                void (*callback) (evm_volId_t   volId,
#define EVM_TKO_OK          NFX_OK
#define EVM_TKO_GIVEUP      1
#define EVM_TKO_CONFLICT    2
                                  uint32        status,
                                  uint64        clientPrivate),
                boolean     checkOnly,
                char *      err);

/*----------------------------------------------------------------------------*/

#endif // _EVM_TAKEOVER_H_
