/*
 *-----------------------------------------------------------------
 *
 * Name:	exc-init.c
 *
 * RCS:  $Id: exc-init.c,v 1.7 2002/05/12 18:40:28 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	3/02/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include "except-api.h"
#include "except.h"

#if defined(R4000)
extern uchar8 _tlb_refill_exception[];
extern uchar8 _tlb_refill_end[];
extern uchar8 _xtlb_refill_exception[];
extern uchar8 _xtlb_refill_end[];
extern uchar8 _cache_error_exception[];
extern uchar8 _cache_error_end[];
extern uchar8 _general_exception[];
extern uchar8 _general_end[];
extern uchar8 _interrupt_exception[];
extern uchar8 _interrupt_end[];
#elif defined(TX3927)
extern uchar8 _utlb_refill_exception[];
extern uchar8 _utlb_refill_end[];
extern uchar8 _general_exception[];
extern uchar8 _general_end[];
#endif

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	3/2/02
 *
 *-----------------------------------------------------------------
 */
void
except_init()
{
	uint32	sr;

//	printf("[exc_init] Enter\n");

	/*
	 * Install exception handlers
	 */
#if defined(R4000)
	exc_install_handler((void *)PHYS_TO_K1(0x00000000), _tlb_refill_exception,
														_tlb_refill_end, 0x80);
	exc_install_handler((void *)PHYS_TO_K1(0x00000080), _xtlb_refill_exception,
														_xtlb_refill_end, 0x80);
	exc_install_handler((void *)PHYS_TO_K1(0x00000100), _cache_error_exception,
														_cache_error_end, 0x80);
	exc_install_handler((void *)PHYS_TO_K1(0x00000180), _general_exception,
														_general_end, 0x80);
	exc_install_handler((void *)PHYS_TO_K1(0x00000200), _interrupt_exception,
														_interrupt_end, 0x80);
#elif defined(TX3927)
	exc_install_handler((void *)PHYS_TO_K1(0x00000000), _utlb_refill_exception,
														_utlb_refill_end, 0x80);
	exc_install_handler((void *)PHYS_TO_K1(0x00000080), _general_exception,
														_general_end, 0x80);
#endif

	/*
	 * Initialize interrupt structures
	 */
	intr_init();

	/*
	 * Clear BEV bit in Status Register, exceptions now go to KSeg0
	 */
	sr = _mips_mfc0(C0_SR);
	sr &= ~SR_BEV;
	_mips_mtc0(C0_SR,sr);

//	printf("[exc_init] Leave\n");
}

