/*
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * $Id: proto.h,v 1.40 2002/11/26 22:54:07 bob Exp $
 */

/* buf.c */
void *new(int x);
fs_Buf *get_buf(uint64 blknum);
fs_Buf *alloc_buf(fs_Inode *inode);
void buf_dump(void);
/* main.c */
int main(int argc, char *argv[]);
/* emapleaf.c */
void fs_emapleaf_init(fs_Context *context, fs_Buf *buf);
void fs_emapleaf_compact_init(fs_Context *context, fs_Buf *buf);
fs_Bt_insert fs_emapleaf_insert(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *extentp0, boolean split_allowed, fs_Bt_insert_dispatch *insert);
fs_Bt_remove fs_emapleaf_remove(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *arg0, boolean dispose_allowed, fs_Bt_remove_dispatch *remove);
fs_Bt_eeksearch
fs_emapleaf_eek_mark(fs_Context *context,
		 fs_Inode *inode,
		 fs_Buf *buf,
		 int child_level,
		 uint64 key,
		 void *bitmap0,
		 fs_Bt_eek_dispatch *disp);
uint64 fs_emapleaf_search(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *pair0, fs_Bt_search_dispatch *search, boolean exclusive);
uint64 fs_emapleaf_walk(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *walk0, fs_Bt_search_dispatch *search, boolean exclusive);
fs_Bt_remove fs_emapleaf_shrink(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *arg0, boolean dispose_allowed, fs_Bt_remove_dispatch *remove);
fs_Bufpair fs_emapleaf_cleave(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *arg0, fs_Bt_cleave_dispatch *cleave);
uint64 fs_freeleaf_scan(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *cb0, fs_Bt_search_dispatch *search, boolean exclusive);
/* emapflatroot.c */
void fs_emaproot_spill(fs_Context *context, fs_Inode *inode);
void fs_emaproot_dispose(fs_Context *context, fs_Inode *inode, boolean walk, char *fmt, ...);
void fs_emap_flat_add(fs_Context *context, fs_Inode *inode, uint64 offset, fs_Extent extent);
uint64 fs_emap_flat_remove(fs_Context *context, fs_Inode *inode, uint64 offset);
fs_Emappair fs_emap_flat_lookup(fs_Context *context, fs_Emapflatroot *r, uint64 offset);
uint64 fs_emap_flat_shrink(fs_Context *context, fs_Inode *inode, uint64 offset);
fs_Extent fs_emap_flat_search_forward(fs_Context *context, fs_Inode *inode, fs_Block start, fs_Block end, boolean (*match)(fs_Extent extent, void *match_arg), void *match_arg);
boolean fs_emapflat_check_extents(fs_Context *context, fs_Inode *inode, boolean walk);
/* btree.c */
void fs_bt_init(fs_Context *context, fs_Buf *buf, int level);
uint64 fs_bt_search(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *data, fs_Bt_search_dispatch *search, boolean exclusive);
fs_Bt_insert fs_bt_insert(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *data, boolean split_allowed, fs_Bt_insert_dispatch *insert);
fs_Bt_remove fs_bt_remove(fs_Context *context, fs_Inode *inode, fs_Buf *buf, int level, uint64 key, void *data, boolean dispose_allowed, fs_Bt_remove_dispatch *remove);
