// -*- tab-width: 8; indent-tabs-mode: nil -*-
// ex: set tabstop=8 shiftwidth=4 expandtab:

/*
 * Name:  fs-arena.h
 *
 * RCS:  $Id: fs-arena.h,v 1.2 2001/09/04 18:34:10 haahr Exp $
 *
 * Description:  Temporary allocation arenas for context operations.
 * 
 * Created By:  Paul Haahr <haahr@agilestorage.com>
 *
 * Date Created:  2001-08-05
 */

#ifndef FS_ARENA_H
#define FS_ARENA_H


/**
 * Allocate memory which will be freed when this context goes away.
 */
extern void *fs_contextMemAlloc(
    fs_Context *context,
    uint32     bytes);


/**
 * Allocate zero-initialized memory will be freed when this context goes away.
 */
extern void *fs_contextMemAllocZeroed(
    fs_Context *context,
    uint32     bytes);


/**
 * Free the memory associated with the given context.
 */
extern void fs_contextMemFree(
    fs_Context *context);


#endif /* FS_ARENA_H */
