/*
 * Name		: fs-path.c
 * RCS		: $ID$
 * Description	: Support stucture for pathname parsing
 * Created by	: Rahul Khona
 * Date Created	: 8/15/2001
 */

#if !defined(SSC)

#include "fs-includes.h"

/*
 * Prepare to parse the pathname. Remove all leading / and \  to
 * begin with
 */

EXPORTED fs_path_t *
fs_makePath(char *data)
{
    int len = strlen(data);
	fs_path_t	*p = fs_ramAlloc(FS_RAM_MAKEPATH, sizeof (fs_path_t) + len);
	p->len = len;
	p->index = 0;
	strcpy(p->data, data);
	while (p->data[p->index] == '/' || p->data[p->index] == '\\') {
		p->data[p->index++] = 0;
	}
	return p;
}

EXPORTED void
fs_destroyPath(fs_path_t *path)
{
	fs_ramDealloc(FS_RAM_MAKEPATH, path);
}

EXPORTED char *
fs_getNextComponent(fs_path_t *path)
{
	
	int 	index = path->index;
	char	*data = &path->data[index];
	int		count = 0;
	if (path->index >= path->len || path->data[index] == '\0') {
		return NULL;
	}
	FS_TRACE(NULL, FS_TRACE_DUMP_RESTORE, ("index = %d", index));
	while (data[count] != '/' && data[count] != '\\' && index < path->len) {
		index++;
		count++;
		if (data[count] == '\0') {
			break;
		}
	}

	/*
	 * Don't bother reporting empty // or \\
	 */

	while (data[count] == '/' || data[count] == '\\') {
		data[count++] = 0;
		index++;
	}
	path->index = index;
	return data;
}

#endif // SSC
