/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: busclock.c,v 1.9 2002/11/07 01:18:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/22/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/hwMap.h>
#include <exports/cm-api.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include "gpp-defs.h"

uint32	busclock = 0;

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/1/02
 *
 *-----------------------------------------------------------------
 */
uint32
gpp_get_busclock()
{
	if ((((*(volatile uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE)) &
							GPP_FC123_CLK_MODE_MASK) >> GPP_FC123_CLK_MODE_SHIFT) ==
														GPP_FC123_CLK_MODE_125MHz)
		return 125;
	else
		return 100;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/1/02
 *
 *-----------------------------------------------------------------
 */
uint32
get_busclock()
{
#ifdef PROM
	uint32 bmfpga_get_busclock();

	if (isFC()) {
		if (isOldFC()) {
			uint32	config;
			config = _mips_mfc0(C0_CONFIG);
			if (((config & CFG_PIMASK) >> CFG_PISHIFT) == 1)
				busclock = 100;
			else
				busclock = 125;
		}
		else {
			if ((((*(volatile uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE)) &
								GPP_FC_SLICE_MASK) >> GPP_FC_SLICE_SHIFT) == 0)
				busclock = bmfpga_get_busclock();
			else
				busclock = gpp_get_busclock();
		}
	}
	else {
		busclock = bmfpga_get_busclock();
	}
#else
	if (busclock == 0) {
		extern uint32 get_busclock_mhz(void);

		busclock = get_busclock_mhz();
		if (busclock == 0) {			/* not yet implmented in jmptbl ? */
			busclock = 100;
		}
	}
#endif

	return busclock;
}

#ifndef PROM

/* SysClk to PipeClk ratio table */
struct ratio {char mult; char div;};
static const struct ratio ratios_rm7k[8] = {{2,1}, {3,1}, {4,1}, {5,2},
                                            {6,1}, {7,2}, {8,1}, {9,2}};

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/24/02
 *
 *-----------------------------------------------------------------
 */
uint32
get_pipefreq()
{
    unsigned int ec;
    const struct ratio *ratio;

	ec = (_mips_mfc0(C0_CONFIG) & CFG_ECMASK) >> CFG_ECSHIFT;

    ratio = &ratios_rm7k[ec];
    return ((get_busclock() * 1000000 * ratio->mult) / ratio->div);
}

#else

uint32
get_pipefreq()
{
    return (sbdpipefreq());
}

#endif
