/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: led.c,v 1.5 2002/11/07 01:18:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/9/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/hwMap.h>
#include <sys/led-api.h>
#include <sys/bmfpga.h>
#include <exports/cm-api.h>
#include "gpp-defs.h"

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	7/9/02
 *
 *-----------------------------------------------------------------
 */
void
led_set(
	int	led_state
)
{
    volatile uint32	gpp_value;
    volatile uint32 *base_p;

    if (isSSC()) {
        gpp_value = *(volatile uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE);

        if (led_state == LED_OK_ON) {
            gpp_value &= ~0x30000000;
            gpp_value |= 0x20000000;
        }
        if (led_state == LED_OK_OFF) {
            gpp_value &= ~0x30000000;
        }
        if (led_state == LED_FAULT_ON) {
            gpp_value &= ~0xC0000000;
            gpp_value |= 0x40000000;
        }
        if (led_state == LED_FAULT_OFF) {
            gpp_value &= ~0xC0000000;
        }
        if (led_state == LED_FAN_GREEN) {
            gpp_value &= ~0x03000000;
            gpp_value |= 0x02000000;
        }
        if (led_state == LED_FAN_RED) {
            gpp_value &= ~0x03000000;
            gpp_value |= 0x01000000;
        }
        *(volatile uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE) = gpp_value;
	}
    else if (isFC()) {
        volatile uint32 diag_leds;

        /* it maybe too early for nfxMyCPUId use chassis mgmt fct */
        if (cmGetMyCPUId() == NFX_FCNIM_CTRL_CPU) {
            gpp_value = *(volatile uint32 *)PHYS_TO_K1(HW_BMFPGA_BASE + BMFPGA_REG_GPP_CTL_VAL_OFF);

            switch (led_state) {
            case LED_OK_ON:
                gpp_value &= ~BMFPGA_CTRL_FP_LED_OK_MASK;
                gpp_value |=  BMFPGA_CTRL_FP_LED_OK_GREEN;
                break;

            case LED_OK_OFF:
                gpp_value &= ~BMFPGA_CTRL_FP_LED_OK_MASK;
                break;

            case LED_FAULT_ON:
                gpp_value &= ~BMFPGA_CTRL_FP_LED_FLT_MASK;
                gpp_value |=  BMFPGA_CTRL_FP_LED_FLT_RED;
                break;

            case LED_FAULT_OFF:
                gpp_value &= ~BMFPGA_CTRL_FP_LED_FLT_MASK;
                break;
            }
            *(volatile uint32 *)PHYS_TO_K1(HW_BMFPGA_BASE + BMFPGA_REG_GPP_CTL_VAL_OFF) = gpp_value;
        }
        if (led_state < LED_DIAG_00)
            return;

        diag_leds = *(volatile  uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE);
        base_p = (volatile  uint32 *)PHYS_TO_K1(HW_GALILEO_BASE + GPP_VALUE);
        diag_leds = base_p[0];
        //printf("read %x from %p\n", diag_leds,&base_p[0]);

        switch (led_state) {
        case LED_DIAG_00:
            diag_leds &= ~GPP_FC_DIAG_LED_CPUOK_MASK;
            break;
        case LED_DIAG_01:
            diag_leds &= ~GPP_FC_DIAG_LED_DLINK_MASK;
            break;
        case LED_DIAG_02:
            diag_leds &= ~GPP_FC_DIAG_LED_CLINK_MASK;
            break;
        case LED_DIAG_03:
            diag_leds &= ~GPP_FC_DIAG_LED_2LINK_MASK;
            break;
        case LED_DIAG_04:
            diag_leds &= ~GPP_FC_DIAG_LED_ERR_MASK;
            break;
        case LED_DIAG_0F:
            diag_leds &= ~GPP_FC_DIAG_LED_ALL_MASK;
            break;
        case LED_DIAG_10:
            diag_leds |=  GPP_FC_DIAG_LED_CPUOK_MASK;
            break;
        case LED_DIAG_11:
            diag_leds |=  GPP_FC_DIAG_LED_DLINK_MASK;
            break;
        case LED_DIAG_12:
            diag_leds |=  GPP_FC_DIAG_LED_CLINK_MASK;
            break;
        case LED_DIAG_13:
            diag_leds |=  GPP_FC_DIAG_LED_2LINK_MASK;
            break;
        case LED_DIAG_14:
            diag_leds |=  GPP_FC_DIAG_LED_ERR_MASK;
            break;
        case LED_DIAG_1F:
            diag_leds |=  GPP_FC_DIAG_LED_ALL_MASK;
            break;
        }
        base_p[0] = diag_leds;
        //printf("wrote %x to %p\n", diag_leds, &base_p[0]);
    }
}

