/*
 *-----------------------------------------------------------------
 *
 * Name:	wd.c
 *
 * RCS:  $Id: wd.c,v 1.6 2002/11/07 01:18:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description: Watchdog implementation
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/mips.h>
#include <sys/gt64240r.h>
#include <exports/hwMap.h>

uint32	wd_cnt;

extern uint32	watchdog_state;

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */
void
wd_enable(
	uint32	nsec
)
{
	extern uint32 get_busclock(void);

	volatile uint32 * wdc = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + WATCHDOG_CONFIGURATION_REGISTER);

	wd_cnt = (nsec * get_busclock() * 1000000) >> 8;

	if (!watchdog_state) {
//printf("wd enable, wd_cnt = 0x%x\n", wd_cnt);
		*wdc = wd_cnt | 0x1000000;
		*wdc = wd_cnt | 0x2000000;
	}
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */
void
wd_disable()
{
	volatile uint32 * wdc = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + WATCHDOG_CONFIGURATION_REGISTER);

	if (watchdog_state) {
//printf("wd dis, wd_cnt = 0x%x\n", wd_cnt);
		*wdc = wd_cnt | 0x1000000;
		*wdc = wd_cnt | 0x2000000;
	}
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */
void
wd_kick()
{
	volatile uint32 * wdc = (volatile uint32 *)PHYS_TO_K1(
							HW_GALILEO_BASE + WATCHDOG_CONFIGURATION_REGISTER);
	extern uint32	watchdog_state;

	if (watchdog_state) {
		*wdc = wd_cnt | 0x4000000;
		*wdc = wd_cnt | 0x8000000;
	}
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	4/8/02
 *
 *-----------------------------------------------------------------
 */
void
wd_init()
{
	volatile uint32 * wdv =  (volatile uint32 *)PHYS_TO_K1(
								HW_GALILEO_BASE + WATCHDOG_VALUE_REGISTER);

	extern int32 get_wd_state();

	watchdog_state = get_wd_state();
	if (watchdog_state) {
		watchdog_disable();
	}
	*wdv = 0;
}

