/*
 *-----------------------------------------------------------------------------
 *
 * Name:	wwn.h
 *
 * RCS:		$Id: wwn.h,v 1.3 2002/06/06 03:23:07 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	WWN definitions
 *
 * Created by:	Radek Aster
 *
 * Date Created: 5/11/01
 *
 *-----------------------------------------------------------------------------
 */

#include <nfx-incl.h>

#ifndef __WWN_H__
#define __WWN_H__

typedef struct wwn {
	union {
		uint64	wwn;
		byte	octets[sizeof(uint64)];
		struct {
			ushort16	nport_identifier;
			byte		ieee_assigned[3];
			byte		company_assigned[3];
		} name;
	} u;
} wwn_t;

extern wwn_t null_wwn;
char * wwn_to_str (wwn_t *wwn, char *buf);

#define WWN_STR_LEN	 32

#define WWN_SET(_dest_, _src_)	  memcpy((_dest_), (_src_), sizeof(wwn_t))
#define WWN_EQUAL(_dest_, _src_) (memcmp((void *)(_dest_), (void *)(_src_), sizeof(wwn_t)) == 0)

#endif /* __WWN_H__ */
