/*
 *-----------------------------------------------------------------
 *
 * Name:	vs-hash.c
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2003, Agile Storage Inc.
 *
 * Description:	Virtual server hash table support functions
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	01/15/03
 *
 *-----------------------------------------------------------------
 */

/*
#include <nfx-incl.h>
#include <exports/hash-api.h>
#include <exports/malloc-api.h>
*/
#include "vs-hash.h"

/*-----------------------------------------------------------------
 * Name:	vs_hash_getNode()
 *
 * Description:	Allocate new hash node
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	01/15/03
 *
 *-----------------------------------------------------------------
 */
vs_ht_item_t *
vs_hash_getNode(void)
{
	return ((vs_ht_item_t *)eee_ramAlloc(sizeof(vs_ht_item_t)));

}	/* vs_hash_getNode */

/*-----------------------------------------------------------------
 * Name:	vs_hash_freeNode(np)
 *
 * Description: Deallocates node
 *
 * Created by:	Xiaobing Zhang
 *
 * Date Created:	01/15/03
 *
 *-----------------------------------------------------------------
 */
void
vs_hash_freeNode(
	vs_ht_item_t	* np
)
{
	eee_ramDealloc(np);

}	/* vs_hash_freeNode */

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
void
vs_hash_display(
	address_t	htp
)
{
	uint32	i;
	vs_ht_item_t	* np;

	printf("ht at %p\n", (void *)htp);
	printf("  ht array at %p(%p)\n", ((vs_ht_t *)htp)->head,
												&(((vs_ht_t *)htp)->head[0]));
	NFX_SPIN_LOCK(&((vs_ht_t *)htp)->ht_spin);
	for (i=0; i< ((vs_ht_t *)htp)->num_buckets; i++) {
		printf("%p  ", ((vs_ht_t *)htp)->head[i]);
		for (np = ((vs_ht_t *)htp)->head[i]; np != NULL; np = np->next) {
			printf("%d, %d, %d ", np->data.srvrIdx,
								  np->data.dataType,
								  np->data.idx);
		}
		printf("\n");
	}
	NFX_SPIN_UNLOCK(&((vs_ht_t *)htp)->ht_spin);

}	/* vs_hash_display */

