/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: hw-api.h,v 1.7 2002/11/07 17:54:09 sandrineb Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
#ifndef _HW_API_H
#define _HW_API_H

#include <exports/hwMap.h>

#ifdef LANGUAGE_C
int isFC(void);
int isOldFC(void);
int isSSC(void);
int isOldSSC(void);
#if !defined(NFP_TXRX) && !defined(NFP_FP)
int isTXRX(void);
int isFP(void);
#endif
extern int isCheetah(void);
// #define isCheetah() ( 1 )
int isSSCmgmt(void);
int isRecovBoot(void);
int isDiagJumpered(void);

void delay_us(uint32 us);
uint32 get_busclock(void);
#ifdef R7000
uint32 get_pipefreq(void);
#endif
#ifdef PROM
#ifdef SIBYTE
unsigned int  sbdpipefreq(void);
#else
unsigned long  sbdpipefreq(void);
#endif
#endif
#if defined(R7000) || defined(SIBYTE) || (defined(__OpenBSD__) && defined(_KERNEL))
int32 i2c(uint32 op, uchar8 bus, uchar8 i2c_addr, uchar8 byte_addr, uint32 len, uchar8 *buf);
#endif

void wd_enable(uint32 nsec);
void wd_disable(void);
void wd_kick(void); 
void wd_init(void);

void watchdog_init(void);
void watchdog_kick(void);
void watchdog_enable(int32	nsec);
void watchdog_disable(void);
void watchdog_stop(void) ;
void watchdog_restart(void);
void watchdog_view(void);
int32 watchdog_cmd(int32 argc, uchar8 * argv[]);

/*
 * jumptbl fcts
 */
#ifndef SSC_MGMT

uint32 get_busclock_mhz(void);
uint64 get_memorysize(void);
#else
uint32 get_memorysize(void);
#endif

#endif /* LANGUAGE_C */

#endif /* _HW_API_H */
