/*
 *-----------------------------------------------------------------
 *
 * Name:    memchr.c
 *
 * RCS:  $Id: memchr.c,v 1.1 2001/11/19 03:27:04 bob Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description: return a ptr to c in up to n bytes of p
 *              return NUL if not found
 *
 * Created by:  Bob Fozard
 *
 * Date Created:    11/16/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

void *
memchr(
    const void  *s,
    int         c,
    int         n)
{
    if (n != 0) {
        const unsigned char *p = s;

        do {
            if (*p++ == (unsigned char)c)
                return ((void *)(p - 1));
        } while (--n != 0);
    }
    return NULL;

} /* memchr */
