/*
 *-----------------------------------------------------------------
 *
 * Name:	memmove.c
 *
 * RCS:  $Id: memmove.c,v 1.2 2002/05/24 23:40:53 laurentb Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Bob Fozard
 *
 * Date Created:	11/5/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>


void *
memmove(
       void	*			d,
       const void	*	s,
       __SIZE_TYPE__	length
)
{
	char *dest = (char*)d;
	char *source = (char*)s;
    void *ret = dest;

    if (source < dest) {
        /* Moving from low mem to hi mem; start at end.  */
        for (source += length, dest += length; length; --length)
            *--dest = *--source;
    }
    else if (source != dest) {
        /* Moving from hi mem to low mem; start at beginning.  */
        for (; length; --length)
            *dest++ = *source++;
    }

    return ret;

}	/* memmove() */


