/*
 *-----------------------------------------------------------------
 *
 * Name:	strncmp.c
 *
 * RCS:  $Id: strncmp.c,v 1.2 2002/10/18 02:52:42 johnh Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	compares at most n characters
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/26/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

int32 
strncmp (
	const char8	* s1,
	const char8	* s2,
	int32	    n
)
{
	if (!s1 || !s2)
		return (0);

	while (n && (*s1 == *s2)) {
		if (*s1 == 0)
			return (0);
		s1++;
		s2++;
		n--;
	}

	if (n)
		return (*s1 - *s2);

	return (0);
}

