/*
 *-----------------------------------------------------------------
 *
 * Name:	strpat.c
 *
 * RCS:  $Id: strpat.c,v 1.1 2001/09/26 17:59:41 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	9/19/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

#define BANCHOR		(0x80|'^')
#define EANCHOR		(0x80|'$')

#define MAXLN	256

/** int strpat(p,pat) return 1 if pat matches p, else 0; wildcards * and ? */
int32 
strpat (
	char8	*s1,
	char8	*s2
)
{
	char8	*p, *pat;
	char8	*t, tmp[MAXLN];
	char8	src1[MAXLN], src2[MAXLN];

	if (!s1 || !s2)
		return (0);

	p = src1;
	pat = src2;
	*p++ = BANCHOR;
	while (*s1)
		*p++ = *s1++;
	*p++ = EANCHOR;
	*p = 0;
	*pat++ = BANCHOR;
	while (*s2)
		*pat++ = *s2++;
	*pat++ = EANCHOR;
	*pat = 0;

	p = src1;
	pat = src2;
	for (; *p && *pat;) {
		if (*pat == '*') {
			pat++;
			for (t = pat; *t && *t != '*' && *t != '?'; t++);
				strncpy (tmp, pat, t - pat);
			tmp[t - pat] = '\0';
			pat = t;
			t = strposn (p, tmp);
			if (t == 0)
				return (0);
			p = t + strlen (tmp);
		} else if (*pat == '?' || *pat == *p) {
			pat++;
			p++;
		} else
			return (0);
	}

	if (!*p && !*pat)
		return (1);
	if (!*p && *pat == '*' && !*(pat + 1))
		return (1);

	return (0);

}

