/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: shmem.c,v 1.4 2001/12/06 02:54:53 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

#ifdef SHMEM

#include "../sm-eee/eee-platform.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <errno.h>

main()
{
	int32	shmid;
	uchar8	* shmptr;
	uint32	done;
	struct shmid_ds	ssc_ds, nfp_ds, fcnim_ds;
	int32	rc;
	uint32	linux_test_running;
	uint32	ssc_last_count, nfp_last_count, fcnim_last_count;

	int32	shmid_txrx;
	int32	shmid_fp;
	int32	shmid_ssc;
	int32	shmid_ssc_mgmt;
	int32	shmid_fc1;
	int32	shmid_fc2;
	int32	shmid_fc3;
	int32	shmid_fc4;

	int32	shmid_ssc_wka;
	int32	shmid_nfp_wka;
	int32	shmid_fcnim_wka;

	int32	shmid_mp_ssc;
	int32	shmid_mp_txrx1;
	int32	shmid_mp_txrx2;
	int32	shmid_mp_fp1;
	int32	shmid_mp_fp2;
	int32	shmid_mp_fc1;
	int32	shmid_mp_fc2;
	int32	shmid_mp_fc3;
	int32	shmid_mp_fc4;

	int32	shmid_dp_txrx;
	int32	shmid_dp_fp;
	int32	shmid_dp_fc1;
	int32	shmid_dp_fc2;
	int32	shmid_dp_fc3;
	int32	shmid_dp_fc4;

	int32	sid_mp_ssc;
	int32	sid_mp_txrx1;
	int32	sid_mp_txrx2;
	int32	sid_mp_fp1;
	int32	sid_mp_fp2;
	int32	sid_mp_fc1;
	int32	sid_mp_fc2;
	int32	sid_mp_fc3;
	int32	sid_mp_fc4;

	int32	sid_dp_txrx;
	int32	sid_dp_fp;
	int32	sid_dp_fc1;
	int32	sid_dp_fc2;
	int32	sid_dp_fc3;
	int32	sid_dp_fc4;

	int32	sid_fwd_txrx;
	int32	sid_fwd_fp;

	shm_tx_t	* cptr;


	printf("\n\n");
/*
 * TXRX shared memory segment
 */
	if ((shmid = shmget(SHM_SEG_TXRX, SHM_SEG_PSM_SIZE_TXRX,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_TXRX);
	printf("TXRX     : PSM base at 0x%x\n", shmptr);
	shmid_txrx = shmid;

/*
 * FP shared memory segment
 */
	if ((shmid = shmget(SHM_SEG_FP, SHM_SEG_PSM_SIZE_FP,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_FP);
	printf("FP       : PSM base at 0x%x\n", shmptr);
	shmid_fp = shmid;

/*
 * SSC shared memory segment
 */
	if ((shmid = shmget(SHM_SEG_SSC, SHM_SEG_PSM_SIZE_SSC,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_SSC);
	printf("SSC      : PSM base at 0x%x\n", shmptr);
	shmid_ssc = shmid;

/*
 * SSC_MGMT shared memory segment
 */
	if ((shmid = shmget(SHM_SEG_SSC_MGMT, SHM_SEG_PSM_SIZE_SSC_MGMT,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_SSC_MGMT);
	printf("SSC_MGMT : PSM base at 0x%x\n", shmptr);
	shmid_ssc_mgmt = shmid;

/*
 * FC shared memory segments
 */
	if ((shmid = shmget(SHM_SEG_FC1, SHM_SEG_PSM_SIZE_FC,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_FC);
	printf("FC1 : PSM base at 0x%x\n", shmptr);
	shmid_fc1 = shmid;

	if ((shmid = shmget(SHM_SEG_FC2, SHM_SEG_PSM_SIZE_FC,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_FC);
	printf("FC2 : PSM base at 0x%x\n", shmptr);
	shmid_fc2 = shmid;

	if ((shmid = shmget(SHM_SEG_FC3, SHM_SEG_PSM_SIZE_FC,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_FC);
	printf("FC3 : PSM base at 0x%x\n", shmptr);
	shmid_fc3 = shmid;

	if ((shmid = shmget(SHM_SEG_FC4, SHM_SEG_PSM_SIZE_FC,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_PSM_SIZE_FC);
	printf("FC4 : PSM base at 0x%x\n", shmptr);
	shmid_fc4 = shmid;

	printf("\n\n");

/*
 * 130 lines
 * Allocate shared memory areas for Mgmt Plane messaging
 */
	if ((shmid = shmget(SHM_SEG_MP_SSC, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to SSC at 0x%x\n", shmptr);
	shmid_mp_ssc = shmid;

	if ((shmid = shmget(SHM_SEG_MP_TXRX1, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to TXRX1 at 0x%x\n", shmptr);
	shmid_mp_txrx1 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_TXRX2, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to TXRX2 at 0x%x\n", shmptr);
	shmid_mp_txrx2 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FP1, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FP1 at 0x%x\n", shmptr);
	shmid_mp_fp1 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FP2, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FP2 at 0x%x\n", shmptr);
	shmid_mp_fp2 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FC1, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FC1 at 0x%x\n", shmptr);
	shmid_mp_fc1 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FC2, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FC2 at 0x%x\n", shmptr);
	shmid_mp_fc2 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FC3, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FC3 at 0x%x\n", shmptr);
	shmid_mp_fc3 = shmid;

	if ((shmid = shmget(SHM_SEG_MP_FC4, SHM_SEG_MP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_MP_SIZE);
	printf("MP to FC4 at 0x%x\n", shmptr);
	shmid_mp_fc4 = shmid;

/*
 * 90 lines
 * Allocate shared memory areas for Data Plane messaging
 */
	if ((shmid = shmget(SHM_SEG_DP_TXRX, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to TXRX at 0x%x\n", shmptr);
	shmid_dp_txrx = shmid;

	if ((shmid = shmget(SHM_SEG_DP_FP, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to FP at 0x%x\n", shmptr);
	shmid_dp_fp = shmid;

	if ((shmid = shmget(SHM_SEG_DP_FC1, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to FC1 at 0x%x\n", shmptr);
	shmid_dp_fc1 = shmid;

	if ((shmid = shmget(SHM_SEG_DP_FC2, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to FC2 at 0x%x\n", shmptr);
	shmid_dp_fc2 = shmid;

	if ((shmid = shmget(SHM_SEG_DP_FC3, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to FC3 at 0x%x\n", shmptr);
	shmid_dp_fc3 = shmid;

	if ((shmid = shmget(SHM_SEG_DP_FC4, SHM_SEG_DP_SIZE,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_DP_SIZE);
	printf("DP to FC4 at 0x%x\n", shmptr);
	shmid_dp_fc4 = shmid;

	printf("\n\n");

/*
 * 48 lines
 * Well Known Address (WKA) shared memory segment
 */
	if ((shmid = shmget(SHM_SEG_SSC_WKA, SHM_SEG_SIZE_WKA,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_SIZE_WKA);
	printf("SSC WKA at 0x%x\n", shmptr);
	shmid_ssc_wka = shmid;

	if ((shmid = shmget(SHM_SEG_NFP_WKA, SHM_SEG_SIZE_WKA,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_SIZE_WKA);
	printf("NFP WKA at 0x%x\n", shmptr);
	shmid_nfp_wka = shmid;

	if ((shmid = shmget(SHM_SEG_FCNIM_WKA, SHM_SEG_SIZE_WKA,
									IPC_CREAT | SHM_R | SHM_W)) < 0) {
		printf("error in shmget, shmid = 0x%x\n", shmid);
		return 0;
	}
	if ((shmptr = shmat(shmid, 0, 0)) == (void *) -1) {
		printf("shmat error\n");
		return 0;
	}

	bzero(shmptr, SHM_SEG_SIZE_WKA);
	printf("FCNIM WKA at 0x%x\n", shmptr);
	shmid_fcnim_wka = shmid;

	printf("\n\n");

/*
 * Allocate and initialize semaphores for messaging queues
 */
	if ((sid_mp_ssc = semget(SEM_MP_SSC, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating SSC semaphore\n");
	if ((rc = semctl(sid_mp_ssc, 0, SETVAL, 1)) != 0)
		printf("MP_SSC semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_txrx1 = semget(SEM_MP_TXRX1, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating NFP_TX semaphore\n");
	if ((rc = semctl(sid_mp_txrx1, 0, SETVAL, 1)) != 0)
		printf("MP_TXRX1 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_txrx2 = semget(SEM_MP_TXRX2, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating NFP_RX semaphore\n");
	if ((rc = semctl(sid_mp_txrx2, 0, SETVAL, 1)) != 0)
		printf("MP_TXRX2 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fp1 = semget(SEM_MP_FP1, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating NFP_FP1 semaphore\n");
	if ((rc = semctl(sid_mp_fp1, 0, SETVAL, 1)) != 0)
		printf("MP_FP1 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fp2 = semget(SEM_MP_FP2, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating NFP_FP2 semaphore\n");
	if ((rc = semctl(sid_mp_fp2, 0, SETVAL, 1)) != 0)
		printf("MP_FP2 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fc1 = semget(SEM_MP_FC1, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FCNIM_FC1 semaphore\n");
	if ((rc = semctl(sid_mp_fc1, 0, SETVAL, 1)) != 0)
		printf("MP_FC1 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fc2 = semget(SEM_MP_FC2, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FCNIM_FC2 semaphore\n");
	if ((rc = semctl(sid_mp_fc2, 0, SETVAL, 1)) != 0)
		printf("MP_FC2 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fc3 = semget(SEM_MP_FC3, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FCNIM_FC3 semaphore\n");
	if ((rc = semctl(sid_mp_fc3, 0, SETVAL, 1)) != 0)
		printf("MP_FC3 semctl failed, rc = 0x%x\n", rc);

	if ((sid_mp_fc4 = semget(SEM_MP_FC4, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FCNIM_FC4 semaphore\n");
	if ((rc = semctl(sid_mp_fc4, 0, SETVAL, 1)) != 0)
		printf("MP_FC4 semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_txrx = semget(SEM_DP_TXRX, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_TXRX semaphore\n");
	if ((rc = semctl(sid_dp_txrx, 0, SETVAL, 1)) != 0)
		printf("DP_TXRX semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_fp = semget(SEM_DP_FP, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_FP semaphore\n");
	if ((rc = semctl(sid_dp_fp, 0, SETVAL, 1)) != 0)
		printf("DP_FP semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_fc1 = semget(SEM_DP_FC1, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_FC1 semaphore\n");
	if ((rc = semctl(sid_dp_fc1, 0, SETVAL, 1)) != 0)
		printf("DP_FC1 semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_fc2 = semget(SEM_DP_FC2, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_FC2 semaphore\n");
	if ((rc = semctl(sid_dp_fc2, 0, SETVAL, 1)) != 0)
		printf("DP_FC2 semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_fc3 = semget(SEM_DP_FC3, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_FC3 semaphore\n");
	if ((rc = semctl(sid_dp_fc3, 0, SETVAL, 1)) != 0)
		printf("DP_FC3 semctl failed, rc = 0x%x\n", rc);

	if ((sid_dp_fc4 = semget(SEM_DP_FC4, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating DP_FC4 semaphore\n");
	if ((rc = semctl(sid_dp_fc4, 0, SETVAL, 1)) != 0)
		printf("DP_FC4 semctl failed, rc = 0x%x\n", rc);

	if ((sid_fwd_txrx = semget(SEM_FWD_TO_TXRX, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FWD_TXRX semaphore\n");
	if ((rc = semctl(sid_fwd_txrx, 0, SETVAL, 1)) != 0)
		printf("FWD_TXRX semctl failed, rc = 0x%x\n", rc);

	if ((sid_fwd_fp = semget(SEM_FWD_TO_FP, 1, 0666 | IPC_CREAT)) == -1)
		printf("error creating FWD_FP semaphore\n");
	if ((rc = semctl(sid_fwd_fp, 0, SETVAL, 1)) != 0)
		printf("FWD_FP semctl failed, rc = 0x%x\n", rc);



	/* spin, while simulation is running */

	done = 0;
	linux_test_running = 0;
	ssc_last_count = 1;
	nfp_last_count = 1;
	fcnim_last_count = 1;
	while (!done)  {
		sleep(1);

		if (getchar() == '\n')
			done = 1;
#if 0
		rc = shmctl(shmid_ssc_wka, IPC_STAT, &ssc_ds);
		if (rc < 0) {
			printf("error in SSC shmctl, rc = 0x%x\n", rc);
			done = 1;
		}

		rc = shmctl(shmid_nfp_wka, IPC_STAT, &nfp_ds);
		if (rc < 0) {
			printf("error in NFP shmctl, rc = 0x%x\n", rc);
			done = 1;
		}

		rc = shmctl(shmid_fcnim_wka, IPC_STAT, &fcnim_ds);
		if (rc < 0) {
			printf("error in FCNIM shmctl, rc = 0x%x\n", rc);
			done = 1;
		}

		if (ssc_ds.shm_nattch > ssc_last_count) {
			printf("New client attached to SSC WKA shared memory segment\n");
			ssc_last_count = ssc_ds.shm_nattch;
			linux_test_running = 1;
		}
		if (ssc_ds.shm_nattch < ssc_last_count) {
			ssc_last_count = ssc_ds.shm_nattch;
			printf("client dettached from SSC WKA shared memory segment\n");
			if ((ssc_ds.shm_nattch == 1) &&
				(nfp_ds.shm_nattch == 1) &&
				(fcnim_ds.shm_nattch == 1)) {
				if (linux_test_running)
					done = 1;
			}
		}
		if (nfp_ds.shm_nattch > nfp_last_count) {
			printf("New client attached to NFP WKA shared memory segment\n");
			nfp_last_count = nfp_ds.shm_nattch;
			linux_test_running = 1;
		}
		if (nfp_ds.shm_nattch < nfp_last_count) {
			nfp_last_count = nfp_ds.shm_nattch;
			printf("client dettached from NFP WKA shared memory segment\n");
			if ((ssc_ds.shm_nattch == 1) &&
				(nfp_ds.shm_nattch == 1) &&
				(fcnim_ds.shm_nattch == 1)) {
				if (linux_test_running)
					done = 1;
			}
		}
		if (fcnim_ds.shm_nattch > fcnim_last_count) {
			printf("New client attached to FCNIM WKA shared memory segment\n");
			fcnim_last_count = fcnim_ds.shm_nattch;
			linux_test_running = 1;
		}
		if (fcnim_ds.shm_nattch < fcnim_last_count) {
			fcnim_last_count = fcnim_ds.shm_nattch;
			printf("client dettached from FCNIM WKA shared memory segment\n");
			if ((ssc_ds.shm_nattch == 1) &&
				(nfp_ds.shm_nattch == 1) &&
				(fcnim_ds.shm_nattch == 1)) {
				if (linux_test_running)
					done = 1;
			}
		}

#endif
	}

	if (shmctl(shmid_txrx, IPC_RMID, 0) == -1)
		printf("remove segment TXRX, error = 0x%x\n", errno);
	if (shmctl(shmid_fp, IPC_RMID, 0) == -1)
		printf("remove segment FP, error = 0x%x\n", errno);
	if (shmctl(shmid_ssc, IPC_RMID, 0) == -1)
		printf("remove segment SSC, error = 0x%x\n", errno);
	if (shmctl(shmid_ssc_mgmt, IPC_RMID, 0) == -1)
		printf("remove segment SSC_MGMT, error = 0x%x\n", errno);

	if (shmctl(shmid_ssc_wka, IPC_RMID, 0) == -1)
		printf("remove segment SSC WKA, error = 0x%x\n", errno);
	if (shmctl(shmid_nfp_wka, IPC_RMID, 0) == -1)
		printf("remove segment NFP WKA, error = 0x%x\n", errno);
	if (shmctl(shmid_fcnim_wka, IPC_RMID, 0) == -1)
		printf("remove segment FCNIM WKA, error = 0x%x\n", errno);

	if (shmctl(shmid_mp_ssc, IPC_RMID, 0) == -1)
		printf("remove segment DEST SSC, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_txrx1, IPC_RMID, 0) == -1)
		printf("remove segment DEST TX, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_txrx2, IPC_RMID, 0) == -1)
		printf("remove segment DEST RX, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fp1, IPC_RMID, 0) == -1)
		printf("remove segment DEST FP1, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fp2, IPC_RMID, 0) == -1)
		printf("remove segment DEST FP2, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fc1, IPC_RMID, 0) == -1)
		printf("remove segment DEST FC1, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fc2, IPC_RMID, 0) == -1)
		printf("remove segment DEST FC2, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fc3, IPC_RMID, 0) == -1)
		printf("remove segment DEST FC3, error = 0x%x\n", errno);
	if (shmctl(shmid_mp_fc4, IPC_RMID, 0) == -1)
		printf("remove segment DEST FC4, error = 0x%x\n", errno);

	if (shmctl(shmid_dp_txrx, IPC_RMID, 0) == -1)
		printf("remove segment DP TXRX, error = 0x%x\n", errno);
	if (shmctl(shmid_dp_fp, IPC_RMID, 0) == -1)
		printf("remove segment DP FP, error = 0x%x\n", errno);
	if (shmctl(shmid_dp_fc1, IPC_RMID, 0) == -1)
		printf("remove segment DP FC1, error = 0x%x\n", errno);
	if (shmctl(shmid_dp_fc2, IPC_RMID, 0) == -1)
		printf("remove segment DP FC2, error = 0x%x\n", errno);
	if (shmctl(shmid_dp_fc3, IPC_RMID, 0) == -1)
		printf("remove segment DP FC3, error = 0x%x\n", errno);
	if (shmctl(shmid_dp_fc4, IPC_RMID, 0) == -1)
		printf("remove segment DP FC4, error = 0x%x\n", errno);

	if (semctl(sid_mp_ssc, 0, IPC_RMID, 0) != 0)
		printf("MP_SSC semctl failed\n");
	if (semctl(sid_mp_txrx1, 0, IPC_RMID, 0) != 0)
		printf("MP_TXRX1 semctl failed\n");
	if (semctl(sid_mp_txrx2, 0, IPC_RMID, 0) != 0)
		printf("MP_TXRX2 semctl failed\n");
	if (semctl(sid_mp_fp1, 0, IPC_RMID, 0) != 0)
		printf("MP_FP1 semctl failed\n");
	if (semctl(sid_mp_fp2, 0, IPC_RMID, 0) != 0)
		printf("MP_FP2 semctl failed\n");
	if (semctl(sid_mp_fc1, 0, IPC_RMID, 0) != 0)
		printf("MP_FC1 semctl failed\n");
	if (semctl(sid_mp_fc2, 0, IPC_RMID, 0) != 0)
		printf("MP_FC2 semctl failed\n");
	if (semctl(sid_mp_fc3, 0, IPC_RMID, 0) != 0)
		printf("MP_FC3 semctl failed\n");
	if (semctl(sid_mp_fc4, 0, IPC_RMID, 0) != 0)
		printf("MP_FC4 semctl failed\n");

	if (semctl(sid_dp_txrx, 0, IPC_RMID, 0) != 0)
		printf("DP_TXRX semctl failed\n");
	if (semctl(sid_dp_fp, 0, IPC_RMID, 0) != 0)
		printf("DP_FP semctl failed\n");
	if (semctl(sid_dp_fc1, 0, IPC_RMID, 0) != 0)
		printf("DP_FC1 semctl failed\n");
	if (semctl(sid_dp_fc2, 0, IPC_RMID, 0) != 0)
		printf("DP_FC2 semctl failed\n");
	if (semctl(sid_dp_fc3, 0, IPC_RMID, 0) != 0)
		printf("DP_FC3 semctl failed\n");
	if (semctl(sid_dp_fc4, 0, IPC_RMID, 0) != 0)
		printf("DP_FC4 semctl failed\n");

	if (semctl(sid_fwd_txrx, 0, IPC_RMID, 0) != 0)
		printf("FWD_TXRX semctl failed\n");
	if (semctl(sid_fwd_fp, 0, IPC_RMID, 0) != 0)
		printf("FWD_FP semctl failed\n");

	printf("\n\n");
}

#endif	/* SHMEM */

