/* vi:ts=4
 *
 *-----------------------------------------------------------------
 *
 * Name:			lock-deadlock.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2002, ClariStor Inc.
 *
 * Description: Deadlock detection function prototypes.
 *
 * Created by:		Xiaobing Zhang
 *
 * Date Created:	01/06/2003
 *
 *-----------------------------------------------------------------
 */
#ifndef _LOCK_DEADLOCK_H
#define _LOCK_DEADLOCK_H

/*--------------------
 * Function prototypes
 *--------------------
 */
boolean
lock_detectDeadlock(lock_dependency_t   *dependencyListp,
					vs_mem_index_t      blockedOwnerIdx);

lock_dependency_t *
lock_createDependencyListOfPendLock(lock_fileLock_t    *fileLockp,
									void               *pendLockInfop,
									uint8              pendLockType,
									boolean            checkExclTree,
									boolean            checkSharedTree,
									vs_mem_index_t     *dependencyNodeIdxp);

int32
lock_incDependencyListOfBlockedOwner(vs_mem_index_t      lockOwnerIdx,
									 vs_mem_index_t      inDpndListIdx,
									 lock_dependency_t   *inDpndListp);

int32
lock_decDependencyListOfBlockedOwners(lock_fileLock_t    *fileLockp,
									  void               *delLockInfop,
									  uint8              delLockType);

int32
lock_delOwnersFmDependencyListOfBlockedOwners(lock_fileLock_t    *fileLockp,
											  ip_index_t         clientIpAddr);

#endif /*_LOCK_DEADLOCK_H*/

