/*
 *-----------------------------------------------------------------
 *
 * Name:	mdk-sub.c
 *
 * RCS:  $Id: mdk-sub.c,v 1.4 2002/07/08 21:04:25 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
uint32
mdk_get_req_tests(
	uchar8	* line,
	uchar8	* req,
	int32	min,
	int32	max
)
{
	uint32	cnt = 0;
	uchar8	* str;
	uint32 loop_flag = 0;

	mdkp->num_loops = 1;

	if (str = getToken(line)) {
		do {
			if (isdigit(str[0])) {
				if(!loop_flag)	{
					req[cnt] = atoi(str);
					if ((req[cnt] < min) || (req[cnt] > max)) {
						printf("Invalid test number, %d\n", req[cnt]);
						return 0;
					}
					cnt++;
				}
				else {
				    mdkp->num_loops = atoi(str);
					loop_flag = 0;
				}		
			}
			else if ((str[0] == 'l') || (str[0] == 'L')) {
					/* integer after the "l" is no of loops */
					loop_flag = 1;
			}
		} while (str = getToken(0));
	}

	return cnt;

}

uint32
mdk_get_loop_tests(
	uchar8	* line,
	uchar8	* req,
	int32	min,
	int32	max
)
{
	uint32	cnt = 0;
	uchar8	* str;


#if 0	
	if (str = getToken(line)) {
		do {
			if ((str[0] == 'l') || (str[0] == 'L')) {
					/* do nothing */
			}
			else if (isdigit(str[0])) {
                if (cnt == 0)
				    mdkp->num_loops = atoi(str);
                else {
					req[cnt-1] = atoi(str);
					if ((req[cnt-1] < min) || (req[cnt-1] > max)) {
						printf("Invalid test number, %d\n", req[cnt-1]);
						return 0;
					}
                }
				cnt++;
				}
		} while (str = getToken(0));
	}
#endif	
	return (cnt - 1);

}
/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
uint32
mdk_get_all_tests(
	mdk_package_t	** pkgPtr,
	uchar8			* req
)
{
	mdk_test_t	* test;
	uint32		cnt = 0;

	test = (*pkgPtr)->basicTests;
	while (test->testName != NULL) {
		req[cnt] = cnt;
		test++;
		cnt++;
	}
	return cnt;

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
mdk_test_t *
mdk_sub_get_test(
	mdk_package_t	** pkgPtr,
	uint32			num_basic,
	uint32			num_restr,
	uchar8			test_num
)
{
	if (test_num < num_basic)
		return (&((*pkgPtr)->basicTests[test_num]));
	else
		return (&((*pkgPtr)->restrictedTests[test_num - num_basic]));
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */
void
mdk_get_num_tests(
	mdk_package_t	** pkgPtr,
	uint32			* num_basic,
	uint32			* num_restr
)
{
	mdk_test_t	* testPtr;
	uint32		i;

	i = 0;
	testPtr = (*pkgPtr)->basicTests;
	if (testPtr) {
		while (1) {
			if (testPtr->testName != NULL) {
				testPtr++;
				i++;
			}
			else
				break;
		}
	}
	*num_basic = i;

	i = 0;
	testPtr = (*pkgPtr)->restrictedTests;
	if (testPtr) {
		while (1) {
			if (testPtr->testName != NULL) {
				testPtr++;
				i++;
			}
			else
				break;
		}
	}
	*num_restr = i;

}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/14/02
 *
 *-----------------------------------------------------------------
 */
int32
mdk_sub_do_cmd(
	mdk_package_t	** pkgPtr,
	uchar8			* line
)
{
	uchar8				req_tests[MDK_MAX_TESTS_PER_PACKAGE];
	uint32				num_tests_todo,num_loop_tests_todo;
	mdk_test_t			* testPtr;
	mdk_test_t	* prv_test;
	uint32				num_basic, num_restr;
	int32				rc = RET_PASSED;
	uint32 				i;
	
	mdk_get_num_tests(pkgPtr, &num_basic, &num_restr);

	if (line[0] == '\0')
		rc = RET_NOTHING;
	else {
		switch(line[0]) {
			case 'q':					/* quit the diags */
			case 'Q':
					rc = RET_QUIT;
					break;
			case 'a':					/* run acceptance test */
			case 'A':
					num_tests_todo = mdk_get_all_tests(pkgPtr, req_tests);
					mdk_run_sub_accept(	pkgPtr,
										req_tests,
										num_tests_todo,
										num_basic,
										num_restr);
					break;
			case 'h':					/* help */
			case 'H':
					mdk_help_sub(line,num_basic, num_restr, pkgPtr);
					/*mdk_help();*/
					break;
			case 'l':
			case 'L':
					printf("Please enter <tests> l <no of loops>!\n");
#if 0					
					num_loop_tests_todo = mdk_get_loop_tests(	line,
														req_tests,
														0,
														num_basic+num_restr-1);
					if(num_loop_tests_todo == 0)
						printf("Please enter <no of loops> <test>!\n");
					else if (num_loop_tests_todo > 1) {
						mdk_run_sub_accept(	pkgPtr,
											req_tests,
											num_loop_tests_todo,
											num_basic,
											num_restr);
					}
					else if (num_loop_tests_todo == 1) {
						testPtr = mdk_sub_get_test(	pkgPtr,
													num_basic,
													num_restr, 
													req_tests[0]);
						if (testPtr) {
							tp->loop_num = 0;
							for(i=0;i<mdkp->num_loops; i++) {
								testPtr->test_complt = 0;
								if(i==0)
									prv_test = 0;
								else
									prv_test = prv_test;
								if(prv_test) {
									while(!(prv_test->test_complt))
										eee_poll();
								}	
								mdk_run_test(pkgPtr, testPtr);
								rc = tp->testresult;
								tp->loop_num ++;
							}
						}
					}
#endif					
					break;
			case 'u':
			case 'U':
					rc = RET_TOP;
					break;
			case 'o':
			case 'O':
					mdk_set_options(pkgPtr);
					rc = RET_NOTHING;
					break;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
					num_tests_todo = mdk_get_req_tests(	line,
														req_tests,
														0,
														num_basic+num_restr-1);
					if (num_tests_todo > 1) {
						mdk_run_sub_accept(	pkgPtr,
											req_tests,
											num_tests_todo,
											num_basic,
											num_restr);
					}
					else if (num_tests_todo == 1) {
						testPtr = mdk_sub_get_test(	pkgPtr,
													num_basic,
													num_restr, 
													req_tests[0]);
						if (testPtr) {
							for(i=0;i<mdkp->num_loops;i++) {
								/*	
								testPtr->test_complt = 0;
								if(i==0)
									prv_test = 0;
								else
									prv_test = prv_test;
								if(prv_test) {
									while(!(prv_test->test_complt))
										eee_poll();
								}*/	
								mdk_run_test(pkgPtr, testPtr);
								prv_test = testPtr;
							}
						}	
					}
					break;
			default:
					printf("Invalid selection\n");
					break;
		}
	}

	if ((rc != RET_QUIT) && (rc != RET_TOP) && (rc != RET_NOTHING))
		get_continue();

	return (rc);
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */
int32
mdk_submenu(
	mdk_package_t	** pkgPtr
)
{
    uchar8  * line;
	int32	rc = 0;

	while ((rc != RET_QUIT) && (rc != RET_TOP)) {
		mdk_show_submenu(pkgPtr);

		line = mdk_get_line(MDK_CMD_LINESIZE);
		rc = mdk_sub_do_cmd(pkgPtr, line);
	}

	return rc;
}

