/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-mem.h,v 1.7 2002/08/28 22:27:42 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/30/02
 *
 *-----------------------------------------------------------------
 */

/* defined options used in mem test */
#define TP_VERBOSE		0
#define TP_CONT_DESP_ERR	1
#define TP_WALKING_ONES		2
#define TP_WALKING_ZEROS		3
#define TP_ADDRESS			4

/* Defined options used in loopback test */
#define TP_PKT_TRACE		1	
#define TP_LBPKT_CNT		2
#ifdef DIAG_SIBYTE
#define TP_LB_ON_FP		3
#elif defined (DIAG_R7000)
#define TP_LB_FC_PORT		3
#endif
#define TP_LB_DURATION		4

#define ERR_DATA_FAIL	(RET_TEST_ERR_BASE + 0)
#define ERR_DATA_FAIL_0	(RET_TEST_ERR_BASE + 1)
#define ERR_DATA_FAIL_1	(RET_TEST_ERR_BASE + 2)
#define ERR_ADDR_FAIL	(RET_TEST_ERR_BASE + 3)
#define ERR_TIMEOUT	(RET_TEST_ERR_BASE + 4)			
#define ERR_I2CADDR_FAIL (RET_TEST_ERR_BASE + 5)
#define ERR_READ_FAIL	(RET_TEST_ERR_BASE + 6)
#define ERR_WRITE_FAIL	(RET_TEST_ERR_BASE + 7)
#define ERR_UNEXPECTED_RESULT	(RET_TEST_ERR_BASE + 8)
#define ERR_PKT_FWD	(RET_TEST_ERR_BASE + 9)
#define ERR_PKTDROP	(RET_TEST_ERR_BASE + 10)
#define ERR_LPBKDATA	(RET_TEST_ERR_BASE + 11)

/* DALLAS TEMP CHIP Registers */
#define START_CONV 0xEE
#define READ_TEMP 0xAA

#define MDK_INTERPKTDELAY	500

typedef struct _sb_smbus_dev_t{
	uchar8 * dev_str;
	uchar8 dev_addr;
} sb_smbus_dev_t;

typedef struct _reg_tst{
	uint32 addr;
	uint32 res;
} reg_tst_t;

typedef struct _reginfo_t{
	uchar8 * rw;
	uint32 reg;
	uint32 expected;
	uint32 wbits;
	uint32 res;
} reginfo_t;


#ifdef DIAG_SIBYTE

/* For Cheetah: use MAC 0 and 2, for Garfield, use MAC 0 and 1 */
#define BC1250_MAC_CNT 		3

typedef struct mdk_bc1250Eth_test {

	        uint32 portUnderTest;
	        uint32 testState;                  
	        uint32 testMode;     
	        uint32 testPktCnt;
	        uint32 testPktSize;
	        uint32 testDestAddr;
	        uchar8 *testBuffer;
	        uint32 fVerify;
	        uint32 rxPktCnt;;
	        uint32 rxErrPktCnt;
	        uint32 rxByteCnt;
	        uint32 txPktCnt;
	        uint32 txByteCnt;
		uint32 timer;
} mdk_bc1250Eth_test_t;
#endif

typedef struct mdk_dp83820_test {
	uint32 testState;				
	uint32 testMode;		
	uint32 startPktSize;
	uint32 endPktSize;
	uint32 testPktCnt;
	uint32 testPktSize;
	uint32 testDestAddr;
	uint32 testStep;
	uchar8 *testBuffer;
	uint32 fVerify;

	uint32 rxPktCnt;;
	uint32 rxErrPktCnt;
	uint32 rxByteCnt;
	uint32 txPktCnt;
	uint32 txByteCnt;
	uint32 timer;
} mdk_dp83820_test_t;

#ifdef DIAG_R7000
typedef struct mdk_gt64240mii_test {
	uint32 testState;				
	uint32 testMode;		
#define GT_LB_TEST_INT		1
#define GT_LB_TEST_MAC		2
#define GT_LB_TEST_PHY		3
#define GT_LB_TEST_EXT		4
	uint32 testPktCnt;
	uint32 testPktSize;
	uint32 testDestAddr;
	uchar8 *testBuffer;
	uint32 fVerify;
	uint32 rxPktCnt;
	uint32 rxErrPktCnt;
	uint64 rxByteCnt;
	uint32 txPktCnt;
	uint64 txByteCnt;
	uint32 timer;
} mdk_gt64240mii_test_t;
#endif

#define TEST_DONE		1
#define TEST_INPROGRESS		2
#define TEST_VERIFY		3
#define TEST_CONTINUE		4
#define TEST_END		5

#define TEST_INT			1
#define TEST_EXT			2
#define TEST_PHY			3
#define TEST_LUC			4
#define TEST_MAC			5

typedef struct _mdk_loopback_t {
	uint32 state;
	uint32 timeout;
}mdk_loopback_t	;



