/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mdk-sb.c,v 1.6 2002/07/31 21:19:16 lipikaathome Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	1/29/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/mdk-api.h>
#include "mdk-mem.h"
#if defined (DIAG_SIBYTE)
#include "mdk-bmc12500-eth-mii.h"

#include <exports/i2c-api.h>
#include <exports/seep-api.h>
#include <exports/bmc12500-eth.h>
#include <sys/sb1250/sbmips.h>
#include <sys/sb1250/sb1250_smbus.h>


uint32 bmc_sel;
extern uint32 bmc12500Eth_rx_pkt_trace;
extern uint32 bmc12500Eth_tx_pkt_trace;
extern bc1250EthCfg_t *bcEthCfg[BC1250_MAC_CNT+1];

/* Max ports for TXRX: 4 + 1
 * Max ports for FP : 6
 * Max ports for FC : 4
 */ 
mdk_loopback_t mdk_testState[6];

uint32	time_handle_dp83820;
uint32	time_handle_port0;
uint32	time_handle_port1;
uint32	time_handle_port2;
uint32	time_handle_port3;
uint32	time_handle_port4;
uint32	time_handle_port5;
//static mdk_bc1250Eth_test_t mdk_bc1250Eth_testControl[BC1250_MAC_CNT];


/* Global Variables */
extern uint32 sb_conflict;

sb_smbus_dev_t sm_dev[] = {
	{"SEEP",0x50}, 
	{"DRAM Slot 1",0x54},
	{"DRAM Slot 2",0x55},
	{"DRAM Slot 3",0x56},
	{"DRAM Slot 4",0x57},
	{"DALLAS-1621 Board Temp",0x48}, 
	{"MAXIM-1617A RXTX Sibyte Temp",0x18},
	{"MAXIM-1617A FP-Sibyte Temp",0x1a},
	{NULL,NULL},
	};			 
		
#define MAX_DEV = (sizeof(sm_dev)) / (sizeof(sb_smbus_dev_t));

reginfo_t sb_bc5208[] = {
	{"r",0x2, 0x00000040,0,0}, 	
	{"r",0x3, 0x0000613d, 0,0},
	{"w",0x0, 0x0, 0x00006100,0},
	{NULL, NULL, NULL,NULL,NULL},
};
#define BC5208_REG_MAX		3

#define CFG_DRAM_SMBUS_CHANNEL	0
#define RLTS  0
#define RRTE  1
#define RLHN  5
#define RLLI  6
#define RRHI  7
#define RRLS  8

#define SKIP_TEST 1
int32
sb_pkg_init()
{
	tp->resultCnt = 1;
	tp->param[TP_LBPKT_CNT] = 10000;
	if(!time_handle_port0)
		time_handle_port0 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
	if(!time_handle_port1)
		time_handle_port1 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
	if(!time_handle_port2)
		time_handle_port2 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
	if(!time_handle_port3)
		time_handle_port3 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
	if(!time_handle_port4)
		time_handle_port4 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
	if(!time_handle_port5)
		time_handle_port5 = eee_timerCreate(MDK_INTERPKTDELAY, EEE_TIMER_ONCE);
}

/* MAIN TEST FUNCTIONS */

int32
sb_phy5208_test(
	mdk_test_params_t	* tp
)
{
	uint32 phy_id;
	uint32 rdata, sdata, odata;
	uint32 i,j=0;
	uchar8 * test;
	uint32 maxPHYcnt;
	uint32 rc;

	if(isFP()) {
			tp->testresult = RET_SKIP_TEST;
			return (tp->testresult);
	}
	if (isCheetah()) {
			test = "r";
			phy_id = 0x3;
			if (tp->param[TP_VERBOSE] == 1) {
					printf("\nBC5208:  Read/Write (phy id %08x)\n",phy_id);
					printf("=========================================================\n");
					printf("Register	Result	Expected	Received\n");
			}
			for(i=0;i<BC5208_REG_MAX;i++)
			{
				if(!(strcmp((sb_bc5208[i].rw),test))) {
					rdata  = (uint32)dp83820_readMII_common(phy_id, sb_bc5208[i].reg);
					if((rdata & 0x0000ffff) == sb_bc5208[i].expected)
						sb_bc5208[i].res = 1;
					else {	
						sb_bc5208[i].res = 0;	
						tp->result[0].addr[j] = sb_bc5208[i].reg;
						tp->result[0].exptd[j] = sb_bc5208[i].expected ;
						tp->result[0].rcvd[j] = rdata;	
						tp->testresult = ERR_DATA_FAIL;
						j++;
					}
					if (tp->param[TP_VERBOSE] == 1) {
						printf("%08x	%s	%08x	%08x\n",sb_bc5208[i].reg, 
								(sb_bc5208[i].res == 1)? "PASS":"FAIL" , 
								sb_bc5208[i].expected,rdata);}
				}
				else {
					sdata  = (uint32)dp83820_readMII_common(phy_id, sb_bc5208[i].reg);
					odata = sdata;
					sdata |= sb_bc5208[i].wbits;
					dp83820_writeMII_common(0, phy_id, sb_bc5208[i].reg, sdata);
					rdata  = (uint32)dp83820_readMII_common(phy_id, sb_bc5208[i].reg);
					if(rdata  == sdata) {
					sb_bc5208[i].res = 1;
						/* restore orig data */
						dp83820_writeMII_common(0, phy_id, sb_bc5208[i].reg, odata);
					}	
					else {	
						sb_bc5208[i].res = 0;	
						tp->result[0].addr[j] = sb_bc5208[i].reg;
						sb_bc5208[i].expected = sdata;;
						tp->result[0].exptd[j] = sb_bc5208[i].expected ;
						tp->result[0].rcvd[j] = rdata;	
						tp->testresult = ERR_DATA_FAIL;
						j++;
					}	
					if (tp->param[TP_VERBOSE] == 1) {
						printf("%08x	%s	%08x	%08x\n",sb_bc5208[i].reg, 
								(sb_bc5208[i].res == 1)? "PASS":"FAIL" , 
								sdata,rdata);}
				}	
			}
		}	
	if(tp->testresult != ERR_DATA_FAIL)
		tp->testresult = RET_PASSED;
	return (tp->testresult);
}

int32
sb_smbus_test(
	mdk_test_params_t	* tp
)
{
	int32 rc;
	uchar8   buf[4], data;
	uchar8   i2c_addr, byte_addr;
	uint32    i, j = 0,len, devMax;

	if(isTXRX())
		devMax = 8;
	else if(isFP())
		devMax = 5; /* Only SEEP and DRAM */

	for (i=0; i<devMax; i++)
	{
		i2c_addr = sm_dev[i].dev_addr; /* addr of device */
		byte_addr = 0x0 ; /* offset within dev reg */
		len = 1;
		rc = i2c(I2C_READ, i2c_addr, byte_addr, len, buf);
		if (rc < 0) {
			tp->result[0].addr[j] = sm_dev[i].dev_addr;
			tp->result[0].exptd[j] = 0;
			tp->result[0].rcvd[j] = 0;	
			if (tp->param[TP_VERBOSE] == 1) {
				printf("Error in I2C_READ at dev %s 0x%02x, rc = 0x%x\n", sm_dev[i].dev_str,tp->result[0].addr[j], rc);
			j++;
			}
			/* Don't return ERROR if we cannot find a DRAM in its slot */
			if((i2c_addr < 0x54) || (i2c_addr > 0x57))
			{		
				tp->testresult = ERR_I2CADDR_FAIL;
				//return (tp->testresult);
			}	
		}
		else
			if (tp->param[TP_VERBOSE] == 1) {
				printf("Dev %s at %04x passed.\n", sm_dev[i].dev_str, sm_dev[i].dev_addr);		
			}	
	}
	/* If not even 1 error, then return PASS */
	if(tp->testresult != ERR_I2CADDR_FAIL)
		tp->testresult = RET_PASSED;	

	return (tp->testresult);
}

int32	
verify_temp(mdk_test_params_t *tp, uchar8 add,uint32 test_stat)
{
	unsigned long base;
	//char8 local_temp, local_thigh, local_tlow;
	//char8 remote_temp, remote_thigh, remote_tlow;
	char8 board_temp;
	uchar8   buf[4];

	if(test_stat == SKIP_TEST)
		return(tp->testresult = RET_SKIP_TEST);

	base = PHYS_TO_K1(A_SMB_BASE(CFG_DRAM_SMBUS_CHANNEL));	

	/* For DALLAS chip*/
	
	i2c(I2C_READ, add, START_CONV, 1, buf);
	delay_us(300000);
	board_temp = sb1250_smbus_readbyte(base,add,READ_TEMP);

	if((board_temp < 5) || (board_temp > 50))
	{
		tp->testresult = ERR_DATA_FAIL_0;
		tp->result[0].addr[0] = board_temp;
	}
	else{
		tp->testresult = RET_PASSED;
		if (tp->param[TP_VERBOSE] == 1) 
			printf("Board Temp %d PASSED\n",board_temp);
	}
#if 0
	local_temp  = sb1250_smbus_readbyte(base,add,RLTS);
	remote_temp  = sb1250_smbus_readbyte(base,add,RRTE);
	printf("add : %02x local_temp %d remote_temp %d\n", add, local_temp, remote_temp);

	local_thigh  = sb1250_smbus_readbyte(base,add,RLHN);
	remote_thigh  = sb1250_smbus_readbyte(base,add,RRHI);

	local_tlow  = sb1250_smbus_readbyte(base,add,RLLI);
	remote_tlow  = sb1250_smbus_readbyte(base,add,RRLS);

	/* For now just give some reasonable temp */
	remote_tlow = 5;
	remote_thigh = 50;
	
	if(remote_temp > remote_thigh)
	{
		tp->testresult = ERR_UNEXPECTED_RESULT;
		/* panic ("TEMP ABOVE accepted range!") */
	}
	else if(remote_temp < remote_tlow)
	{
		tp->testresult = ERR_UNEXPECTED_RESULT;
		/* panic ("TEMP BELOW accepted range!") */
	}
	else
		tp->testresult = RET_PASSED;

	printf("remote temp %d, high %d, low %d\n", remote_temp, remote_thigh, remote_tlow);
	printf("local temp %d, high %d, low %d\n", local_temp, local_thigh, local_tlow);
#endif
	return(tp->testresult);
}

int32
sb_temp_test(
	mdk_test_params_t	* tp
)
{
	uint32 rc;
	if(isFP()) {
		/*	printf("This test is not supported from the FP.\n");*/	
		return (tp->testresult = RET_SKIP_FP);
	}	

	/* Get temperature for each device on board */
	rc = verify_temp(tp, 0x48,0);

	/* The other 2 temp devices have not been implemented yet */
	/*
	verify_temp(tp, sm_dev[2].dev_addr, SKIP_TEST);

	verify_temp(tp, sm_dev[3].dev_addr, SKIP_TEST);
	*/
	return(rc);
}	


int32
sb_phy_reg_test(
	mdk_test_params_t	* tp
)
{
	//int32 rc;
	int32 i;
	uint32 phyAddr;
	bc1250EthCfg_t *cfg;
	bc1250Eth_regs_t *r;

	if(isFP())
		return(tp->testresult = RET_SKIP_FP);

	if (isCheetah()) {
		for (i = 0x08; i <= 0x0b; i++) {
			if (tp->param[TP_VERBOSE] == 1) {
				printf("\nPHY REGISTER TEST (Phy Addr = 0x%x):\n", i);
				printf("=================================================\n");
				printf("Register\t Result\t Expected\t Received\n");
				printf("\n");
			}
			mdk_phy8353_reg_test(0, i);
			//printf("8353 Phy Id 0x%x: %x\n", i, val);
		}
		for (i = 0x10; i <= 0x13; i++) {
			if (tp->param[TP_VERBOSE] == 1) {
				printf("\nPHY REGISTER TEST (Phy Addr = 0x%x):\n", i);
				printf("=================================================\n");
				printf("Register\t Result\t Expected\t Received\n");
				printf("\n");
			}
			mdk_phy8353_reg_test(0, i);
			//printf("8353 Phy Id 0x%x: %x\n", i, val);
		}
		for (i = 0x18; i <= 0x1b; i++) {
			if (tp->param[TP_VERBOSE] == 1) {
				printf("\nPHY REGISTER TEST (Phy Addr = 0x%x):\n", i);
				printf("=================================================\n");
				printf("Register\t Result\t Expected\t Received\n");
			}
			mdk_phy8353_reg_test(0, i);
		}
	}
	else {
		/* for now just use MAC 0 !!!!!! */
		for(i=0;i<1;i++){
		cfg = bcEthCfg[i];	
		r = &cfg->regs;

		phyAddr = 8; /* PHYS connected to FP */

		for(i=0; i < 2; i++, phyAddr++) {
			if (tp->param[TP_VERBOSE] == 1) {
				printf("\nPHY REGISTER TEST (Phy Addr = 0x%x):\n", phyAddr);
				printf("=================================================\n");
				printf("Register\t Result\t Expected\t Received\n");
				printf("\n");
			}
			mdk_phy8353_reg_test(r, phyAddr);
		}

		phyAddr = 16; /* PHYS connected to TXRX */
		for(i=0; i < 2; i++, phyAddr++) {
			if (tp->param[TP_VERBOSE] == 1) {
				printf("\nPHY REGISTER TEST (Phy Addr = 0x%x):\n", phyAddr);
				printf("=================================================\n");
				printf("Register\t Result\t Expected\t Received\n");
				printf("\n");
			}
			mdk_phy8353_reg_test(r, phyAddr);
		}
		}
	}
	return (tp->testresult);
}

int32
sb_int_lb_test(
	mdk_test_params_t	* tp
)
{
	/* This is not supported yet */
	uint32 testMode;

	/*testMode = TEST_INT; */
	if (tp->param[TP_VERBOSE] == 1)
		printf("This test is not supported by SIBYTE yet.\n");
	return (tp->testresult = RET_SKIP_TEST);
}

/* FP */
int32
sb_phy_fp_lb_test_port0(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 0;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}


int32
sb_phy_fp_lb_test_port1(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 1;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_fp_lb_test_port2(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);

	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 2;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_fp_lb_test_port3(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 3;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_fp_lb_test_port4(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 4;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_fp_lb_test_port5(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	port = 5;
	//tp->param[TP_LB_ON_FP] = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

/* TXRX */
int32
sb_phy_lb_test_port0(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(isFP())
		return(tp->testresult = RET_SKIP_FP);
	port = 0;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_lb_test_port1(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(isFP())
		return(tp->testresult = RET_SKIP_FP);
	port = 1;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_lb_test_port2(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isFP())
		return(tp->testresult = RET_SKIP_FP);
	port = 2;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_phy_lb_test_port3(
	mdk_test_params_t	* tp
)
{
	uint32 port;

	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isFP())
		return(tp->testresult = RET_SKIP_FP);
	port = 3;
	sb_phy_lb_test(tp,port);
	return(tp->testresult = RET_SKIPPED);
}

int32
sb_set_fp_phy_lpbk(
	mdk_test_params_t	* tp
)
{
	uint32 phyAddr, tmp;
	bc1250EthCfg_t *cfg;
	uint32 i, j;

	if(isFP())
		return(tp->testresult = RET_SKIP_FP);

	cfg = bcEthCfg[0];
	if(isCheetah()) {
		for(j=0;j<2;j++) {
			if(j == 0)
				tmp = 0x8;
			else
				tmp = 0x18;	
			for(i=0;i<4;i++) {
				phyAddr = tmp + i;
				dp83820_writeMII_common(0, phyAddr, 0, 0x5140);
			}
		}
	}
	else {	
		phyAddr = 0x8;
		mdk_bmc12500Eth_mii_phyLoopback(cfg, 1, phyAddr);
		phyAddr = 0x9;
		mdk_bmc12500Eth_mii_phyLoopback(cfg, 1, phyAddr);
	}	
	return(tp->testresult = RET_PASSED);
}

int32
sb_reset_fp_phy_lpbk(
	mdk_test_params_t	* tp
)
{
	uint32 phyAddr, tmp;
	bc1250EthCfg_t *cfg;
	uint32 i, j;

	if(isFP())
		return(tp->testresult = RET_SKIP_FP);

	cfg = bcEthCfg[0];
	if(isCheetah()) {
		for(j=0;j<2;j++) {
			if(j == 0)
				tmp = 0x8;
			else
				tmp = 0x18;	
			for(i=0;i<4;i++) {
				phyAddr = tmp + i;
				dp83820_writeMII_common(0, phyAddr, 0, 0x1140);
			}
		}
	}
	else {	
		phyAddr = 0x8;
		mdk_bmc12500Eth_mii_phyLoopback(cfg, 0, phyAddr);
		phyAddr = 0x9;
		mdk_bmc12500Eth_mii_phyLoopback(cfg, 0, phyAddr);
	}	
	return(tp->testresult = RET_PASSED);
}


int32
sb_phy_lb_test(
	mdk_test_params_t	* tp,
	uint32 port
)
{
	/* This sets the PHYS 8353 into loopback */
	/* Which PHY is selected thru bcEthCfg.phy.addr */
	//uint32 i;
	bc1250EthCfg_t *cfg;
	uint32 testMode;
	uint32 phyAddr;
	uint32 mac;

	/* This does not work now! it should be <2 */
	testMode = TEST_PHY; /* 3 */
	if(isCheetah()) {
		if(isTXRX()) {	
			if((port == 0) || (port == 1))
				mac = 0;
			else if((port == 2) || (port == 3))
				mac = 2;
		}
		else if(isFP())	{
			if((port == 0) || (port == 1) ||(port == 2))
				mac = 0;
			else if((port == 3) || (port == 4) || (port == 5))
				mac = 2;
		}	
		cfg = bcEthCfg[mac];
	}	
	else
		cfg = bcEthCfg[port];

	/* only for txrx */
	if(port == 0)
		phyAddr = 0x10;
	else if(port == 1)
		phyAddr = 0x11;

	if(isCheetah()) {
		if(port == 2)
			phyAddr = 0x12;
		if(port == 3)
			phyAddr = 0x13;
	}		

	if(isTXRX())
		mdk_bmc12500Eth_mii_phyLoopback(cfg, BC1250_SET, phyAddr);

	if(!isCheetah())
		bmc12500Eth_setPromiscMode( cfg, BC1250_SET);

	/* To run loopback test */
	switch (tp->param[TP_PKT_TRACE]) {
		case 0:
			bmc12500Eth_rx_pkt_trace = 0;
			bmc12500Eth_tx_pkt_trace = 0;
			break;
		case 1:
			bmc12500Eth_rx_pkt_trace = 1;
			bmc12500Eth_tx_pkt_trace = 0;
			break;
		case 2:
			bmc12500Eth_rx_pkt_trace = 0;
			bmc12500Eth_tx_pkt_trace = 1;
			break;
		case 3:
			bmc12500Eth_rx_pkt_trace = 1;
			bmc12500Eth_tx_pkt_trace = 1;
			break;
		default: 
			printf("Invalid Entry: %d\n", tp->param[TP_PKT_TRACE]);
	}
	mdk_12500Eth_diagLBTest(cfg, testMode, port);
	tp->testresult = RET_SKIPPED;
	return;
}


int32
sb_ext_lb_test_port0(
	mdk_test_params_t	* tp
)
{
	sb_ext_lb_test_port(0, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port1(
	mdk_test_params_t	* tp
)
{
	sb_ext_lb_test_port(1, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port2(
	mdk_test_params_t	* tp
)
{
	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	sb_ext_lb_test_port(2, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port3(
	mdk_test_params_t	* tp
)
{
	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	sb_ext_lb_test_port(3, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port4(
	mdk_test_params_t	* tp
)
{
	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	sb_ext_lb_test_port(4, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port5(
	mdk_test_params_t	* tp
)
{
	if(!isCheetah())
		return(tp->testresult = RET_SKIP_TEST);
	if(isTXRX())
		return(tp->testresult = RET_SKIP_TEST);
	sb_ext_lb_test_port(5, tp);
	return(	tp->testresult = RET_SKIPPED);
}

int32
sb_ext_lb_test_port(
	uint32 			port,
	mdk_test_params_t	* tp
)
{
	bc1250EthCfg_t *cfg;
	uint32 testMode;

	testMode = TEST_EXT; 

	if(isCheetah()) {
		if(isTXRX()) {	
			if((port == 0) || (port == 1))
				cfg =  bcEthCfg[0];
			else if((port == 2) || (port == 3))
				cfg =  bcEthCfg[2];
		}
		if(isFP()) {	
			if((port == 0) || (port == 1) || (port == 2))
				cfg =  bcEthCfg[0];
			else if((port == 3) || (port == 4) || (port == 5))
				cfg =  bcEthCfg[2];
		}
	}
	else	
		cfg =  bcEthCfg[port];

	switch (tp->param[TP_PKT_TRACE]) {
			case 0:
				bmc12500Eth_rx_pkt_trace = 0;
				bmc12500Eth_tx_pkt_trace = 0;
				break;
			case 1:
				bmc12500Eth_rx_pkt_trace = 1;
				bmc12500Eth_tx_pkt_trace = 0;
				break;
			case 2:
				bmc12500Eth_rx_pkt_trace = 0;
				bmc12500Eth_tx_pkt_trace = 1;
				break;
			case 3:
				bmc12500Eth_rx_pkt_trace = 1;
				bmc12500Eth_tx_pkt_trace = 1;
				break;
			default: 
				printf("Invalid Entry: %d\n", tp->param[TP_PKT_TRACE]);
				break;
	}
	mdk_12500Eth_diagLBTest(cfg, testMode, port);
	if(sb_conflict)
		tp->result[port].testresult = RET_SKIPPED;
	else
		tp->testresult = RET_SKIPPED;
	return(tp->testresult);
}



#if 0 /* Needs to be modified for Cheetah */
int32
sb_loopbk_results(
	mdk_test_params_t	* tp
)
{
	mdk_bc1250Eth_test_t *pptc;
	uint32 portNo;

	if((mdk_testState[0].state == TEST_DONE) || (mdk_testState[0].state == TEST_INPROGRESS))
	{
		pptc = &mdk_bc1250Eth_testControl[0];
		portNo = 0;
	}
	else if((mdk_testState[1].state == TEST_DONE) || (mdk_testState[1].state == TEST_INPROGRESS))
	{	
		pptc = &mdk_bc1250Eth_testControl[1];
		portNo = 1;
	}
	mdk_bmc12500Eth_diagShowLbTestResults(pptc,portNo);
	return;
}
#endif

int32
sb_pkg_err(
	mdk_log_entry_t	* err
)
{

	uint32 i;
	uint32 num1 = 0;
	uint32 num2 = 0;

	switch (err->testresult) {
		case ERR_DATA_FAIL:
			if (tp->param[TP_VERBOSE] == 1) {
				printf("SB Register Test Failure : \n");
				printf("-------------------------------\n");
			        printf("addr	expected	got \n");
				while (err->result[0].addr[num1++]);
				for (i=0;i<(num1 - 1);i++) {
				printf("0x%x	 0x%x		0x%x\n",
					err->result[0].addr[i], err->result[0].exptd[i], err->result[0].rcvd[i]);}
			}
			break;	
		case ERR_I2CADDR_FAIL:
			if (tp->param[TP_VERBOSE] == 1) {
				printf("SmBUS Device Test Failure : \n");
				printf("-------------------------------\n");
				while (err->result[0].addr[num1++]);
				for (i=0;i<(num1);i++) {
				printf("addr : 0x%x\n",
					err->result[0].addr[i]);}
			}
				break;
		case ERR_TIMEOUT:
			if (tp->param[TP_VERBOSE] == 1) {
				printf("Loopback test timeout\n");
			}	
				break;
		case ERR_DATA_FAIL_0:
				printf("Temperature Failure : 
				Board Temp %d\n",err->result[0].addr[0]);
				break;
		case ERR_UNEXPECTED_RESULT:
			if (tp->param[TP_VERBOSE] == 1) 
				printf("\nResult not within expected limits.\n");
			break;
		case ERR_PKTDROP:
			if (tp->param[TP_VERBOSE] == 1) 
				printf("\nSome pkts have been dropped.\n");
			break;
		case ERR_LPBKDATA:
			if (tp->param[TP_VERBOSE] == 1) 
				printf("\nData corruption.\n");
			break;
		default:
				printf("Unknown error, testresult = 0x%x\n", err->testresult);
				break;
	}

	return 0;
}
#endif
