/*
 *------------------------------------------------------------------------------
 *
 * Name:	ndmp_debug.h
 *
 * RCS:		$Id: ndmp-debug.h,v 1.9 2002/12/05 19:46:09 anhv Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	NDMP debug definitions
 *
 * Created by:	Anh Vu
 *
 * Date Created: 02/18/02
 *
 *------------------------------------------------------------------------------
 */
#if !defined(_NDMP_DEBUG_H)
#define _NDMP_DEBUG_H_


extern int ndmp_dbg_level;
extern int ndmp_perf_meas;
extern int ndmp_loop_bk;
extern int ndmp_trace_msg;
extern int ndmp_trace_files;
extern int ndmp_restore_mode;
extern int ndmp_enabled;
extern int ndmp_hi_ver;

typedef enum ndmp_dbglevel {
    D_INFO = 1,
    D_MALLOC,
    D_DBG
} ndmp_dbgLevel;

#define NDMP_DBG_PRINTF(level, the_string) \
	if (ndmp_dbg_level >= level) printf the_string

#ifdef SSC
/*
 * Global MACRO's for malloc
 */
extern int ndmp_ssc_malloc;
extern int ndmp_ssc_free;

#define NDMP_SSC_ALLOC(_ptr, _type, _size)              \
{                                                       \
    _ptr = (_type *)malloc(_size);                      \
    if (_ptr != NULL)                                   \
        ndmp_ssc_malloc++;                              \
    NDMP_DBG_PRINTF(D_MALLOC, ("\nMalloc -> %s(line %d):  %d\n", __FILE__, __LINE__, ndmp_ssc_malloc)); \
}

#define NDMP_SSC_FREE(_ptr)                             \
{                                                       \
    if (_ptr != NULL)                                   \
    {                                                   \
        free(_ptr);                                     \
        _ptr = NULL;                                    \
        ndmp_ssc_free++;                                \
    	NDMP_DBG_PRINTF(D_MALLOC, ("\nFree -> %s(line %d):  %d\n", __FILE__, __LINE__, ndmp_ssc_free)); \
    }                                                   \
}
#endif

#endif /* _NDMP_DEBUG_H_ */
