/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: mbox.c,v 1.2 2002/11/21 01:36:51 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/15/02
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <sys/sb1250/sb1250_regs.h>

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/15/02
 *
 *-----------------------------------------------------------------
 */
void
sb1250_mbox_poke(
	uint32		which_core,
	void		* sm_struct_addr
)
{
	void	** mbox_addr;

	printf("sb1250_mbox_poke(%d, %p)\n", which_core, sm_struct_addr);

	mbox_addr = (void **)PHYS_TO_K1(A_IMR_REGISTER((long)which_core,R_IMR_MAILBOX_SET_CPU));

	*mbox_addr = sm_struct_addr;
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/12/02
 *
 *-----------------------------------------------------------------
 */
uint64
sb1250_mbox_peek(
	uint32	which_core
)
{
	uint64	* mbox_addr;

	mbox_addr = (uint64 *)PHYS_TO_K1(A_IMR_REGISTER((long)which_core,R_IMR_MAILBOX_CPU));

	return (*mbox_addr);
}

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/12/02
 *
 *-----------------------------------------------------------------
 */
void
sb1250_mbox_clear(
	uint32	which_core
)
{
	uint64	* mbox_addr;

	printf("sb1250_mbox_clear(%d)\n", which_core);

	mbox_addr = (uint64 *)PHYS_TO_K1(A_IMR_REGISTER((long)which_core,R_IMR_MAILBOX_CLR_CPU));

	*mbox_addr = 0xFFFFFFFFFFFFFFFFll;
}

