/*
 *-----------------------------------------------------------------
 *
 * Name:
 *
 * RCS:  $Id: smp-api.h,v 1.3 2002/11/26 22:23:10 rick Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	11/07/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _SMP_API_H
#define _SMP_API_H

#define SMP_NUM_CPUS	2

#define SMP_CLIENTPRIVATE_TLB_SIZE	0x10000		/* one of TLB pg sizes */

extern uchar8	smp_ClientPrivatePhysSpace[SMP_NUM_CPUS][SMP_CLIENTPRIVATE_TLB_SIZE*2];
extern uchar8	smp_stack[SMP_NUM_CPUS][STKSIZE];

int32
sb1250_getCoreId();

typedef struct smp_rfunc {
	address_t	func;
	uint32		arg0;
	uint32		arg1;
	uint32		arg2;
	uint32		arg3;
} smp_rfunc_t;

extern void smp_remote_function_call(
	uint32 which_core, uint32 num_args, char8 * func, ...
);
extern smp_rfunc_t *  smp_remote_function_poll(uint32 which_core);
extern int32 smp_remote_function_wait_to_clear(uint32 which_core);
extern void smp_remote_function_clear(uint32 which_core);

extern void sb1250_mbox_poke(uint32 which_core, void * sm_struct_addr);
extern smp_rfunc_t	* sb1250_mbox_peek(uint32 which_core);
extern void sb1250_mbox_clear(uint32 which_core);

#endif	/* _SMP_API_H */

