/*
 *-----------------------------------------------------------------
 *
 * Name:	env-api.h
 *
 * RCS:  $Id: env-api.h,v 1.7 2002/10/31 01:02:49 maximk Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	3/17/02
 *
 *-----------------------------------------------------------------
 */

#ifndef _ENV_API_H
#define _ENV_API_H

/*
 * BSD's LOADOPTIONS:
 *
 * m - multiuser
 * s - singleuser
 * a - ask for boot device names
 * A - do not ask for boot device names
 * d - use compiled default root
 * t - use the serial console (we do not have anything else, so this is ignored
 */

#define NUM_ENV_VARS		12
#define ENV_KEY_AUTOLOAD		0		/* "yes", "no" */
#define ENV_KEY_AUTOREBOOT		1		/* "yes", "no" */
#define ENV_KEY_LOAD_SRC		2		/* "disk", "net" */
#define ENV_KEY_LOAD_OPTS		3		/* see above */
#define ENV_KEY_BOOT_DEV		4		/* "wd0a", "wd1a", "sc1" */
#define ENV_KEY_UPGRADE_PROM	5		/* "yes", "no" */
#define ENV_KEY_RESET_ENV		6
#define ENV_KEY_AUTOLINKENABLE	7		/* "yes", "no" */
#define ENV_KEY_HW_QT_OPTION  	8		/* "off", "on" */
#define ENV_KEY_HW_FT_OPTION  	9		/* "off", "on" */
#define ENV_KEY_HW_DIAG_OPTION  10		/* "off", "on" */

#define ENV_VAL_LOAD_SRC_DISK	0
#define ENV_VAL_LOAD_SRC_NET	1
#define ENV_VAL_LOAD_OPTS_MULTI		0x1
#define ENV_VAL_LOAD_OPTS_DONT_ASK	0x2
#define ENV_VAL_LOAD_OPTS_DEFAULT	0x4
#define ENV_VAL_LOAD_OPTS_CONSOLE	0x8
#define ENV_VAL_BOOT_DEV_A		0
#define ENV_VAL_BOOT_DEV_B		1
#define ENV_VAL_BOOT_DEV_SC0	2

#define ENV_MAX_STR_LEN		20

typedef struct seepenv {
	uchar8	* key;
	uchar8	* val;
	uchar8	* values[5];
	void	(*view_func)(uchar8 * key, uchar8 * val, uchar8 ** values);
	int32	(*str_to_val_func)(int32 key, uchar8 * str,
										uchar8 ** values, uchar8 * val);
	void	(*val_to_str_func)(int32 key, uchar8 val,
										uchar8 ** values, uchar8 * str);
} seepenv_entry_t;

int32	seepenv_get(int32 key, uchar8 * val);
int32	seepenv_set(int32 key, uchar8 * val);
void	seepenv_show();
void	seepenv_reset();
int32	seepenv_get_key(uchar8 * str, int32 * key);
int32   check_env_autoreboot_flag(void);

#endif	/* _ENV_API_H */

