/*
 *-----------------------------------------------------------------
 *
 * Name:	gt64440-uart.h
 *
 * RCS:  $Id: $
 *
 * Copyright (C) 2004, OnStor Inc.
 *
 * Description: Contains data structure & definitions for 
 *              gt64440 debug mode uart.
 *
 * Created by:	Shaun Hui
 *
 * Date Created: 04/05/04
 *
 *-----------------------------------------------------------------
 */

#if defined(R9000)

typedef struct _gt64440_uart_t {
	uint32	mcr_lo;		/* main config reg. lo */
	uint32	mcr_hi;		/* main config reg. hi */
	uint32	pcr;		/* protocol config reg */
	uint32	ubsr;		/* uart break/shift reg */
	uint32	cr;		/* Command reg */
	uint32	mir;		/* max idle reg */
	uint32	cfr;		/* control filering reg */
	uint32	chr5;		/* uart control char regs 5-8 */
	uint32	chr6;
	uint32	chr7;
	uint32	chr8;
	uint32	adr;		/* address reg */
	uint32	esr;		/* event status reg */
} gt64440_uart_t;

#define GT_MPSC_0_BASE		(GT_BASE_ADDR + 0x8000)

#define GT_MPSC_MCRL_MODE_UART	0x00000004
#define GT_MPSC_MCRL_ET		0x00000040
#define GT_MPSC_MCRL_ER		0x00000080
#define GT_MPSC_MCRL_NLM	0x00000400

#define GT_MPSC_CFR_DBG_MODE	0x20000000
#define GT_MPSC_PCR_CL_8	0x00003000

#define GT_MPSC_CR_EH		0x80000000
#define GT_MPSC_CR_TCS		0x00000200
#define GT_MPSC_CR_CRD		0x02000000

#define GT_MPSC_CHR5_V 		0x00008000
#define GT_MPSC_CHR5_INT	0x00001000

#define GT_UART_BASE(chnl)	(GT_MPSC_0_BASE + (chnl*0x1000))

void gt64440_uart_init( volatile gt64440_uart_t *uart_p);


#endif	/* R9000 */
