/*
 *-----------------------------------------------------------------
 *
 * Name:	serio-api.c
 *
 * RCS:  $Id: serio-api.c,v 1.22 2002/12/05 06:46:30 tonyw Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6t/18/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>
#include <exports/serio-api.h>
#include <exports/rcon-api.h>
#include <exports/eee-poll.h>
#include <exports/cm-api.h>

// WTG
#if defined(PROM_SIBYTE_BC)
#include <sys/sb1250/sb1250_defs.h>
#include <exports/load-bobcat.h>
extern int ad_module_menu();   // Diag menu in sm-loader
extern uint32 load_bc_get_ssc_state();
extern uint32 load_bc_set_mod_state();
extern load_cb_t volatile *load_cb_p;
                                                                                                                              
#endif

int32	(*console_driver)(uint32 op, uint32 chan, int32 data);

extern  volatile uint32	inDebugger;
#ifdef R9000
// Bobcat has 2 NS16550 UARTs for debugger
// SSC use uart 0, FC use uart 1
int32   (*dbg_console_driver)(uint32 op, uint32 chan, int32 data);
void    dbg_console_init(int chan);

#else

#define dbg_console_driver      console_driver

#endif

int32	serio_inited = 0;

#ifdef SIBYTE
uint32	sb1250_cable_installed[2] = {1,1};
#endif


/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:
 *
 *-----------------------------------------------------------------
 */
void
serio_init()
{
	extern int32 sb1250_uart(uint32 op, uint32 chan, int32 data);
	extern int32 gt64240_console(uint32 op, uint32 chan, int32 data);
	extern int32 st16552(uint32 op, uint32 chan, int32 data);
	extern int32 tx3927_uart(uint32 op, uint32 chan, int32 data);
	extern int32 ns16550(uint32 op, uint32 chan, int32 data);
	extern int32 gt64440_uart(uint32 op, uint32 chan, int32 data);

#ifdef PROM_R9000
#ifdef EVAL_BOARD
	console_driver = ns16550;
#else
	console_driver = gt64440_uart;
	gt64440_uart(OP_INIT, 0, 0);
	gt64440_uart(OP_INIT, 1, 0);

// This is 3 4Andy
        dbg_console_init(0); // init both channels
        dbg_console_init(1);
        
#endif
#else
	if (serio_inited)
		return;
#ifndef LINUX_TEST
#ifdef SIBYTE

	console_driver = sb1250_uart;

#ifndef PROM
printf("\n\n\nEnabling RTS/CTS, if card stops working here, check modem control settings\n\n\n");
	sb1250_uart(OP_INIT, 0, 57600);
	sb1250_uart(OP_INIT, 1, 57600);

{
uint32	i;
for (i=0; i<10000000; i++);

putchar(' ');
sb1250_cable_installed[0] = 0;
for (i=0; i<10000000;i++) {
if (*(volatile uint64 *)PHYS_TO_K1(0x10060120) & 0x8) {
	sb1250_cable_installed[0] = 1;
	break;
}
}
alt_tty_putchar(' ');
sb1250_cable_installed[1] = 0;
for (i=0; i<10000000;i++) {
if (*(volatile uint64 *)PHYS_TO_K1(0x10060220) & 0x8) {
	sb1250_cable_installed[1] = 1;
	break;
}
}
}
#endif

#elif defined(EVAL_BOARD)

	console_driver = st16552;

#elif defined(SSC_MGMT)

	console_driver = tx3927_uart;

#else

	console_driver = gt64240_console;
	gt64240_console(OP_INIT, 0, 0);
#if defined(PROM) || defined(EXCEPTIONS_IN_KSEG0)
	gt64240_console(OP_INIT, 1, 0);
#endif

#ifdef PROM
	while (char_avail())
		getchar();
	while (alt_tty_char_avail())
		alt_tty_getchar();
#endif

#endif
#endif	/* !LINUX_TEST */
#endif

	serio_inited = 1;

}	/* serio_init() */

#if defined(EVAL_BOARD) || defined(AGILE_HARDWARE)
/*-----------------------------------------------------------------
 * Name:	getchar()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
getchar()
{
	int32	chan;
	int32	rc;


#ifdef NFX_SMP
	chan = nfxMyCoreId;
#else
	chan = 0;
#endif

breakback:
	if (!rcon)	{
		while (!(*console_driver)(OP_RXRDY, chan, 0))
		{
		    if (rcon)   /* rcon happens */
			    goto breakout;	

#ifdef NFX_SMP
			if ((inDebugger) && (inDebugger != nfxMyCPUId)) {
				watchdog_stop();
				while ((inDebugger) && (inDebugger != nfxMyCPUId));
				watchdog_restart();
			}
#endif
		
		    eee_poll(100);
#if defined(PROM_SIBYTE_BC)
                    // WTG Add a way for SSC to interrupt the Console port to run diag cmds
                    if( isTXRX() ) {
                        load_cb_p = (load_cb_t *)(HW_OC_SRAM_BASE_FROM_TXRX + LOAD_BC_SRAM_OFFSET);
                        if( load_bc_get_ssc_state(1) == LOAD_BC_STATE_DIAG_INIT) {
                            printf("\n Request from SSC -Diag Menu-\n");
                            ad_module_menu(); // Go to diag Menu mode wait for cmds from SSC
                            //  We cam from the Prom prompt.. let them know it on return
                            printf(" cmGetCPUState = %d \n", cmGetCPUState( 1, 0));
                            if((cmGetCPUState( 1, 0) == CM_SLICE_STATE_PROM_CRASHED) || 
                               (cmGetCPUState( 1, 0) == CM_SLICE_STATE_RESET_WAIT)) {
                                printf("\n  -TXRX is at DEBUG PROMPT \n");
                                load_bc_set_mod_state(1, LOAD_BC_STATE_DIAG_PROM_CRASHED);
                            }
                            else {
                                // we are at normal prom prompt 
                                load_bc_set_mod_state(1, LOAD_BC_STATE_DIAG_PROM_PROMPT);
                            }
                            printf(" Return from Diag Menu\n");
                        }
                    }
                    if( isFP() ) {
                        load_cb_p = (load_cb_t *)(HW_OC_SRAM_BASE_FROM_TXRX + LOAD_BC_SRAM_OFFSET);
                        if( load_bc_get_ssc_state(2) == LOAD_BC_STATE_DIAG_INIT )  {
                            printf("\n Request from SSC -Diag Menu-\n");
                            ad_module_menu(); // Go to diag Menu mode wait for cmds from SSC
                            //  We cam from the Prom prompt.. let them know it on return
                            printf(" cmGetCPUState = %d \n", cmGetCPUState( 1, 2));
                            if((cmGetCPUState( 1, 2) == CM_SLICE_STATE_PROM_CRASHED) || 
                               (cmGetCPUState( 1, 2) == CM_SLICE_STATE_RESET_WAIT)) {
                                printf("\n  -FP is at DEBUG PROMPT \n");
                                load_bc_set_mod_state(2, LOAD_BC_STATE_DIAG_PROM_CRASHED);
                            }
                            else {
                                load_bc_set_mod_state(2, LOAD_BC_STATE_DIAG_PROM_PROMPT);
                            }
                            printf(" Return from Diag Menu\n");
                        }
                    }
#endif

		}

                rc = (*console_driver)(OP_RX, chan, 0);
                /* 
                 * check for escape sequences from keyboard 
                 * looking for up-arrow, down-arrow, left-arrow, 
                 * and right-arrow only
                 *  Up arrow = "ESC [ A"  or 0x1b 0x5b 0x41
                 */
                if (rc == 0x1b) {  //Looking for ESC / CTRL'[' / 033
                    while (!(*console_driver)(OP_RXRDY, chan, 0))
                        ; // wait for the next char
                    rc = (*console_driver)(OP_RX, chan, 0);
                    if (rc == 0x5b) {  // Looking for char '['
                        while (!(*console_driver)(OP_RXRDY, chan, 0))
                            ; // wait for the next char
                        rc = (*console_driver)(OP_RX, chan, 0);
                        if (rc == 0x41)       //Looking for char 'A'
                            return(0x1b5b41); //"up-arrow (hex value)"
                        else if (rc == 0x42)  //Looking for char 'B'
                            return(0x1b5b42); //"down-arrow"
                        else if (rc == 0x43)  //Looking for char 'C'
                            return(0x1b5b43); //"left-arrow"
                        else if (rc == 0x44)  //Looking for char 'D'
                            return(0x1b5b44); //"right-arrow"
                        else
                            return(rc);
                    }
                    else
                        return(rc);
                }
                else
                    return(rc);

	}

breakout:
/* rcon case below: */

	while (!rcon_user_buf_len) {
		/*  if console driver is ready see if console_driver has a CTRL-B */
		if ((*console_driver)(OP_RXRDY, chan, 0))
		   if ('@' == (*console_driver)(OP_RX, chan, 0))
			{
				rcon_send_end_connection(0,NFX_SSC_UNIX);
				rcon = 0;
			}
		if (!rcon) /*in case rcon is squashed while in wait state */
			goto breakback;
		eee_poll(100);
	}

	rc =  rcon_getchar();

	return rc;

}	/* getchar() */

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
alt_tty_getchar()
{
	int32	chan;

#ifdef NFX_SMP
	if (nfxMyCoreId == 0)
		chan = 1;
	else
		chan = 0;
#else
//4Andy	chan = 1;
	chan = 0;
#endif

	while (!(*dbg_console_driver)(OP_RXRDY, chan, 0))
    {
		if (!inDebugger)
		{
			eee_poll(100);
		}
	}

	return ((*dbg_console_driver)(OP_RX, chan, 0));

}	/* getchar() */

/*-----------------------------------------------------------------
 * Name:	putchar()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
putchar(
	int32	c
)
{
	int32	chan;

#ifdef NFX_SMP
	chan = nfxMyCoreId;
#else
	chan = 0;
#endif

	while (!(*console_driver)(OP_TXRDY, chan, 0));

	(*console_driver)(OP_TX, chan, c);

	if (c == 0xa) {
		while (!(*console_driver)(OP_TXRDY, chan, 0));

		(*console_driver)(OP_TX, chan, 0xd);
	}
	return NFX_OK;

}	/* putchar() */

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
alt_tty_putchar(
	int32	c
)
{
	int32	chan;

#ifdef NFX_SMP
	if (nfxMyCoreId == 0)
		chan = 1;
	else
		chan = 0;
#else
// 4Andy	chan = 1;
	chan = 0;
#endif

	while (!(*dbg_console_driver)(OP_TXRDY, chan, 0));

	(*dbg_console_driver)(OP_TX, chan, c);

	if (c == 0xa) {
		while (!(*dbg_console_driver)(OP_TXRDY, chan, 0));

		(*dbg_console_driver)(OP_TX, chan, 0xd);
	}

	return NFX_OK;

}	/* putchar() */

/*-----------------------------------------------------------------
 * Name:	char_avail()
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
char_avail()
{
	int32	chan;

#ifdef NFX_SMP
	chan = nfxMyCoreId;
#else
	chan = 0;
#endif

	if (rcon)
		return (rcon_user_buf_len);
	else
		return((*console_driver)(OP_RXRDY, chan, 0));

}	/* char_avail() */

/*-----------------------------------------------------------------
 * Name:
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/14/01
 *
 *-----------------------------------------------------------------
 */
int32
alt_tty_char_avail()
{
	int32	chan;

#ifdef NFX_SMP
	if (nfxMyCoreId == 0)
		chan = 1;
	else
		chan = 0;
#else
//4Andy	chan = 1;
	chan = 0;
#endif

	return((*dbg_console_driver)(OP_RXRDY, chan, 0));

}	/* char_avail() */

#ifdef PROM_R9000
// Init GT UART to use debug mode.
// During WD/NMI, cannot use SDMA mode since
// SDMA pointers have been changed by BSD.
void
serio_reinit( void )
{
        extern int32 gt64440_uart(uint32 op, uint32 chan, int32 data);


        gt64440_uart(OP_INIT, 0, 0);
        console_driver = gt64440_uart;
}
#endif

#endif	/* EVAL_BOARD || AGILE_HARDWARE */

