/*
 *-----------------------------------------------------------------
 *
 * Name:	meminit.S
 *
 * RCS:  $Id: mem-init.S,v 1.1.1.1 2001/10/31 01:27:27 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	Initiliaze memory sections
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-target.h>
#include <sys/mips.h>

	.text

	.globl	meminit_data
	.globl	meminit_bss

/*-----------------------------------------------------------------
 * Name:	meminit_data()
 *
 * Description:	Initialize the data section of the PROM in memory
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_data
meminit_data:
	la		t0,etext
	addu	t0,15
	and		t0,~15
	la		t1,_fdata
	la		t2,edata

	.set noreorder
1:
	lw		t3,0(t0)
	sw		t3,0(t1)
	addu	t0,4
	addu	t1,4
	bltu	t1,t2,1b
	nop

	j		ra
	nop

	.set reorder

	.end	meminit_data

/*-----------------------------------------------------------------
 * Name:	meminit_bss()
 *
 * Description:	Initialize the bss section of the PROM in memory
 *
 * Created by:	Rick Lund
 *
 * Date Created:	6/18/01
 *
 *-----------------------------------------------------------------
 */
	.ent	meminit_bss
meminit_bss:
	la		v0,_fbss
	la		v1,end

    .set noreorder
1:
	sw		zero,0(v0)
    sw		zero,4(v0)
    sw		zero,8(v0)
	addu	v0,16
	bltu	v0,v1,1b
    sw		zero,-4(v0)			# BDSLOT

	j		ra
	nop

	.set	reorder

	.end	meminit_bss

