/*
 *------------------------------------------------------------------------------
 *
 * Name:	tape-device.h
 *
 * RCS:		$Id: tape-device.h,v 1.10 2002/11/01 19:29:15 raster Exp $
 *
 * Copyright (C) 2001, Agile Storage Inc.
 *
 * Description:	Tape driver device specific code definitions.
 *
 * Created by:	Radek Aster
 *
 * Date Created: 10/2/01
 *
 *------------------------------------------------------------------------------
 */

#ifndef __TAPE_DEVICE_H__
#define __TAPE_DEVICE_H__

int tape_parse_devicename(char *, scsi_id_t *, uint32 *);
int mc_parse_devicename(char *, scsi_id_t *);

sdm_relayCdbReqMsg_t *tape_build_scsi_tur_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_mode_sense_compression_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_mode_select_compression_msg(tape_dev_t *, sdm_relayCdbRspMsg_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_mode_select_dlteeprom_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_rewind_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_unload_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_load_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_read_position_msg(tape_dev_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_space_msg(tape_dev_t *, tape_space_req_msg_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_write_fms_msg(tape_dev_t *, tape_write_fm_req_msg_t *);
sdm_readDataReqMsg_t *tape_build_scsi_read_msg(tape_dev_t *, tape_read_req_msg_t *);
sdm_writeDataReqMsg_t*tape_build_scsi_write_msg(tape_dev_t *, tape_write_req_msg_t *);
sdm_relayCdbReqMsg_t *tape_build_scsi_passthru_msg(tape_dev_t *, tape_passthru_req_msg_t *);
sdm_relayCdbReqMsg_t *mc_build_scsi_passthru_msg(tape_dev_t *, mc_passthru_req_msg_t *);

uint32      tape_device_to_chandle(tape_dev_t *);
tape_dev_t *tape_chandle_to_device(uint32);

#endif /* __TAPE_DEVICE_H__ */
