/*
 *-----------------------------------------------------------------
 *
 * Name:	getword.c
 *
 * RCS:  $Id: getword.c,v 1.1.1.1 2001/07/04 00:44:57 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

/*-----------------------------------------------------------------
 * Name:	getword()
 *
 * Description: copies next word from p into dst, else rtns 0
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
char8 *
getword (
	char8	* dst,
	char8	* p
)
{
	char8	* a;

	if (!dst || !p)
		return (0);

	dst[0] = 0;
	while (isspace (*p))
		p++;
	if (*p == 0)
		return (0);
	a = p;
	while (!isspace (*p) && *p != 0)
		p++;
	strncpy (dst, a, p - a);
	dst[p - a] = 0;

	return (p);

}	/* getword() */

/*-----------------------------------------------------------------
 * Name:	wordsz()
 *
 * Description: return size of first word in p
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
int32 
wordsz (
	char8	* p
)
{
	int32	n;

	if (!p)
		return (0);

	while (isspace (*p))
		p++;
	for (n = 0; !*p && !isspace (*p); n++)
		p++;

	return (n);

}	/* wordsz() */

