/*
 *-----------------------------------------------------------------
 *
 * Name:	io.c
 *
 * RCS:  $Id: io.c,v 1.2 2002/09/27 22:30:51 rick Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */

#include <nfx-incl.h>

#ifdef LINUX_TEST

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <termios.h>

fd_set	rfds;


/*-----------------------------------------------------------------
 * Name:	cli_getchar()
 *
 * Description:	for LINUX test purposes, a non-blocking character read
 *				function.  If no character is pending, run the EEE layer
 *				polling loop.
 *
 * Created by:	Rick Lund
 *
 * Date Created:	5/31/01
 *
 *-----------------------------------------------------------------
 */
int32
cli_getchar()
{
	struct timeval  tv;
	int32			rc;
	int32			c;
	int32			col=0;
	uint32			counter=0;

	while (1) {
		/*
		 * check out read descriptor for tty
		 */
		FD_ZERO(&rfds);
		FD_SET(0, &rfds);

		/* return immediately */
		tv.tv_sec = 0;
		tv.tv_usec = 0;

		if ((rc = select(1, &rfds, NULL, NULL, &tv)) > 0) {
			if (!(FD_ISSET(0, &rfds)))
				printf("ERROR: c = 0x%x, but ISSET = 0\n");
			return (getchar());
		}
		else {
			if (counter++ == 2) {
				counter = 0;
				eee_poll(1);
			}
			if (FD_ISSET(0, &rfds))
				printf("ERROR: c = 0, but ISSET != 0\n");
		}
	}

}	/* cli_getchar() */

#endif	/* LINUX_TEST */

