// vi:ts=4
#include <stdio.h>

#include "exports/anpssc-api.h"
#include "exports/ea-api.h"

extern int
main(int argc, char *argv[])
{
	int sock;
	long long buf[1024];
	int rc;
	int cpu, slot, plane;
	char app[80];
	ea_mntFsysRsp_t *rsp = (ea_mntFsysRsp_t *)buf;
	ea_movInFsysReq_t *mi = (ea_movInFsysReq_t *)buf;
	ea_movInFsysRsp_t mi_rsp;

	sock = regAgileApp("ea");
	if (sock < 0) {
		perror ("Unable to register mountd");
		exit (1);
	}

	while (1) {
		rc = recvAgileMsg (sock, buf, sizeof(buf), NULL, 
		                   app, &cpu, &slot, &plane);

		switch (rsp->hdr.msgType) {

			case EA_UMNT_FSYS_REQ:

				printf ("%s: file system unmount req for: %s/%llx\n", argv[0],
				        ((ea_umntFsysReq_t *)buf)->fsysId.fsysName,
				        ((ea_umntFsysReq_t *)buf)->fsysId.volId.whole_thing);

				rsp->hdr.msgType = EA_UMNT_FSYS_RSP;
				break;

			case EA_MNT_FSYS_REQ:

				printf ("%s: file system mount req for: %s/%llx\n", argv[0],
				        ((ea_mntFsysReq_t *)buf)->fsysId.fsysName,
				        ((ea_mntFsysReq_t *)buf)->fsysId.volId.whole_thing);

				rsp->hdr.msgType = EA_MNT_FSYS_RSP;
				break;

			case EA_MOVIN_FSYS_REQ:
				printf ("%s: file system move in req for %s/%llx\n", argv[0],
				        mi->fsysId.fsysName, mi->fsysId.volId.whole_thing);

				mi_rsp.hdr.msgType = EA_MOVIN_FSYS_RSP;
				mi_rsp.hdr.userInfo = mi->hdr.userInfo;
				mi_rsp.result = NFX_OK;
				strcpy (mi_rsp.output, "You suck!");

				sendAgileMsg (-1, &mi_rsp, sizeof(mi_rsp), 
		              app, cpu, slot, plane,
                      NULL, NULL, 0);

				continue;

			default:
				
				printf ("%s unknown message id: %d\n", argv[0],
				        rsp->hdr.msgType);
				continue;

		}
		rsp->result = NFX_OK;

		sendAgileMsg (-1, buf, sizeof(ea_mntFsysRsp_t), 
		              app, cpu, slot, plane,
                      NULL, NULL, 0);

		printf ("%s: got %d(len %d), from %s:%d:%d\n", argv[0], *(int *)buf,
		        rc, app, slot, cpu);
	}
}
