// vi:ts=4
#include <stdio.h>

#include "exports/anpssc-api.h"
#include "exports/evm-api.h"
#include "../sm-ipm/ipm.h"

extern int
main(int argc, char *argv[])
{
	int sock;
	long long buf[1024];
	int rc;
	int cpu, slot, plane;
	char app[80];

	sock = regAgileApp("ipm");
	if (sock < 0) {
		perror ("Unable to register ipm");
		exit (1);
	}

	while (1) {
		rc = recvAgileMsg (sock, buf, sizeof(buf), NULL, 
		                   app, &cpu, &slot, &plane);

		switch (*(int *)buf) {

			case IPM_MSG_IP_DEL:
				printf ("%s got IP del msg\n", argv[0]);
				break;

			case IPM_MSG_IP_ADD:
				printf ("%s got IP add msg\n", argv[0]);
				break;

			case IPM_MSG_RT_ADD:
				printf ("%s got route add msg\n", argv[0]);
				break;

			default:
				printf ("%s: got %d(len %d), from %s:%d:%d\n", argv[0], 
				        *(int *)buf, rc, app, slot, cpu);
				continue;
		}

		((ipm_mhdr_t *)buf)->ipmh_flags = IPM_MSG_CMD_OK;
		sendAgileMsg (sock, buf, ((ipm_mhdr_t *)buf)->ipmh_size,
		              app, cpu, slot, plane, NULL, NULL, 0);
	}
}
