/* vi:ts=4
 *-----------------------------------------------------------------
 *
 * Name:	lnm-api.h
 *
 * RCS:  $Id: lnm-api.h,v 1.8 2002/08/26 21:14:19 gregs Exp $
 *
 * Copyright (C) 2001, Agile Storage, Inc.
 *
 * Description:	Exported API for the LNM module
 *
 * Created by:	Pankaj Gupta 
 *
 * Date Created:	11/05/01
 *
 *-----------------------------------------------------------------
 */

#ifndef _LNM_API_H
#define _LNM_API_H

#define	MAX_NODE_PER_CLUSTER	16

#define	LNM_MAX_CLUSTER_NAME		256
#define	LNM_MAX_NODE_NAME			256

/*
 * Message types for all communication with the
 * cluster module
 */

typedef enum {
	/*
	 * Cluster Control messages MAXIMUM of 10 unless you change nfx-defs.h
	 */
	CLUSTER_INIT_HELLO_MSG = CLUSTER_MSG_BASE,
	CLUSTER_NODE_HELLO_MSG,
	CLUSTER_ASSIGN_SCC_REQ,
	CLUSTER_FIND_PCC_REQ,
	CLUSTER_NODE_TIMEOUT_MSG
} cluster_msgType_t;

typedef struct {
	cluster_msgType_t	msgType;	// CLUSTER_NODE_TIMEOUT_MSG
	int					newTimeout;	// sec
} lnm_newTimeoutMsg_t;

#endif /* _LNM_API_H */
