/* vi:ts=4
*/
#include <stdio.h>
#include "nfxnis-api.h"
#include "nfxnis-loc.h"

// NOTE: This only works for little endian

static unsigned char cnetAddr[4] = { 192, 168, 1, 34 };
static unsigned char bnetAddr[4] = { 172, 16, 3, 1 };
static int *cAdd = (int *)cnetAddr;
static int *badd = (int *)bnetAddr;

#define IS_EQU(a, b)			\
if ((int)(a) != (int)(b)) {		\
	printf ("FAILED\n");		\
	exit(1);					\
}

int main()
{
	in_addr_t add;
	unsigned char *x = (unsigned char *)&add;
	char inp[10];

	fprintf (stdout, "Make sure the file %s looks like:\n\n", NFXNISCFG);
	fputs ("10\t\tagilestorage\t10.0.0.21\n", stdout);
	fputs ("172.16\t\tbnet\t\t172.16.2.1\n", stdout);
	fputs ("192.168.1\tcnet\t\t192.168.1.127\n", stdout);
	fputs ("\nPress the Enter key to continue\n", stdout);
	fgets (inp, sizeof(inp), stdin);

	add = nfxnis_hostAddr ("192.168.1.234", "tstsys");

	fputs ("Asking for tstsys exported via 192.168.1.234\n", stdout);
	fputs ("Should get: 192.168.1.34\n", stdout);
	fprintf (stdout, "Got: %d.%d.%d.%d\n\n", x[0], x[1], x[2], x[3]);
	IS_EQU (add, *cAdd)

	add = nfxnis_hostAddr ("172.16.5.4", "tstsys");

	fputs ("Asking for tstsys exported via 172.16.5.4\n", stdout);
	fputs ("Should get: 172.16.3.1\n", stdout);
	fprintf (stdout, "Got: %d.%d.%d.%d\n\n", x[0], x[1], x[2], x[3]);
	IS_EQU (add, *badd)

	fputs ("\nPress the Enter key to continue\n", stdout);
	fgets (inp, sizeof(inp), stdin);

	fputs ("Now we're going to test the libraries ability to detect\n", stdout);
	fputs ("a change in the file. Edit the file and remove the\n", stdout);
	fputs ("line:\n192.168.1 cnet 192.168.1.127\n", stdout);

	fputs ("\nPress the Enter key to continue\n", stdout);
	fgets (inp, sizeof(inp), stdin);

	add = nfxnis_hostAddr ("192.168.1.234", "tstsys");

	fputs ("Asking for tstsys exported via 192.168.1.234\n", stdout);
	fputs ("Should get: 0.0.0.0\n", stdout);
	fprintf (stdout, "Got: %d.%d.%d.%d\n\n", x[0], x[1], x[2], x[3]);
	IS_EQU (add, 0)

	fputs ("Now we'll append that line onto the file\nDo:\n", stdout);
	fprintf (stdout, "echo \"%s\" >> %s\n", "192.168.1 cnet 192.168.1.127",
	        NFXNISCFG);

	fputs ("\nPress the Enter key to continue\n", stdout);
	fgets (inp, sizeof(inp), stdin);

	add = nfxnis_hostAddr ("192.168.1.234", "tstsys");

	fputs ("Again asking for tstsys exported via 192.168.1.234\n", stdout);
	fputs ("Should get: 192.168.1.34\n", stdout);
	fprintf (stdout, "Got: %d.%d.%d.%d\n\n", x[0], x[1], x[2], x[3]);
	IS_EQU (add, *cAdd)

	printf ("Tests PASS\n");
	exit (0);
}
