/*
 *-----------------------------------------------------------------
 *
 * Name:	prom_upgrade_api.h
 *
 * RCS:  $Id: prom-upgrade-api.h,v 1.2 2002/08/22 06:05:49 johnh Exp $
 *
 * Copyright (C) 2002, Agile Storage, Inc.
 *
 * Description:
 *
 * Created by:	
 *
 * Date Created:	
 *
 *-----------------------------------------------------------------
 */


#if !defined(__PROM_UPGRADE_API_H)
#define __PROM_UPGRADE_API_H


typedef enum {
	promUpgradeStart = PROM_UPGRADE_MSG_BASE,
	promUpgradeStartAck,
	promUpgradeData,
	promUpgradeDataAck,
	promUpgradeChecksum,
	promUpgradeChecksumSuccess,
	promUpgradeChecksumFail,
	promUpgradePerformWrite,
	promUpgradeWriteSuccess,
	promUpgradeWriteFailure,
} promUpgradeMsg_t;

typedef struct promUpgradeHdr
{
	uint32 msgType;
} promUpgradeHdr_t;

#define PROM_UPGRADE_MAX_DATA_SIZE  \
        (1500 - sizeof(promUpgradeHdr_t) - sizeof(agile_hdr_t))

/* min pkt size is min enet 60 minus mac hdr */
#define MIN_PKT_SIZE                (60 - 14) 
#define PROM_UPGRADE_MIN_DATA_SIZE  \
        (MIN_PKT_SIZE - sizeof(promUpgradeHdr_t) - sizeof(agile_hdr_t))


typedef struct promUpgradeDataMsg
{
	promUpgradeHdr_t hdr;
	char data[PROM_UPGRADE_MAX_DATA_SIZE];
} promUpgradeDataMsg_t;

#define PROM_UPGRADE_SIGNATURE  ('p'<<24 | 'R'<<16 | 'u'<<8 | 'G')
#define PROM_UPGRADE_MSG_VERIF(_sum, _len)    \
    ((_sum) ^ (_len) ^ PROM_UPGRADE_SIGNATURE)

typedef struct promUpgradeChecksumMsg
{
	promUpgradeHdr_t hdr;
	uchar8 cksum;
	uint32 total_len;
    uint32 msg_verif;
} promUpgradeChecksumMsg_t;


#endif
