OUTPUT_ARCH(mips)
ENTRY(_start)
SECTIONS
{
	. = 0xffffffff83000000;
	.text :
		{
			_ftext = . ;
			*(.init)
			*(.text)
			*(.rodata)
			*(.fini)
			etext  =  .;
		}
	.data :
		{
			_fdata = . ;
			*(.data)
		   _gp = ALIGN(16) + 0x8000;
			*(.sdata)
			CONSTRUCTORS
			_edata  =  .;
		}

  .ctors          :
  {
    /* gcc uses crtbegin.o to find the start of
       the constructors, so we make sure it is
       first.  Because this is a wildcard, it
       doesn't matter if the user does not
       actually link against crtbegin.o; the
       linker won't look for a file to match a
       wildcard.  The wildcard also means that it
       doesn't matter which directory crtbegin.o
       is in.  */
    KEEP (*crtbegin.o(.ctors))
    /* We don't want to include the .ctor section from
       from the crtend.o file until after the sorted ctors.
       The .ctor section from the crtend file contains the
       end of ctors marker and it must be last */
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  }
  .dtors          :
  {
    KEEP (*crtbegin.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend.o ) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  }

	.sbss :
		 {
			_fbss = .;
			*(.sbss)
			*(.scommon)
		}
	.bss :
		{
			*(.bss)
			*(COMMON)
/*
 * Allocate physical space for the cpu private data.
 * The 0x10000 should = SMP_CLIENTPRIVATE_TLB_SIZE in smp-api.h
 * The 4 should be >= SMP_NUM_CPUS in smp-api.h
 * For the TLB init to work, the space must be nicely aligned.
 */
			. = ALIGN(0x10000);
			smp_ClientPrivatePhysSpace = .;
			. = . + (0x10000 * 4);
/*
 * Allocate space for SMP stacks.
 * The 0x3000 should = STKSIZE in Includes/nfx-target.h
 * The 4 should be >= SMP_NUM_CPUS in smp-api.h
 */
			smp_stack = .;
			. = . + (0x3000 * 4);
			_end = .;
			end = .;
		}
	. = 0x60000000;
	.private (NOLOAD) :
		{
			_private_start = . ;
			*(cpu_private)
			_private_end = .;
		}
}
